v1.13.1.0
IMPROVEMENTS / FIXES
- General:
	- Missile magazine missile mass is no longer affected by hull material part mass modifiers.
	- Fix HP values of parts using ModulePartVariants; they should be a bit more sensible now.
- UI:
	- Don't drag the targeting window when slewing with the mouse.
  - Fix 'Selected Weapon: xxx' message spam when under AI control.
	- Add a 'Log Marker' button to the debugging section to help with syncing videos and logs.
	- Move the debris removal sliders to the General Sliders section. Add a "Clear Debris Now" button and a toggle to always clear the debris vs only during competitions.
	- Add hack to TGP camera to work around https://github.com/LGhassen/Scatterer/issues/229 with Scatterer on OpenGL.
- AI / WM:
	- Fix AI considering radar missiles not painting them with a radar as incoming.
	- Fix AI selecting bombs over missiles when missiles have priority.
	- Surface AIs using 'Maintain Min Distance' now require LoS/detection to target to maintain dist; fights with target behind a building/terrain no longer prevent AI from maneuvering.
	- Stale Target parameter for object permanence tracking of targets that have dipped out of sight now tracked per vessel.
	- Fix staleTarget timeout not timing out.
	- Target selection now properly takes LoS into account; no more AI fixation on a target behind cover when there's another target out in the open it can shoot.
	- Improved roll and extending behaviour for bombing (post-drop wing-slapping should no longer occur).
	- Fix high-frequency fly-to direction oscillation due to squiggly squid direction incorrectly switching every frame.
- Sensors:
	- Split `HMDCost` into `HMDCost` which represents a fixed per-cockpit cost of the system, and `HMDCostPerSeat` which represents a per-seat cost of the system. Defaults to 1500 and 500 respectively.
	- Replaced ventral RCS editor view with polar plot showing RCS values by craft azimuth when “Real-Time Aspected RCS” is enabled.
- Weapons:
	- Account for Krakensbane frame velocity in GPS and targeting camera targets.
	- Fix rocket RoF not matching selected value.
  - Bullets:
		- Fix bulletDmgMult not applying to shaped charge kinetic damage.
	- Missiles:
		- Improved missile "maxOffBoresight" limiting. Missiles will now try to turn as hard as they can in the commanded direction while keeping the target inside "maxOffBoresight".
		- Added new "terminalMaxOffBoresight" field to "MissileLauncher" missiles. When a missile has a "terminalGuidanceType", "terminalMaxOffBoresight" replaces "maxOffBoresight" (if specified) when targeting gets handed over to "terminalGuidanceType".
		- Fixed "CLOS"'s commanded acceleration being incorrect.
		- Fixed "maxTorque = 0" + "maxAeroTorque = 0" missiles bugging out and potentially causing crashes.
    - Expand "LoftAltitudeAdvMax" slider limits to 10,000 m.
   - Custom Turrets:
		- Custom Turrets can now be set to add an amount of aim-assist to fixed guns or turrets with < 2deg traverse that are mounted on them, to help with stock robotics granularity.
		- Adds new BDA settings field - CUSTOM_TURRET_AIM_ASSIST - to set degrees of aim assist to apply.
	- Ammo:
		- Implements resizable ammo container module that scales with shell size and selected max quantity.
- RWP:
	- Fix control surface actuator speed hack.

v1.13.0.0
IMPROVEMENTS / FIXES
- General:
	- Fix GetBodyByName("Kerbin") issues for mods that replace Kerbin.
	- Fix HP and cost scaling of parts when TweakScale is installed.
	- Fix SimpleRepaint messing with part HP.
	- Fix Battle Damage 'Proc Min Penetration'; now properly functions as a minimum threshold for BD to occur.
	- Added additional conditions for BD to occur, should stop seeing gimbals jam, etc, from scratch-the-paint chip damage.
	- Modded EVA kerbals with WMs no longer get their vessel type changed.
	- Fix setting world velocity not accounting for Krakensbane properly in some cases.
	- Fix thermal conduction values using the wrong config values during armor setup. Thermal properties of unmodified parts are now their default values.
	- Can now apply self-sealing tanks to cockpits with liquid fuel tankage.
- UI:
	- Updated German localisation from EzBro.
	- Updated Japanese localisation from Taka005.
	- Fix infolink explanation of Extend Abort Time / Extend Min Gain Rate.
	- BDA UI Icon draw distance (MAX_DISTANCE_THRESHOLD) no longer clamped to a max of MAX_GUARD_VISUAL_RANGE.
	- Add an option (and MM patch) to allow specifying the Kerbal Suit kerbals spawn with in crewed parts. Adds an override in the vessel spawner window for BDA spawns.
	- New 'localizedName' field for armor material configs.
	- Fix Craft Utilities Tool GUI mis-reporting craft Lift-To-Weight on craft load in some cases.
	- Add a toggle in the gameplay settings section for toggling the option for weapons respecting crossfeed.
	- Add a debug toggle specifically for part HP.
	- Team Icons Color Picker now includes 16+ color swatch for quick color selection.
		- Right clicking a swatch changes the swatch color to the currently selected color (if it's unique).
		- Clicking the '+' adds the currently selected color as a new swatch (if it's unique).
		- Ctrl-right clicking a swatch removes the swatch.
		- If fewer than 16 preset swatches are in the settings.cfg, then they are padded up to 16 with default values.
- AI / WM:
	- Fix Guard Mode using incorrect heat signature value for IR missile selection.
	- Add "Attack Uncontrolled Tgt." Weight to the Weapon Manager, setting this to negative makes the AI prioritize targets under control, thus avoiding wasting ammo on vehicles with knocked out crews. NOTE: Be cautious when using this on aircraft, this includes g-loc'd pilots!
	- Fix AI not accurately locking targets via the targeting pod while moving at speed.
	- Fix various NREs in GuardMissileRoutine that would potentially lock out a vessel from firing missiles.
	- Add an option to set a minimum mass for avoidance logic in the pilot and VTOL AIs (was already an option in the surface AI).
	- Pilot AI will now ignore other vessels already within its radius for avoidance purposes (to help with lodged debris and detaching parasite fighters).
	- Pilot AI now ignores "Hard Min Altitude" when ramming.
	- Add a gameplay option (enabled by default) to allow pilot AIs to retreat a few extra km from a threat if they're orbiting and come under fire.
	- Prevent pilot AIs from chasing targets when they have no weapons and aren't allowed to ram them.
	- Fix AI weapon selection softlocking on AntiRad ordnance when no hostile radar sources present.
	- Fix AI not respecting Max Missiles Per Target setting when dropping bombs.
	- Fix Surface AI circling last waypoint when it finishes a WP race.
	- Fix AI usage of radar-warning receiver not always being consistent, sometimes not "noticing" a radar missile fired at it.
	- Re-worked logic and implementation for Kinematic Missile Evasion, AI will do a much better job of avoiding missiles kinematically.
	- Improve AI missile notching. AI will now accurately notch / beam missiles while diving, as well as when flying level.
	- Added "Msl Emergency Notch Vel" to the Pilot AI. If the AI is chaffing, and has a range-rate greater than "Msl Emergency Notch Vel", the AI will immediately stop whatever maneuver it's trying to perform and instead try to "notch" (more accurately, "beam") the missile / radar as soon as possible. Setting this to 0 will disable the feature, and it is by default set to 0. (NOTE: It is highly recommended users press the (i) button at the top of the AI menu and read the infolink for more information on any AI setting).
	- Improve AI missile turret usage behavior, now instead of timing out after half of "Firing Interval" elapses, the turret must make no progress towards the target for half of "Firing Interval" to time out.
	- Point Defense AI:
		- Fix PD usage of laser-guided, anti-radiation, and heat-seeking missiles.
		- AI will no longer target interceptor missiles with interceptor missiles, preventing interceptor conga lines from forming.
		- Add support for acoustic torpedoes.
		- Uncommented point defense missile debug statements (now accessible via Debug Missiles + Debug AI) since they weren't really providing much of a performance saving, and they give better insight into what's happening when issues arise.
	- Add a "Retreat Distance" slider to the AI to allow customising the distance to retreat by when an orbiting vessel comes under attack.
	- Overhaul the pilot AI's aiming and extending logic for level- and dive-bombing against both landed and airborne targets.
		- Move bombing-related options into their own section of the PAW and AI GUI. This includes bombing altitude, divebombing angle, extending for bombing (which gets adjusted by the estimated time-to-impact) and PIDs for finetuning the bomb release point (default values should work for most craft).
		- Fix the bomb aimer not working when the bomb's rigidbody and parent part's rigidbody are both null.
	- Adjust the climb-slope limiter to allow maintaining a decent slope at high speeds (relative to min speed) even if the TWR drops to almost 0. This is particularly relevant for prop engines.
- Armor:
	- Limit Adjustable Armor thickness to the minimum of length / width of the armor plate to prevent unphysical armor calculations.
	- Armor cost, some stats tweaked to be more reasonable.
	- Adds Reinforced Concrete and Silicon Carbide armor materials.
- Sensors:
  - Improvements to target camera target switching behavior, should no longer switch to a new target while current laser ordnance is still in the air.
  - Multiple target cam support, craft with multiple cams can now simultaneously engage multiple targets with laser ordnance, one per camera.
	  - Under manual control the active camera can be cycled via the new < #n > buttons below the FOV controls.
  - Target Cameras now respect subsystem targeting options and will paint specific part(s) of a target craft if non-CoM targeting enabled.
  - Fix Laser missile LoS checks using vessel root instead of missile position for determining terrain occlusion of target.
  - Radars will now set any newly locked targets as the current primary target (affecting their multi-lock FoV).
  - Improved radar debug statements.
- Weapons:
	- Turrets:
		- Added "baseTransformName" field to turrets, while this was previously unclear, the parent transform of yawTransform was previously being used to determine the turret's center of rotation and the orientation of its axes. This has now been made into an explicit field to allow modders to better control this behavior. Unless specified, the transform will be set to the parent of the yawTransform.
		- Made turret code more failure tolerant, and capable of dealing with cases where yawTransform and/or pitchTransform are missing. IMPORTANT NOTE: A turret lacking a yawTransform and/or pitchTransform will NOT function properly, it will try to work around it, but the modder should fix this issue ASAP!
		- Added support for multiple turrets on a single axis. This allows for things like coaxial guns, and missile launchers mounted on turrets to function correctly.
			- Any number of turrets can now use the same "yawTransform" or "pitchTransform".
			- The currently selected weapon will always take priority over all other turrets using that axis.
			- New "turretPriority" field that determines which turret is prioritized over others when none of the weapons using that axis are currently selected. HIGHER values are prioritized.
			- For turrets with the same "turretPriority" value, the turret with the LOWEST "turretID" is prioritized (to allow support for older mods which were created prior to this feature being added).
	- Active Protection Systems:
		- Target shells now need to be within a certain size/APS needs to pass penetration depth check to destroy larger shells; no more destroying battleship shells with standard anti-tankshell APS.
		- APS debugging moved to new Debug PointDefense toggle.
	- Explosions:
		- Re-implemented the shaped charge unfocusing/squeezing mechanic, where as the shaped charge jet penetrates armor, it loses coherence and diameter.
		- Add spall to shaped charge damage calculations, shaped charge now carries along a % of the spall it produces as it penetrates causing additional damage.
			- Spaced armor and materials with high ductility can be used as spall liners, which will reduce some of this spall, up to a configurable percentage. This is set by default to 50% in the settings.cfg file, using the "HEAT_SPALL_MAX_RED" setting, higher means more spall can be reduced with spall liners.
			- Add "HEAT Spall Dmg. Multiplier" setting that affects shaped charge kinetic damage.
		- Fix shaped charges applying kinetic damage without actually penetrating the part they hit.
		- Apply missing explosion source multiplier for shaped charge kinetic damage and shrapnel.
		- Rename incorrectly named "Implosive Damage Multiplier" setting to "Exp. Impulse Multiplier". This setting modifies the force with which explosions push vessels (the ones that aren't blown up at least...).
		- Fix explosion blast damage calculations, damage is now more strictly based on the explosion's blast wave and is more consistent. This means explosions will damage armor plates more significantly once they blast through them, while larger plates will see more reasonable amounts of damage relative to the size of the blast.
	- Bullets:
		- Fixed bullets which ricochet not activating their penetrating / delayed fuzes.
	- Rockets:
		- Fixed rockets sometimes not applying kinetic damage when they penetrate armor.
	- Warheads:
		- Add "bulletDmgMult" field to BDCustomWarhead modules, allowing their damage to be tuned.
		- Nuclear warheads now have Arm/Detonate Action Groups.
	- Bombs:
		- Add Symmetrical Firing option to bombs to enable simultaneously dropping a symmetry twin bomb at the same time the selected bomb is dropped.
	- Lasers:
		- Lasers now do less damage over distance based on atmospheric and water attenuation. Compared to before, lasers do more damage at closer range and in vacuum or high altitudes, but less damage at distance.
		- Added LASER_ATM_GAMMA and LASER_WATER_GAMMA in the settings.cfg laser attenuation in atmosphere and water.
		- New, more realistic damage drop off over distance for lasers and microwave weapons (conicAoE=true) due to laser/beam spreading. See ABL.cfg for details.
		- Add aperture configuration value to laser configuration options. See ABL.cfg for details.
		- Apply distance and atmospheric attenuation to electro-lasers, heat rays, and HE pulse lasers.
	- Missiles:
		- Fix graphical glitch where Helmet Mounted Display/Sight appearing in WM modules despite there not being a cockpit with a HMD.
		- Fix NREs that would occur when a CLOS missile has its guiding targeting pod destroyed.
		- Added CLOS missile control deadzones via "beamgDeadzone", the missile will ignore acceleration commands below this value (to simulate things like beam-width and manual missile control).
		- Fix pronav and augpronav missiles not properly guiding on targets when launched from extreme off-boresight angles.
		- Added arming delay to missiles with the "fuzeArmingDelay" field specifying the arming delay in seconds and the "impactFuzeArmingDelay" bool field specifying if the impact fuze should also have an arming delay.
		- Added spinning missiles, missiles can now be given a spin using "spinRate", specifying the spin rate in revolutions per second (clockwise-positive when looking from behind the missile) and "spinAccel", a proportional control constant for missile's spin rate, higher values will mean the missile spins up faster. Note this "spinAccel" should be a relatively small value, by default it is 0.25.
		- Fix INS and GPS missiles fired from multi-missile launchers being fired towards (0, 0, 0) when dumbfired. They will now be fired at a point 2 times the minimum engagement range or 10 km in front of them, whichever is greater.
		- Fix IR missiles not turning towards a target they lost track of.
		- ARH missiles will now use "radarLOAL" behavior when a target flies outside of their boresight instead of declaring a miss.
		- Fix Laser missile target velocity estimation calculation.
		- Fix "CruisePopup" setting for cruise missiles with this feature not being persistent.
		- Fix terminal targeting checks reducing track accuracy for missiles with a terminal targeting mode.
		- Fix debug readouts for radar missiles, now when lacking a target they should properly display "No target!", seeker timeout time will also now display correctly.
		- Fix active sonar torpedoes diving to the seafloor if they lose lock immediately on launch.
		- Fix SARH missiles not respecting IFF and target envelope settings when relocking after having lost the primary target when "canRelock" is true.
		- Fix laser AGM missiles never timing out during search mode. Now, when a laser missile searches for a TGP, it'll time out after "seekerTimeout" seconds. If a missile loses guidance from its guiding TGP, it'll first search for it for "seekerTimeout" seconds before initiating a search for other TGPs.
		- Added "proximityFuzeInhibitionAlt" to MissileLauncher missiles. When they are below this radar altitude, missiles will not proximity fuze on targets. By default, this is set to -1, which disables the feature.
		- Fixes + Improvement for Kappa Guidance:
			- Slightly improve time-to-go clamping in kappa guidance.
			- Add "gLimit" and "maxAoA" based biasing of the kappa shaping coefficient.
			- Calculate proper shaping coefficient for "kappaAngle" = 0 case (no trajectory shaping).
			- Fix numerical issues at long range and at very short range.
			- Improve the efficiency of the level-off maneuver at the top of climb, increasing the missile's range and terminal velocity.
			- Added more granularity to "maneuvergLimit", now 3 values can be specified, the second value is used to estimate the g-load of the dive maneuver while the third value is used to shape the trajectory for the level-off maneuver at the top of climb (note that a quarter of this value is used, as it is intended to work with the default value of 20 g).
			- Added more data to telemetry with kappa guidance.
		- Added "beamWidth" to all CLOS guidance types and "beamLeadMinAlt" to CLOSLead.
			- "beamWidth" allows for the simulation of the increasing inaccuracy of beam-riding missiles with range, due to angular resolution. If the beam is taken as a cone, it is essentially the ratio of the radius of the cone to the height of the cone, I.E. for every meter of distance the missile travels, the potential error, relative to the beam centerline increases by "beamWidth" meters.
			- "beamLeadMinAlt" is essentially an implementation of the "elevated by k" method of the Soviet half-correction missile guidance method. If the relative altitude of the target vs. the guidance sensor is less than "beamLeadMinAlt", then the missile will not add downwards lead when the target is diving, making the missile less likely to be driven into the ground.
		- Added "antiradTargetPrediction" to anti-radiation missiles. When set to true, the missile will use the average velocity of the target between pings to predict the target's future position.
		- Multi-Missile Launchers:
			- Fix bugs due to "missileTransform" being incorrectly set to one of the dummy transform's "missileTransform", which, when discarded / replaced upon load, will result in a completely incorrect aim point. MMLs will now use their first launch transform as their aiming transform.
			- Fix weight of missiles in magazines being incorrectly added to launcher mass.
			- Fix unguided weapons suddenly becoming guided after being launched from a MML.
			- Fix reloadable rails not accounting for missile thickness when spawning ordnance.
			- Add in various missing fields when spawning ordnance on reloadable rails.
		- Custom Turrets:
			- Add Lofted Aimpoint and Loft Vel. Fac. settings to missiles on custom turrets, giving them function parity with regular missile turrets.
			- Fix custom turrets with no radar failing the launch authorization check.
			- Fix custom turrets incorporating guns with turrets (M102 howitzer, etc.) not targeting aircraft.
			- Custom turrets now compatible with turret multi-targeting.
			- Can now use custom turrets for anti-missile point defense.
		- Improved debug telemetry output format.
		- Added "Engagement Summary" to debug log when "Debug Missiles" is turned on. This will provide a one line summary about a missile's engagement, including total elapsed time, closing velocity, final distance, etc.
		- Switch detonation distance override sliders to use a semi-log range to allow larger distances.
- Competition:
	- Fix Waypoint mode immediately moving to next heat on start when running a surface AI WP race with multiple racers when Activate Guard After Gate is disabled.
	- Groundspawn Waypoint Races will now spawn racers in a grid start arrangement instead of circle spawn.
	- Add hidden settings for the max slider values of various tournament options.
	- Fix sorting issue in parse_pvp_scores.py when generating a csv file.
- Mod Support:
	- Hack support for JonnyOThan's TweakScale Rescaled fork, for now we assume all parts have cubic mass scaling, which is incorrect, but will temporarily patch support for the mod, pending official support.

v1.12.1.0
IMPROVEMENTS / FIXES
- Part Changes:
	- AIM-9 Sidewinder now has "uncagedLock = true" to reflect changes in "uncagedlock" behavior.
	- Improve documentation of features in AIM-9 config.
	- KKV now uses a BDCustomWarhead for its kinetic warhead.
- AI / WM:
	- Guard Mode now uses more "realistic" RWR/MWS and visual detection checks against missiles and vessels by taking advantage of overhauled RWR system.
		- Fixed inconsistent detection ranges vs. missiles, now missiles will be detected within specified MWS range if omni RWR/MWS or if pinged by ARH missile.
		- Specifically allow AI to detect incoming SARH missiles (mostly for gameplay reasons).
		- AI will not know what kind of missile is approaching if it's passive (IR, GPS/INS, anti-radiation) unless it is within MWS or visual ID range (1/3 of visual range).
			- When not ID'd, flying or orbital vehicles will assume the incoming missile is an IR missile, ground vehicles will assume it is an anti-radiation missile.
	- Add support for anti-radiation interceptor missiles in the point-defense code.
	- Fix bugs with toggling Guard Mode, turrets should now properly be disabled, and radars and RWR should now correctly automatically enable when toggling via the vessel selector.
- Sensors:
	- Totally rework RWR system. New fields "RWRMWSRange" (range of MWS system in m) and "RWRMWSUpdateRate" (player UI update interval in s for MWS system) added.
	- Fix targeting pod NRE when not targeting vessels.
	- Fix radar part info menu not displaying correct FoV limits.
	- Add radarChaffNotchClutterFactor field, with up to two values for notch velocity and notch range chaff factors.
		- When radar notching is enabled, chaff gets additional bonuses from a target beaming (moving at 90° to the radar) or notching (beaming at low altitudes).
		- The first value in radarChaffNotchClutterFactor determines the additional chaff effectiveness when the target is moving at 90° to the target, independent of the other modifiers.
		- The second value in radarChaffNotchClutterFactor determines the additional chaff effectiveness when the target is actively notching, independent of the other modifiers.
		- E.g., if radarChaffClutterFactor, and both radarChaffNotchClutterFactor values are set to 1.0, the target's position is offset by chaff by up to 3 times the original offset.
- Weapons:
	- Fixed NRE for turrets without a pitchTransform. While not recommended, nor formally supported, such turrets should no longer spam NREs.
	- Explosions:
		- Re-worked explosion physics, now explosions perform armor penetration and HP based attenuation checks at the true location of each of the parts.
		- Fixed instances where the armor calcs could return infinite armor.
		- "Improved" shaped-charge model that somewhat better matches real results.
		- Enable shrapnel damage to non-armored parts.
		- Add debug messages with Debug Armor on regarding projectile destruction when non-sabot projectiles ricochet off of thick sloped armor, causing explosive bullets to not detonate.
	- Missiles:
		- Added consistency/"anti-cheat" checks for missile explosive mass, ensuring missiles don't need to be replaced after a mod update.
		- Added Helmet Mounted Display/Sight for IR missiles. Can be added to any cockpit, when enabled allows targeting of "uncagedLock = true" missiles via mouse.
		- Re-worked "uncagedLock" functionality.
			- Missiles with "uncagedLock = false" have fixed seeker-cones prior to finding a target.
				- Turrets and pilot AI with "uncagedLock = false" will aim towards the target rather than lead the target.
			- Missiles with "uncagedLock = true" can be slaved to a radar lock, an HMD/HMS target, or an IRST lock (in that order of priority).
		- Added altitude-based fuzes for missiles.
			- "altitudeFuzeMode" can be set to -2, -1, 0, 1 or 2. -2/2 are descending/ascending detonation checks with a MSL altimeter, -1/1 are descending/ascending detonation checks with a radar altimeter.
			- "altitudeDetonationAlt" is the altitude to detonate the fuze at in m.
		- Inertial guidance missiles will no longer be able to be guided via non-ranging IRST.
		- New "adjustableProxyFuze" bool, allows for fixed detonation distance.
		- Fuze details now listed in the part info menu.
		- Add "torqueLimiter" bool and "torqueMargin" fields to missiles.
			- Setting "torqueLimiter" to false disables the torque-based AoA limiter (The BDA+ dev team does not take responsibility for any wobbliness caused by this!)
			- "torqueMargin" is a value between 0 and 1 that represents the torque withheld to deal with the missile overshooting the requested AoA. Defaults to 0.1, reducing this value may increase missile performance but also could lead to wobbles.
		- Added "chaffNotchEffectivity" field, which acts the same as the "radarChaffNotchClutterFactor" field detailed in Sensors, but for the missile's onboard sensor.
		- SARH missiles now use the product of "chaffEffectivity" and their parent radar's "radarChaffClutterFactor" (as well as "chaffNotchEffectivity" and "radarChaffNotchClutterFactor") to determine chaff behavior.
- Armor:
	- Fixed edge case where B9 Procedural Wings are given fixed hitpoints or are used for armor plates, which would previously cause "armorVolume" to be zero.

v1.12.0.0
IMPROVEMENTS / FIXES
- UI:
	- Adjust the "Steel Equivalent Thickness" display in the armor GUI to show a more intuitive value.
- AI / WM:
	- Fix broken ActiveController registry clean-up.
	- Add an action group trigger to the WM for when the vessel comes under attack.
	- Fixed some bugs in point-defense logic which could lead to the game freezing.
	- Further improved point-defense logic, should behave slightly better against mixed barrages of missiles, some of which it cannot engage with missiles (like stealthy missiles).
	- AI can no longer see incoming missiles through water.
	- AI will fire missiles that can (probably) clear any terrain in front of them without LoS to the target.
	- Slightly better AI radar management behavior (pending a bigger overhaul), AI will no longer try to lock targets if it'll unlock the radar's current radar target (due to it being outside of multiLockFOV) if it's being used for guidance.
	- Improved AI weapon selection, AI should be a tiny bit smarter about what weapon it picks, as well as not dumping all anti-radiation missiles at once.
	- Fix surface AI reversing behavior, surface AI should now reverse more smoothly.
	- Fix DEBUG_LINES causing NREs for vessels attacking targets beyond visual range which have not previously seen a target within visual range.
- Sensors:
	- Radar and RWR code optimizations.
	- Fix smooth slewing of the targeting camera when clicking on the GUI buttons when a target is locked.
	- Targeting Camera terrain collision detection no longer starts 50m forward of the lens.
	- Targeting Camera will no longer lock on to its parent vessel or missiles fired by its parent vessel.
	- Prevent errors in radar code from potentially causing game freezes.
	- Radar 'auto-disable vs incoming Antirad missiles' default has been changed to Off. This can be toggled per-radar or turned on for the entire vessel from the Weapon Manager.
- Weapons:
	- Add conical beam weapon implementation for creating microwave drone zappers, War of the Worlds heatrays, tractor beams, etc.
		- Adds new weapon.cfg fields: 'conicAoE' = T/F to enable conic field of fire for Laser class weapons.
			'beamFOV' = n to set width of beam.
			'friendlyFire' = T/F to set of conic weapons affect ally craft in AoE, if firing into a melee.
	- Rework EMP weapons. Craft EMP threshold before getting disabled is now dependent on cockpit seat quantity/drone core SAS level.
		- EMP damage received now adjusted by craft armor/hull type and craft bulk. Electrolaser/lightning weapons resisted by non-conductive armor and hull material (e.g. not metal).
		- EMP missile/Nuke EMP burst/conicAoE EMP lasers resisted by craft bulk and conductive armor occluding cockpits from emission source.
		- EMP buildup now causes increasing penalties/subsystem shutdowns as it accrues in a vessel receiving EMP damage.
	- Fix hypersonic rounds dealing self damage when fired into something at close range.
	- Fix explosion damage affecting armored parts which should be able to resist them.
	- Fix incorrect application of certain shaped charge logic to continuous rod warheads.
	- External fires from incendiary ammo into flammable hull materials no longer suppressed by Inerted Tanks.
	- Added a AIMING_VISUAL_MALUS setting (default=0) that applies a malus to aiming at targets with mk1 eyeballs if >0 and the target is within visual range. The malus decreases both with time since target acquisition and shots fired at the target, and resets when changing targets.
		Weapons configs can be configured with:
		- 'sightingAccuracy' (default=1 mrad) which represents the limit of visual aiming accounting for scopes and other visual aids.
		- 'malusReductionPerShot' (default 0.1) which determines how rapidly the malus decreases with each shot at the target.
	- Missiles:
		- Add ordnance offset option to non-adjustableRail reloadable MultiMissileLaunchers that don't come with set missile types.
		- Fix Nuclear ordnance applying multiple stacks of EMP damage to a single vessel during detonation.
		- Improve "CLOSlead" debug visualization, now shows the proper, lead-adjusted beam, for easier debugging.
		- Add new "adjustMissileVOffset = T/F field for MultimissileLauncher.cfgs to set if missiles should automatically adjust mount position based on missile diameter (missile rails, etc) or not (VLS cells).
		- Fixed missile ECM behavior, previously changes to the missile's radar signature due to ECM could be overwritten by the missile going active/passive, causing ECM to seemingly not function.
		- Missiles with a "cruiseRangeTrigger" will now also fire the cruise motor if the missile's airspeed drops below 75% of its optimum airspeed while in-atmosphere.
		- AAMLoft settings for modular missiles are now correctly loaded when returning to the SPH.
		- Fix "guidanceDelay" not working properly.
		- Improve Kappa guidance loft termination, as a result Kappa no longer uses LoftRangeFac and LoftVertVelComp.
		- Fix CLOS/CLOSthree/CLOSlead guidance failure due to inaccurate determination of "no progress" condition.
		- "CruisePopup" setting now persistent and editable in the hangar when missile config has "CruisePopup = true".
		- Missiles will now respect config value of "DetonateAtMinimumDistance" setting, if a missile config does not have this set to true, it cannot be edited/used.
		- Un-deprecate "proxyDetonate" field, missiles with "proxyDetonate = false" in their configs will be *strictly* impact fuzed.
		- Fix certain scaling issues with multi-missile launchers.
		- Fix missile turret aiming under Guard Mode control, particularly, turrets with IR, laser and anti-radiation missiles will now pre-aim at the target to facilitate acquisition.
	- Robotics:
		- !!Experimental!! Adds ability to build custom turrets with Breaking Ground Hinges and Servos.
			- BG hinges/servos now have a 'Custom Turret ID' slider; attaching a weapon as a child of the robotic part adds a similar 'Custom Turret ID' slider to the gun.
			- Setting both to the same value will enable the gun to use BG robotics to slew/traverse the attached weapon (and any other parts attached to the robotics) as if it were a standard BDA turret.
			- Turret ID = 0 is an Off value, and will not link weapons to a servo.
			- Pressing F2 to bring up the Weapon Alignment in the SPH/VAB will draw a Pitch/yaw Blue/Green alignment line for all enabled servos.
			- All servos in a custom turret should have aligned forward and Up directions.
			- Attached weapons should be placed in the forward direction for optimal operation.
- Competition:
	- Allow warping to morning for waypoints tournaments.
	- Show the waypoint name (if it exists) in the VS status during waypoint competitions.

v1.11.1.0
IMPROVEMENTS / FIXES
- General:
	- Fix some compatibility issues with pre-KSP v1.12 versions.
- UI:
	- Make the AI GUI auto-resizing by default. Left clicking the resize handle switches to manual resizing, right clicking it switches to auto-resizing.
- AI / WM:
	- Improved point-defense logic to better account for IR missiles, AI should no longer get stuck trying to fire an IR missile when it can't attain a lock.
	- Add action group triggers for enabling/disabling guard mode on WMs instead of just toggling it.
	- Add 'Full 3-Axis PID' as an option in the pilot AI for using separate PID values for each axis (without dynamic damping).
- Sensors:
	- Fixed omnidirectional radars failing to detect targets west of them.
	- Fix IRST display issues for IRST parts with an irstTransform.
	- Fix issues with notch calculations.
	- Add "radarCanNotch" field to radars to allow for notch calculations to affect chaff effectiveness without affecting track/lock.
	- Fix bubble decoys being able to affect radars in rare cases.
	- Radar code optimizations.
	- Targeting camera radar slaving now affected by chaff.
- Weapons:
	- Adjust weapon selection logic to account for craft spawned from the SPH not having their Landed state set.
	- Missiles:
		- Add "activeRadarCanNotch" field to missiles as a counterpart to "radarCanNotch".
		- Missile RCS now correctly works until the end of the cruise stage even with cruiseRangeTrigger > 0.
		- Added 4th value to maxTorque to allow for specifying a "coast" maxTorque for use when the missile is coasting between the boost and cruise stages (due to cruiseDelay or cruiseRangeTrigger).
		- Allow for laser/targeting camera targeted CLOS missiles to use radar velocity data when radar slaved but not CoM locked.
		- Fix 0 values for advanced (multiple value) maxTorque, liftArea, dragArea, maxTorqueAero and steerMult usage not being respected.
		- Fix 0 values for terminalSeekerTimeout not being respected.
		- Fix missing Cruise Popup menu for MMLs.
- Competition:
	- Fixes to include any newly detached fighters during competition start-up.
	- Fix vessel name deconfliction for teams tournaments that use the "Re-use Craft To Fill Teams" option.
		- Note: If this option is being used and two craft with the same name are used in multiple teams then the scoring will be messed up.
	- If not storing Team Icon colours, reset the colours at the start of a tournament / continuous spawn.
- Scripts:
	- Fix default GLOBAL_LIFT_MULTIPLIER in BDArmoryMissileManeuverEnvelopePlotter.py.

v1.11.0.0
IMPROVEMENTS / FIXES
- General:
	- Fix the g-limit overrides from needing to save the persistent savegame, which was leaving spawned craft in play when reverting to the SPH.
	- Fix issues with armor damage when using "Armor Mass Multiplier" values other than 1.
- Part Changes:
	- Added stack attachment nodes to all turret bases.
	- Sanity-checked turret bulkhead sizes.
	- Increased FoV settings for FLIR ball and Targeting Pod to take advantage of new zoom readouts.
	- Missiles:
		- AMRAAMs given INS/ARH guidance and AAM/Pronav guidance to bring its capabilities in line with modern BDA+ features.
		- Sidewinder missile given Pronav guidance.
		- Hellfire missile slightly buffed and given Kappa guidance, giving it top-attack capabilities.
- UI:
	- Fix spelling of "ordnance" in localisation files (settings and modules retain the misspelling).
	- Add competition marquee messages for fuel/ammo detonations from battle damage.
	- Fix 'Disable Radar vs ARMs' WM GUI toggle being inverted.
	- Tweak vessel switching weights to try to remain focused on vessels that are about to explode.
	- Fix EMP disable messages on craft that have alraedy been disabled before claiming a negative float value time duration.
	- Fix Radar Display not displaying correctly on radars using radarTransform defined pointing directions.
	- Add an option in Team Icons to not store the team colours in the settings.cfg file.
- AI / WM:
	- Add missing unclamped limits for 3-axis static damping.
	- Adjust the release of the "Attack" command so that craft don't go dead-stick when under attack but not threatened enough to trigger evasion.
	- Fix AttackVIP targeting priority impacting target priority weighting if no enemy VIP is present.
	- When assigning turret targets, AI now checks if target is within max range of the turret.
	- Pilot AI using divebombing will now break off the dive when bombs have been released.
	- Add an option to disable the behaviour of disabling guard mode when vessels are spawned.
	- Fix pilot AI's standby mode to automatically trigger AG10 and enable engines if necessary when a threat is detected.
	- Fix behavior of Guard Mode with regards to datalinked radars, Guard Mode should no longer unlock targets when these locks are being used by a datalinked vessel to guide a missile.
	- Slightly improved Guard Mode radar lock management, locks are only dropped as needed on radars that can lock on to the target.
		- AI will automatically set radar to max range when toggled on, allowing it to make full use of the radars.
	- Tweaks to the auto-tuning loss function to give a more stable roll-relevance. Show an auto-tuning summary to reduce confusion in the SPH about the auto-tuning results.
	- Disable Battle Damage while auto-tuning to avoid wooden parts catching fire.
	- Fix AI continuing to increase extend distance while extending away from a target for lining up a bombing run.
	- Fix some errors in Dynamic Launch Zone math.
	- Improve VTOL AI's calculation of bank angle.
	- Overhaul of logic for which AI / WM is in control of a vessel and proper support for motherships / detachable fighters:
		- The "primary" WM is the WM closest (in hierarchical distance) to the root part of the vessel (an "Is Primary" label is added to the top of the WM's PAW to allow checking this).
		- Only a single AI is allowed to be active on a craft at any given time.  Activating one will deactivate the others.
		- Whenever a vessel detaches from or docks with another vessel or loses parts, the primary WM and AI automatically updates to reflect the new vessel configurations.
			- The primary AI is chosen as the first active AI sorted by hierarchical distance from the root part with the precedence: pilot, surface, VTOL, orbital.
				- E.g., if an active pilot AI is further from the root part than an active surface AI at the time that the vessels dock, the pilot AI will be chosen as the primary and the surface AI will get deactivated.
				- A stable sort is used, so ties are decided by order in the craft file.
			- If no AI are active prior to docking (or on spawn), then the primary AI is chosen as the AI closest to the root part regardless of type.
			- Vessel type is also updated to reflect the AI in control of the vessel:
				- Plane
				- Ship (spaceship, boat, submarine)
				- Rover (tank/buggy, amphibious)
				- Lander (stationary)
				- Base (WM with no AI)
		- If a competition is active, then:
			- Duplicately named vessels spawned via BDA's spawning routines get a "_1"-style suffix.
			- Duplicately named fighters (vessels that detach from a parent vessel that has a WM) get a "_F1"-style suffix.
			- Vessel name deconfliction respects custom VESSELNAMING tags, only applying suffixes as necessary for deconfliction.
			- Suffixes applied to spawned vessels are persistent throughout tournaments and continuous spawn, but suffixes applied to fighters are dependent on the order that they detach from the parent.
		- Detached fighters are automatically added to active competitions / tournaments on the same team as the parent vessel and behave independently from the parent vessel.
		- If the parent craft is free or commanded to attack a location, then the fighters get the same command, otherwise they are commanded to follow the parent.
		- Ranked tournaments use the combined score of a parent vessel and its fighters when determining the ranking.
		- Access patterns for the AI / WM are optimised to be even faster than the previously used VesselModuleRegistry.
		- Added a "Weapon Channel" mechanic to support separation of weapons on fighters from the mothership, active Weapon Managers can only control weapons with a lower or equal "Weapon Channel" value.
- Countermeasures:
	- Add 'Ammo' gauges for Countermeasure dispensers for how many CMs they have remaining.
- Sensors:
	- Add support for slaving turrets via targeting cameras.
	- Fix targeting camera issues with moving targets.
	- Targeting camera now displays actual zoom power.
	- Fix 'Slave Turret' button occasionally locking the turret to the vessel's origin point or non-target point in space.
	- Locking a target will no longer automatically slave active turrets to the target when manually controlling a craft. To slave turrets to a locked radar/camera, use the 'Slave Turret' button.
	- Fix bug that allowed radars to lock on below the radar horizon when the appropriate settings are toggled.
	- Fix datalinked radars not conveying lock information to all datalinked vessels.
	- Fix Conformal Decals and part variants affecting craft RCS analysis.
	- Fix radars not having an elevation limit. Radars can now be given a specified elevation limit via "elevationFOV".
		- Non-omnidirectional radars are assumed to be roll stabilized and will scan "directionalFieldOfView" horizontally and "elevationFOV" vertically. Radars will scan the ENTIRE pitch FoV with every sweep, vertical scan limits are affected by vessel pitch, however!
		- Omnidirectional radars scan about an up/down axis (this will at some point be corrected so that they scan about their own spin axis), limited by "elevationFOV".
		- Default behavior for non-omnidirectional radars is to assume a square scan zone (i.e., equal "directionalFieldOfView" and "elevationFOV" unless otherwise specified).
		- Default behavior for omnidirectional radars is to provide full spherical coverage, as they did previously.
	- Radars can now have asymmetric scan zones, both "directionalFieldOfView" and "elevationFOV" can be given two values to specify a lower/upper scan limit. (I.e., a radar with "directionalFieldOfView = -40, 20" will scan up to 40 degrees to the left and 20 to the right.)
		- Note this is a very WIP feature and visualizations may not be perfect!
		- For debugging, the "DEBUG DETECTORS" setting may be used, which will output the radar's lower/upper limits, FoV limit and offset (of the scan centerline) for both the azimuth and elevation axes.
	- Fix radar display not being pitch stabilized, position of targets should now remain static even when maneuvering in pitch.
	- RWR display should no longer drift.
- Weapons:
	- Remove maxEngagementRange (default 5000m) check from bombs when AI is selecting what weapon to use.
	- EMP weapons (both guns and missiles) now capable of disabling missiles.
	- Add a "Yaw Standby Angle" slider to gun turrets.
	- Multi-barreled guns now no longer swap to the next ammo type in the belt until after all barrels have fired.
	- Multi-barreled guns now fire tracers every tracerInterval rounds of each barrel, and will fire tracers simultaneously from all barrels.
	- Fix aim lead offset for weapons with deploy animations.
	- Fix display issue where "Advanced Ammo Config" button does not reflect the actual state of the weapon.
	- Weapons fire SFX maximum distance it can be heard now scales based on weapon caliber.
	- Added fuzeDelay and fuzeSensitivity functionality to bullets. Now, for penetrating and delay fuzes you can specify the fuze delay in seconds, and the fuze sensitivity in mm for penetrating fuzes, by listing them with commas, i.e., "fuzeType = Penetrating,0.01,20" for a 0.01 s delay which will be set off by 20 mm of armor (currently material differences are not considered).
	- Fix bullet behavior when hitting parts with multiple colliders embedded in each other, bullets should now only hit such a part once, unless it exits the part and then hits the part again. Note the system in place cannot catch cases where another part is clipped into such a part.
	- Fix checks for phantom water on planets without oceans.
	- Changed continuous rod warhead damage area from 60°-90° to 30°-60°.
	- Missiles:
		- General Changes:
			- Fix maddog ARH missile launches not turning on seeker.
			- Heat seeking missiles now more realistically use angular velocity rather than vector velocity for flare rejection.
				- Added a new FloatCurve "lockedSensorVelocityMagnitudeBias", weights target score based on the normalized angular velocity magnitude difference, where 1 is when the target's angular velocity magnitude matches the expected angular velocity magnitude and 0 is when the angular velocity magnitude is off by the expected angular velocity magnitude (either 0, or twice the expected). FloatCurve defaults to all 1s when lockedSensorVelocityBias is not specified and linear when specified.
				- Added lockedSensorMinAngularVelocity field which sets the minimum detectable angular velocity magnitude for angular velocity magnitude differencing.
			- Ensure laser-guided weapons have "TargetAcquired" properly set prior to firing.
			- Added cruise specific missile deployment animations.
		- Guidance:
			- Add improved missile controller.
				- Missiles will now better respect gLimit as well as guidance-commanded acceleration, note this means some parameters may need to be tweaked to retain previous performance, specifically pronavGain and weave guidance accelerations.
			- Improve AAMloft and Kappa's ability to hit targets with high closure rates close to the launch point, particularly for VLS and other 0/0 launch conditions.
			- Add WeaveUseAGMDescentRatio and WeaveRandomRange to weave guidance, when WeaveUseAGMDescentRatio is true it forces the use of agmDescentRatio to allow for sea-skimming weave missiles. WeaveRandomRange is a Vector3 (format is WeaveRandomRange = (x,y,z) ) that allows for randomization of weave horizontal/vertical g and frequency parameters.
			- Loft guidance parameters are now no longer persistent and inaccessible in the SPH for non-modular missiles. Modders may still tune these parameters in-flight by enabling the "Debug Missiles" option in the BDArmory Settings menu.
				- For modular missiles, parameters are persistent and editable in the SPH. Turning on "Debug Missiles" will also allow for in-flight adjustment of these parameters.
		- Modular Missiles:
			- Fix check for multi-mode engines being ignited and having fuel.
		- MissileLauncher/Standard Missiles:
			- Sanity checks for maxOffboresight and cruiseSpeed, maxOffboresight and max cruiseSpeed are loaded from the configuration file to ensure consistency with intended values.
			- Fix buggy behavior caused by partial failure of missile warheads to detonate when a custom warhead and a standard warhead were used in conjunction with non-zero fuze failure settings.
			- New "maxTorqueAero" field for missiles, provides a dynamic pressure (density times velocity squared) based component to maxTorque. This is intended to simulate aerodynamic control surfaces (as opposed to maxTorque, which now represents things like thrust-vectoring).
			- New "maneuvergLimit" field for missiles, provides the gLimit for the various maneuvers a missile might conduct (not general guidance maneuvers). Specifically, the pull-up phase of lofted guidance types, like AAMloft and kappa, and the pop-up maneuver of cruise missiles.
			- Several missile parameters can now be specified for different phases of flight with comma-separated values.
				- "liftArea"/"dragArea" has the format: [boost], [cruise], [deltaDeploy], [deltaCruiseDeploy], separated by commas. The [cruise] value is used when "decoupleBoosters" is true, representing the change in aerodynamics after dropping the booster stage. The deltas represent the change in area when deploy animations trigger. A boolean field "deployedLiftInCruise" (defaults to true) allows you to keep [deltaDeploy] after the booster separates.
				- "maxTorqueAero" follows the same format as above.
				- "maxTorque" has the format: [boost], [cruise], [post-thrust], allowing for simulation of thrust-vectoring missiles.
				- "steerMult" has the format: [boost], [cruise], allowing reduced "steerMult"s in cruise if desired.
			- Add the gLimit, maxAoA and chaff/flare effectivity fields to the info box.
			- Implement various command-to-line of sight guidance types, these all use the "beamCorrectionFactor" field and the "pronavGain" fields (with support for pronav gain scheduling).
				- "CLOS" performs basic command-to-line of sight guidance with no beam-velocity compensation.
				- "CLOSThree" performs command-to-line of sight guidance with beam-velocity compensation.
				- "CLOSLead" performs command-to-line of sight guidance with selectable lead (using the "beamLeadFactor" field, 1.0 representing full lead and 0.0 representing three point guidance. Defaults to 0.5 or half-rectification guidance.)
				- "beamCorrectionFactor" is multiplied with the lateral error from the specified line of sight to provide a lateral velocity command, higher values result in a faster snap to the line of sight line, but also more oscillation.
				- "pronavGain" is used, in a similar manner as it used in pronav guidance, to multiply the velocity error and provide an acceleration command. Higher values result in a faster snap to the commanded velocity vector, but also more oscillation.
			- Replaced "radarTimeout" field with general "seekerTimeout", which is now used for heat-seeking, active radar homing, inertial and anti-radiation homing. Added "terminalSeekerTimeout" field so this can be specified separately for the initial and terminal targeting types.
			- Improved guidance for continuous rod missiles, offset direction now depends on if the missile is above/below the target rather than always being offset above.
		- Launchers:
			- Fix multi-missile launcher issues when railAmmo > launcher rails on the mode.
			- Fix multi-missile launchers not properly calculating "FiringAngle" parameter.
			- Fix certain missiles becoming ghost-like entities that ignored bullets and interceptor missiles when fired from MultiMissileLaunchers with "ignoreLauncherColliders = true".
			- Added "Lofted Aimpoint" toggle to Missile Turrets, with the accompanying "Loft Velocity Factor". When toggled on, the turret will aim above the target to provide some lofting to the missile trajectory (though this requires the usage of pronav and a gain schedule). "Loft Velocity Factor" is used to scale the missile's "optimimumVelocity" for the ballistic simulation, a lower "Loft Velocity Factor" results in a higher loft angle.
			- Added new "deployBlocksPitch", "deployBlocksYaw" and "deployBlocksReload" booleans to Missile Turrets, when toggled on, the turret will have to finish it's deploy animation before pitching/yawing, and will have to retract for reloading (respecting the pitch and yaw toggles as well).
			- Allow multi-missile launcher to gracefully error in the event of the missile model not being found. A debug log entry will be made, warning the user of such an error, and if it is a launcher, it will attempt to find the correct model to use.
			- Added "displayOrdinanceHasColliders" field to multi-missile launchers, defaults to true. When set to false disables the colliders on the dummy missiles granting a very minimal performance improvment.
- Effects:
	- Add splash effects to underwater explosions (very WIP, feedback on size, behavior etc. would be appreciated).
	- Bullet hits now attached to whatever collider they hit, so bullet hits on animated parts, like turrets, will now move with them.
	- Fix floating bullet hits and fuel leaks from explosions (note this does NOT fix decals floating due to collider issues, that's a problem with the part model).
- GameModes:
	- Don't spawn new asteroids in asteroid rain mode while in high time-warp.
- Competition:
	- Add a "defaults" button to the scoring window to reset score weights to their default values.
	- Updated parsing and plotting scripts.
		- Using 'python parse_tournament_log_files.py -w cfg' reads the score weights from the score_weights.cfg file.
		- Using 'python plot_summary.py -i regex' creates the plot ignoring any craft matching the regex string.
	- Add a "Daylight" position on the "TimeWarp Between Rounds" tournament slider to warp to dawn whenever a round would start in darkness.
	- Fix Proximity Fuzed bullets/rockets and bullet/rocket-based nukes from not registering hits/score.
- Spawning:
	- Automatically adjust the PRE range if the spawn distance would put craft outside the physics range.
- Scripts:
	- All python scripts have been moved to the folder "Scripts".
	- Added the new "BDArmoryMissileManeuverEnvelopePlotter.py" and "KSPFloatCurveCalc.py" scripts.
		- "KSPFloatCurveCalc.py" is a general utility, implementing KSP FloatCurves in python as a class, using numpy and some not-so-efficient-but-faster-than-opening-KSP code.
		- "BDArmoryMissileManeuverEnvelopePlotter.py" is a new tool, using "KSPFloatCurveCalc.py", numpy and matplotlib, designed to allow modders to make the most of the new missile changes. It is a command-line utility that allows the user to plot the performance of a missile, allowing the modder to better tune the performance of their missile.

v1.10.0.0
IMPROVEMENTS / FIXES
- General:
	- Fix colliders on the AWACS Radar when using legless variant.
	- Update the logic for syncing advanced 'Game Difficulty' settings to respect custom G-limit settings.
- UI:
	- Add an alternate layout to the entries in the vessel switcher, togglable via the ↔ button.
	- Adjust colour of vessel status and target strings in the vessel switcher for better visibility.
	- Update localisation synchronisation script and sync en-us to other languages. Missing entries are commented out and tagged with ??? and the English translation (to assist with user contributions).
	- Fix the wrongly labeled "ru-ru" localisation to "ru" so that it loads properly.
	- Add additional Chinese localisation thanks to user ZIYUXUAN201011.
	- Updated German localisation from EzBro.
	- Adjust waypoint ranking in the vessel switcher window to be based on the current score weights.
	- Fix m/km units in Team Icons to be used appropriately.
	- Automatically disable team scores in the score window when running FFA tournaments or continuous spawning.
- AI:
	- Fix the PID auto-tuner's "Initial Learning Rate" slider in the AI GUI.
	- Improvements to pilot follow mode to improve stability.
	- Fix check for overriding terrain avoidance when ramming ground targets.
	- Fix AI always seeing all LoS targets within 200km regardless of view range or radar detection.
	- The AI targeting priority 'Aerial Target Preference' now considers craft flatspinning or otherwise possessing negligible horizontal velocity lower than 200m from the ground as semi-ground targets for target filtering.
	- Adjust the "fixed field" toggles in the AI GUI for auto-tuning the pilot PID axes that are in use.
	- AIs set to evade while running waypoint courses will now use evasion non-linearity, if enabled, to provide some dodge capability while still remaining on-course for the next gate.
	- Tweaked gate targeting logic, should reduce last-second control jerk while passing through gates with a high deviation.
	- Waypoint Race mode now works with Surface and VTOL AI.
	- Add 3-axis static damping in the pilot PID.
		- Dynamic damping and 3-axis damping are now independent toggles.
		- The UI (both PAW and AI GUI) update to show only the active damping sliders.
		- Craft that used 3-axis dynamic damping get automatically updated to use the independent toggles without losing their tunings (but updated craft are not backwards compatible with older installs).
	- Clamp the strafing minAlt of the pilot AI to at most half the gun range to give at most a 30° dive slope for short range guns.
	- Some minor performance optimisations.
- Countermeasures:
	- Fix flare and smoke CMs ejecting sideways.
- Detectors:
	- Display non-zero RCS <= 0.01m^2 as dBsm instead of square meters for more precision.
- Weapons:
	- Removed the 'Engage Missile' toggle from APS/Dual-Purpose APS turrets as these weapons don't use it and it was confusing users.
	- Fix custom ammo belts not cycling ammo type in some situations.
	- Fix weapons using a secondary ammo consuming secondary ammo when primary ammo missing.
	- Fix tracers on guns with tracerlength > 0 extending behind gun on firing.
	- Radar slaving multiple turrets when turret multi-targeting > 1 now sees if a radar lock exists for each secondary target, instead of overriding multi-targeting and aiming all guns to the primary lock.
	- Fix Point Defense guns not firing on incoming missiles.
	- Add Aim Override option to set what weapon AI uses for aiming/target lead when using heterogeneous weapon groups/weapons with offsets from centerpoint.
	- Fix 'is target behind terrain' check extending beyond the target, preventing weapons from firing if target is in front of a wall or hill.
	- Missiles:
		- Added "hasIFF" field to missiles allowing for missile seekers without IFF functionality. Defaults to true.
		- Fix AAMLoft implementation for MMGs.
		- Fix reload gauge for reloadable launchers.
		- Add dynamic ordnance offset for reloadable rails so larger missiles no longer clip into rails/hardpoint mounts.
		- Fix lock-less Radar missiles doing a loop instead of going straight.
		- Fix Reload Gauge on reloadable launchers.
		- Fix Account For Mass/Cost not applying to Missile magazines.
		- Fix Modular Missiles not being able to intercept missiles.
- Competition:
	- Adjust the default score weights for rockets to be more inline with that of bullets.
	- Adds a Vessel Legality checker button to the BDA Utilities Tool GUI if 'Runway Project' or 'Use Comp Overrides' gamemodes options are enabled and a Comp_settings.cfg is added to GameData/BDArmory/PluginData/. This will check a craft in the SPH/VAB for part count/engine count/Lift-To-Weight/Thrust-Weight-Ratio/max allowed weaponry/banned parts/etc. Check GameData/BDArmory/PluginData/Comp_settings.cfg once loaded in KSP for more info.
	- Switch score weights to reside in their own config file "score_weights.cfg" to simplify distribution of custom score weights in RWP.
- Spawning:
	- Reset the custom craft browser internals if the user switches saves.
	- Add caching of the filtered vessel list in the custom craft browser to reduce UI rendering time.

v1.9.0.0
IMPROVEMENTS / FIXES
- General:
	- Fix potential stack overflow in cfg parsing of bullets, rockets, materials and mutators that can cause KSP to not load if BDBNIC is also installed.
- UI:
	- Added lead target indicator to bombing reticule.
	- Bomb aimer reticule now dynamically sized based on bomb yield.
	- Reloading BDA settings now reloads the spawn locations.cfg.
	- Temporarily show the mouse cursor by holding right shift (customizable).
- AI:
	- Add target priority debug info to the telemetry and AI debugging.
	- Tweak take-off climb rates slightly for smoother take-off.
	- Surface AI now able to (mostly) navigate around buildings at the KSC/Island Airfield/etc.
	- Re-add look-ahead check to Missile Launch authorization, AI now again checks if the target is predicted to still be within boresight 2s later, should cut down on incidents of missiles firing at bad angles the moment a target enters FOV.
	- Missiles set to not use DLZ launch ranges now still use min range turn radius kinematics check to see if a missile can plausibly physically maneuver to reach the target at shorter ranges for determining when the AI should launch.
	- AI beginning to lead target 2s before coming into gun range now properly takes relative closing velocity into account.
	- Bombing improvements:
		- Fix the requested extend distance prior to dropping bombs.
		- Fix AI not dropping bombs despite being on target.
		- Fix AI not properly leading moving targets when bombing with unguided bombs.
		- Add a "Bombing Altitude" slider and switch related fly-to instructions to use this when performing level bombing runs.
		- Implements Dive Bombing behavior, and toggle to swap between dive and level bombing routines.
		- AI now properly dives to torpedo bombing altitude at start of bombing run. Torpedo Bomb Alt raised to 200m.
		- AI will now temporarily inhibit gain alt behavior when doing low-level bombing if min alt has been set too high to prevent aborting runs due to 'gain altitude'.
		- AI will no longer do an Immelmann turn to come about when bombing.
		- Include the expected drop-time (for unguided bombs) in the initial extend distance request and lower the default A2G extend distance to compensate.
		- Add pilot extending readout to the loaded vessel switcher.
		- Fix the bomb aimer sim from stopping early when the bomb is within the explosion radius of the target and use the closest approach instead.
		- Fix the bomb aiming overshoot logic to only abort a bombing run when overshooting by more than twice the blast radius or 200m (whichever is larger).
		- Slightly improve torpedo lead when torpedo bombing vs moving targets.
		- Slightly improve AI bombing ability vs elevated(target on rooftop/bridge)/flying targets.
		- Fix AI not always prioritizing torpedoes over bombs for A2G vs naval targets.
		- AI is now capable of bombing when not the focused vessel.
		- Experimental support for Surface AI torpedo and VTOL AI bomb/torpedo runs to properly aim/abort/extend when using these weapons.
- Detectors:
	- Airborne sonars no longer detect splashed/submerged targets for datalinked teammate radars.
	- Fix submerged radars being able to detect things.
	- Fix bug that would prevent Laser/GPS targeting cameras from targeting vessels with a vessel exterior to CoM distance greater than 14m.
- Competition:
	- Add a hidden setting for the number of attempts of a heat during a tournament before using the "start despite failures" option (if enabled).
	- Improve the reporting of damage / parts hit from explosions in competitions. (Set REPORT_DAMAGE_NOT_PARTS_HIT to False to revert.) Reported values may include nearby debris as long as the main vessel is also hit.
	- Add gzip-compression to the tournament.state file, falling back to plain ASCII if needed.
	- Add continuous spawn scoring to the score window. (Removes the option to disable dumping the logs every spawn.)
	- Fix Pinata mode team swap breaking ground-spawn competitions.
- Weapons:
	- Missiles:
		- Fix kappa guidance when firing at receding targets.
		- Add cruise missile popup behavior, using the fields "CruisePopup", "CruisePopupAngle", "CruisePopupAltitude" and "CruisePopupRange".
		- Added new terminal weave guidance based on https://www.sciencedirect.com/science/article/pii/S1474667015333437, set up as with any other terminalHomingType, uses fields "WeaveVerticalG", "WeaveHorizontalG", "WeaveFrequency", "WeaveTerminalAngle" and "WeaveFactor".
		- Fix bombs/missiles in cargo bay logic and have the cargo bays automatically open/close when selected manually.
		- Fix NRE when trying to use Antirad missiles in reloadable rails/MultiMissileLaunchers
		- Added some target filtering to antirad guidance logic based on ping type, frequency, and proximity to previous ping, they shouldn't get decoyed by the first radar signal they detect now.
		- AntiradTargetType now suports type names as well as ints, e.g. 'antiradTargetTypes = SAM, Detection' vs 'antiradTargetTypes = 0,5'.
		- Added a Fire Angle slider to missiles to allow setting the permitted launch angle to narrower than the missile boresight FOV, to control how lined up with the target the AI should be before triggering a launch.
		- Fixed issue with AI not firing GPS-guided missiles in some conditions.
		- Attempting to fire GPS missiles from a vessel with existant, but non-valid targeting cam will now see if a radar fix can be used instead of aborting.
		- Add support for nuclear/kinetic warheads on Modular Missiles.
		- Fix custom beehive warhead firing submunitions sideways.
		- Fix MultiMissileLaunchers using 'ignoreColliders = true' not properly disabling colliders on spawned missiles and potentially resulting in RUD if the launcher is clipped into the vessel.
		- MultiMissileLaunchers with multiple tubes/cells/rails now properly display the amount of ordnance loaded into the launcher when Ordnance Available set to lower than the number of tubes.
		- Fix radar-guided missiles fired from a VLS detonating immediately after launch due to lost lock.
		- Missile 'hasMissed' grace period now adjusted based on missile velocity and motor state, so things like slow VLS launches don't time out before they can tip over and get on target.
		- Fix GPS missile NRE when trying to fire from beyond Targeting Camera max range using a missile turret.
		- Fix damage from explosions sometimes being lower than it should when hitting large parts with multiple Colliders.
		- Missiles can now be equipped with jammers and countermeasures, the missiles will enable their jammers and begin dropping countermeasures when closer than "missileCMRange", at an interval of "missileCMInterval" seconds.
			- This includes modular missiles, sliders corresponding to the two fields have been added. Setting "Countermeasure Range" to > 0 will activate this system. Note that any countermeasures placed on modular missiles will NOT be accessible for normal use.
			- Note that jammers will only be enabled once at "missileCMRange". CMDropper priority will function as it does for BD AI.
		- Fix multi-missile launcher scaling bug, missiles should now scale correctly.
		- Added multi-missile launcher offsetMax field, to allow increasing the offset limits from the default of 1m.
		- Added multi-missile launcher deployTime field and slider, this allows changing how long the launcher is open for after launching from 0.5s to up to 5s. This is primarily intended for launching slower missiles out of VLS.
		- Reloadable rails no longer do a reload when there's no ordnance remaining.
		- Torpedos now use running depth (default -3m if unguided) and depth-keeping, instead of diving in a straight line towards target.
		- Fix Stingray Torpedo buoyancy.
		- Add AAM Loft as a guidance option for Modular Missile Guidance missiles.
- Spawning:
	- Allow storing craft URLs in the custom spawn templates to simplify repeated use of the templates with specific craft.

v1.8.0.1
IMPROVEMENTS / FIXES
- Weapons:
	- Missiles:
		- Fix not being able to manually fire GPS-guided bombs/missiles without an AI-assigned target.

v1.8.0.0
IMPROVEMENTS / FIXES
- General:
	- Adjust fuel leak FX to work better in space and low atmospheric density.
	- Add the ability to add custom sub-categories to the BDA part categorizer.
	- Add some new missile plume prefabs for jets/sustainer stages.
- UI:
	- Improve prevention of click-through of various windows in the editor.
	- Open sections of the AI GUI now remain open when switching between flight and editor.
	- Competition UI text in the upper left corner now properly scales when adjusting UI_SCALE.
	- Added an option to follow the stock UI scaling instead of BDA's one.
	- Add ability to set teams' Allies to the Team Selector GUI.
	- Add craft thumbnails to the custom craft browser.
	- Add a button (in the Settings->UI section) when in the SPH/VAB to generate missing craft thumbnails (which can be found in KSP/thumbs).
		- Generating thumbnails involves loading each craft and capturing a thumbnail. This can take some time if many are missing.
	- Add "VAB Organizer" MM patch for BDA parts — from user Spartwo.
- AI:
	- Fix AI not going into Ramming mode when guns possess ammo, but not enough to meet resourceRequestAmount of mounted weapons.
	- Orbital AI now automatically disables gimbal on reverse thrust and RCS engines (gimbal directions for these are incorrect).
	- Add missing sonar checks for AIs trying to fire torpedoes.
	- Fix AI not turning on Active sonar when trying to fire INS torpedoes if no passive sonar on vessel.
	- AI visual detection of incoming missiles within visual range no longer requires a RWR. RWR detection of incoming missiles still requires a RWR on the craft.
	- Tweak AI detection and reaction to incoming GPS/INS missiles, they should detect and react to them a bit more consistantly now.
	- AI can now make use of non-DynamicRadar radars for missile targeting when being actively targeted by incoming anti-radiation ordnance.
	- AI can now do non-linear evasion vs long-range targets while aiming missiles.
	- Add Extend Min Gain Rate slider to set extend abort condition if not gaining distance fast enough.
	- AI now checks for available secondary resource as well as primary for weapons using 2 ammo types (e.g. railguns using bullets + EC) when doing weapon selection checks.
	- AI can now use an ally laserdot for targeting laser-guided ordnance if it lacks a targetcam of its own.
	- AI now uses a TWR factor in the climb rate limit calculations.
	- Improvements to formation flying behaviour. Planes in follow mode should now hold their positions better and be more stable.
	- Fix point-defense missile system, AI should now engage with the appropriate amount of missiles.
	- AI will no longer drop locks when these are supporting semi-active radar homing missiles.
- Competition:
	- Fix craft equipped with repulsors breaking ground spawn.
	- Add support for using custom spawn templates with RNG style tournaments.
		- The number of teams per heat and vessels per team per heat are restricted to at most those in the selected spawn template.
		- Teams are considered as the per file / per folder option.
		- The "Re-use Craft To Fill Teams" option applies for teams that lack sufficient craft to fill the spawn template.
		- Both shuffled and ranked tournaments are supported.
	- Add a hidden option to "smart assign" teams for custom spawn templates (when not running a tournament).
		- Set "VESSEL_SPAWN_SMART_REASSIGN_TEAMS = True" in BDA's settings.cfg to enable it when "Reassign Teams" is enabled.
		- The first vessel in the spawn template with a non-default team name (can be set in the SPH) that isn't already taken sets the name for the team. Other teams get their default letter.
	- Updated plot_summary.py to adjust how the graph and legend fit in the window.
- Countermeasures:
	- Fix NRE from countermeasure droppers missing an ejectTransform in the .cfg.
	- Fix Acoustic Decoy launcher launch direction.
	- Acoustic Decoys will no longer defy gravity and fly if launched out of water.
	- Fix Bubble Curtain launcher NRE.
	- "Infinite Ordnance" now also applies to countermeasure droppers.
	- Adjust cmThreshold timing for SLW countermeasures to 5x time set in WM to account for torpedoes being substantially slower than missiles.
		-	This should allow proper CM behavior against both torpedoes and missiles without compromising one or the other.
- Detectors:
	- RWR no longer clamped to visual FOV for detecting incoming missiles.
	- Add new fieldOfView field to RadarWarningReceiver module to set custom RWR FOV.
	- Fix AI not popping countermeasures for non-radar incoming missiles detected by RWR but outside visual range.
	- Added notching and beaming behavior for both vessel radars and missile radars.
		- Defaults to off. When toggled on, radars can be notched by an aircraft flying low and at 90° to the radar.
		- Behavior is configurable using the activeRadarVelocityGate and activeRadarRangeGate floatcurves for missiles and radarVelocityGate and radarRangeGate floatcurves for radars.
		- Also includes water blocking radars, forcing engagements to consider the horizon.
			- Added a hidden "RADAR_ALLOW_SURFACE_WARFARE" option (default: true), which permits surface vessels to see each other over the horizon to simplify naval engagements.
	- Fix the targeting window breaking a lot of scroll behaviours.
	- Fix the targeting window's slewing along an axis and add a small quadratic component to allow faster slewing with faster mouse movement.
	- Avoid firing missiles while slewing the targeting window if the mouse drifts outside the window.
- Weapons:
	- Adjust bullet tracers to lead up to their current position instead of from their previous position.
	- Reduce bullet tracer visual glitching due to krakensbane adjustments.
	- Weapons will now properly report Ammo Depleted when ammo remaining is less than amount required to fire.
	- Fix weapons refusing to fire when one shot left when using multiple ammo boxes with differing starting ammo amounts due to floating point errors.
	- Explosive beehive submunition explosion FX now scaled based on submunition tntMass, not parent HE VFX.
	- Fix weapons with reload animations adding an extra 1-20s to the reload time, based on fire anim length.
	- Add new "postFireChargeAnim" field for weapons with charge animations to specify if the animation should play in reverse to deactivate the weapon after firing.
	- Fix weapons with reload sounds using "oneShotSound = false" immediately stopping the SFX when switching to a different weapon.
	- Fix weapons with spindown anims when they stop firing that have overheated under AI control not spinning down until they've cooled down.
	- Laser weapons or other weapons using ElectricCharge can now fire if Infinite Electricity is on, even if Infinite Ammo is not.
	- Adds fireAnimOverrideSpeed field to set custom fire animation play rate instead of basing it on rate of fire.
	- Fix electrolaser NRE when firing on a target vessel.
	- Added a hidden "WEAPONS_RESPECT_CROSSFEED" setting (default: true), which may be set to false to restore previous behavior where guns did not respect crossfeed rules.
	- Improved performance of bullet firing code.
	- Fixed issue where slaved turrets would fire at a stale radar contact.
	- Added "guidanceRange" parameter for guided bullets, determines the range to the target at which the bullet will begin to maneuver, set to -1 for guidance immediately from the muzzle.
	- Missiles:
		- Add "cruiseRangeTrigger" field to missiles. Missiles using this will delay firing their cruise motor until within the set distance to target.
		- Tweak acoustic propagation loss rate for passive acoustic torpedoes, should have a bit further effective detection range now.
		- Fix INS guidance ordnance not configured with a datalink immediately triggering the lost lock condition and self-destructing.
		- Passive Sonar torpedoes now home in on loudest part, not COM. Respects targetCoM override in the .cfg.
		- Fix Terminal Guidance Passive Sonar torpedoes not entering terminal guidance.
		- Fix laser guided ordnance locking on to enemy laser dots.
		- Missile in-flight anims (flightAnimationName) now starts playing when boost motor ignites instead of post boost phase.
		- Added "custom" warhead module, functions like a normal warhead, except it launches a bullet instead of exploding, integrated with missiles.
		- Point-defense missile turrets will no longer follow mouse aim unless manually selected.
		- Fixed booster mass missing from missile dV calculation.
		- Fixed terminal radar guidance missiles lacking IFF.
		- Inertial guidance missiles with terminal guidance that were dumbfired will now activate their terminal guidance.
- Armor:
	- Armor should now be more consistent in terms of HE resistance. Adjusting the "Armor Explosion Resistance Multiplier" should now more directly affect the amount of armor penetration explosions do.
	- Improved long-dart armor penetration mechanics, should have improved performance against consecutive plates in contact with each other. Improved residual velocity formula.
	- Implemented "realistic" model for explosive reactive armor against kinetic projectiles, now using an interaction length-based model, supports symmetrical and open-faced sandwich configurations.
		- Hits on the sides of explosive reactive armor now no longer provide additional armor protection. (For Modders: Ensure that the section.forward transform is normal to the strike-face of the ERA. Turning on Debug Lines will show you the forward transforms in blue, the green and red lines represent .right and .up respectively.)
		- Now the specific explosive reactive armor section hit by bullets will explode instead of a random section.
	- Implemented angle correction for explosive reactive armor hits, now penetration increases with increasing hit angle. Resistance described by armorModifier * 300 mm at 68 degrees.
	- HEAT warheads now become unfocused as they penetrate through layers of armor, thicker layers will unfocus HEAT jets more than thinner layers.
	- Added a hidden "HEAT_CONE_HALF_ANGLE" setting (default: 2.5), which allows the damage cone angle for HEAT warheads to be adjusted.
		- Setting this value to -1 makes the HEAT damage area into a line instead of a cone.
	- Added a hidden "KERBAL_ERA" setting (default: true), which can be set to false so that EVA Kerbals no longer provide infinite armor.
	- Adjustable armor now scales breakingForce and breakingTorque based on values in the part.cfg file.
- RWP:
	- For S6R10, GM kill craft that lack propulsion and are significantly beyond the asteroid field radius.
	- Adjust attraction of asteroids beyond 90% of the field radius to not clump together at the centre so that they don't kill the sole surviving craft.
	- Add craft spawn warning message if craft doesn't have AI/WM on root part or if the root part isn't a cockpit.
- P:S:
	- Add max extend time limit clamp to override extend behavior that goes on for longer than time limit.
	- Add support for automated AI/WM settings for competition rules compliance. To utilze, create a 'Comp_settings.cfg' with an 'AIWMChecks' node, containing one or more of the following settings:
		-	extensionCutoffTime = n
		-	extendDistanceAirToAir = n
		-	MONOCOCKPIT_VIEWRANGE = n
		-	DUALCOCKPIT_VIEWRANGE = n
		-	guardAngle = n
		-	collisionAvoidanceThreshold = n
		-	vesselCollisionAvoidanceLookAheadPeriod = n
		-	vesselCollisionAvoidanceStrength = n
		-	idleSpeed = n
		-	DISABLE_SAS = T/F	
		If the file is not present, or it is, but the Use AI/WM Overrides toggle in Game Modes is off, overrides will not be used. Overrides will apply on competition start or vessel spawn.

v1.7.1.0
IMPROVEMENTS / FIXES
- General:
	- Add a SimpleRepaint MM patch to ignore incompatible parts.
	- Fix typos and duplicates in the changelog.
- Armor:
	- Add a max armor limit slider (under General Slider Settings) to limit the max thickness of armor. Default: unclamped.
- UI:
	- Team Icon text now scales with icon scale.
- AI:
	- Orbital AI:
		- Adds ability to use controllable sidemounted engines as RCS thrusters.
		- Add toggles to disable use of RCS for translation and rotation.
		- Adds Zero-throttle firing range setting that will override maneuvering orientation in favor of pointing ship in attack Vector direction within set distance.
		- AI now takes target acceleration/velocity into account when accelerating to engagement speed/killing velocity.
		- Adjustments to the hasPropulsion check to properly detect when a vessel no longer has propulsion.
- Detectors / Countermeasures:
	- Allow higher precision for CM intervals and delays in the WM right-click menu.
	- Fix invalid C# syntax in the TWS radar .cfg file.
- Competition:
	- Auto-generated tournaments use the last used world.
	- Fix ramming scoring to also work for orbital AI.
- Game Modes:
	- Sanitise the waypoint course index in the vessel spawner window in case the course list has changed.
	- Asteroid Field:
		- When resetting asteroid fields, destroy those that have switched SoI as they don't reset properly.
		- Adjust the asteroid attraction to be 20% of the field radius instead of hard-coded to 1km.
		- Fix asteroids not spawning at the correct location in orbit.
		- Limit motion-reduction force applied to asteroids to a linear function above 1500m/s and the maximum centroidFactor for re-centering asteroids to avoid yeeting them when the average velocity suddenly changes due to vessels dying.
		- Limit growth of the asteroid pool to twice the requested field size to prevent infinitely growing pool size when there are issues generating new asteroids.
- Weapons:
	- Optimizations to bullets, should be a slight performance increase when firing lots of bullets.
	- Beehive submunitions with proximity/flak fuzes now properly set fuxe distance based on pellet tntMass, not parent shell's.
	- Fix nuclear/explosive beehive submunitions not inheriting velocity when detonating on space.
	- Fix beehive ammo with nuclear submunitions not being able to get the explosion models.
	- Fix APS going rapid-fire when running out of ammo.
	- Fix HEAT bullets being reported as Missile damage in the Score parser.
	- Fix issue with velocity calc that would result in penetrating rounds slowly drifing away from a hit ship in space.
	- Fix laser hit position not accounting for Krakensbane.
	- Fix EC usage requirements not appearing in infocards when weapons are using deprecated ECPerShot.
	- Missiles:
		- Update the KKV model with fixed textures thanks to Stardust.
		- Don't evade missiles fired from teammates unless the missile is locked on to craft or craft is in the flight path of the missile.
		- Log an error if the missile exhaust prefab doesn't exist without breaking OnStart.
- Spawning:
	- Disable waiting for terrain to settle if the spawn altitude is >10km.
	- Add a couple of 30s timeouts to spawning initialisation to avoid a potential soft-lock.

1.7.0.0
IMPROVEMENTS / FIXES
- General:
	- Fixes for post-build event instructions on Windows to allow for different 7zip executables.
	- Downgrade using defaults for missing bulletinfo fields from an error to a warning.
- UI:
	- Updated Chinese localisation thanks to user Marv1n-M.
	- Propagate new localisation strings to non-English localisation files. Seach for commented out entries with value "???".
	- Fix the alignment indicator not showing for dual-mode APS turrets.
	- Waypoints / Waypoint Course builder can now set gate models on a per-gate basis, using models stored in /BDArmory/Models/WayPoint/
	- BDA Craft Utilities Tool Lift to Weight readout split into Dry and Wet mass LTW scores.
		- Can set what resources are considered part of drymass for Dry LtW calculations via new Drymass Resources button.
	- Fix Kinetic Resist readout in the Armor Stats subsection of the BDA Craft utilities Tool being inverted.
- AI / WM:
	- Improvements to the Orbital AI
		- PID control option available, by default is active only during weapon firing, can be toggled to be active always or never active.
		- If a fixed weapon is selected, AI will orient itself to fire the weapon, even if the weapon is not aligned with the forward direction of the craft.
		- Improved maneuvering behavior, it is now better at intercepting targets, killing velocity, and prioritizes combat over minor orbital corrections when within combat range.
		- Add option to engage head-on or broadside (for use with turreted weapons).
		- Add option to select broadside direction (only active when PID is enabled).
		- AI is now able to use reverse engines for maneuvers provided the "Reverse Engines" option is enabled (enabled by default).
		- Add minimum firing speed option. If below this speed and within weapons range, AI will increase speed.
		- Add option for AI using RCS to manage velocity relative to the target when firing (enabled by default).
		- Add options to enable/disable evading gunfire using RCS and/or engine thrust.
		- Add option to allow ramming (enabled by default). If enabled, AI will try to ram the target when it loses weapons, if disabled the AI will withdraw from combat.
		- AI will not engage vessels if doing so will put the AI in risk of de-orbiting.
		- Fixed AI repeatedly jumping back and forth between orbit correction and other modes.
		- AI is now capable of avoiding collisions with other vessels, debris, and asteroids.
		- AI is now properly aims and fires unguided missiles in orbit.
		- AI will automatically move to closer intercept ranges if it is unable to lock missiles after 20s.
	- Improvements to VTOL AI:
		- VTOL AI given secondary speed controller; VTOL AI will now throttle engines set to 'independent thrust' for horizontal speed control independently of primary engines being used for lift/powered hover.
	- AI will no longer ignore max missiles per target when using multimissile launchers for missile interception.
	- AIs/WM no longer subject to GForce failures if KSP part G-Tolerances enabled.
	- Don't set the global infinite fuel option when maintaining fuel levels for individual vessels.
	- Don't raycast for terrain normals when taking off from water, just use the up direction.
- Armor / Hull:
	- Revert invalid HullTypeNum values to that of Aluminium and log a warning.
	- Fix errors in armor damage calcs causing HE rounds to do decreasing amounts of armor damage over subsequent hits.
	- Armor damage/integrity loss now adjustable via the Armor penetration Mult slider in the BDA Settigns menu, General Sliders subsection.
	- Fix shrapnel damage from explosions phasing through armor.
- Competition:
	- Fix GM culling based on HP remaining to use percentage remaining instead of the raw part count.
	- Add an option to average duplicates in the tournament parser.
	- Fix incorrect parsing of unicode chars in the tournament parser for "wins".
	- Add 'Stop Waypoints' button to stop a Waypoints comp started via the 'Run Waypoints' button.
- Detectors:
	- Radars/IRSTs now have a 'resourceName' field to set what resource they use.
	- Fixes datalink from allied craft with sonar not displaying sonar contacts on non-splashed receiving craft.
	- FLIR ball/Camera pod now have different niches; Camera pod is now longer ranged, FLIR ball has faster camera traverse.
	- Targeting cameras now list traverse rate and max view range in the part menu infocard.
	- Added radarChaffClutterFactor (default 1) field to radars, to permit setting how effective chaff is against the radar. Used when guiding SARH missiles/radar-linked gun turrets, see TWS radar .cfg for more details.
- Game Modes:
	- Added g-force limits game mode for part failure and Kerbal GLOC (note: the pilot AI's g-limiter still doesn't work well).
	- Subsystem Battle Daamge to turrets/generators above 50% HP now reduces performance instead of disabling them.
	- Waypoints mode now works with ground spawned caft.
	- Fix Infinite Fuel until First Gate option for Waypoints Mode.
	- Asteroids Field:
		- Adjust the asteroid field game mode to also work in orbit.
		- Adjust forces on asteroids to keep them reasonably contained within the requested field volume and to avoid pinballing.
		- Adjust the asteroid anomalous attraction distance profile to peak at 707m and drop to 0.25 at 0m and 0 at just over 1km.
		- Improved competition messages related to asteroid fields.
- Weapons:
	- 'ecPerShot' deprecated, weapons now use 'secondaryAmmoPerShot' for controlling EC/secondary resource usage for things like railguns, etc.
	- Adds new 'secondaryAmmoName' field (default ElectricCharge), weapons that used ammo + ElectricCharge (railguns, etc) no longer required to use EC as the secondary ammo.
	- Electrolaser EMP damage per shot/sec now set by 'laserDamage' instead of ecPerShot amount.
	- Fix Burst Length Override softlocking the weapon after the first burst.
	- Weapons can now use Hull Materials with a massMod >= 1.
	- Missiles:
		- Improvements
			- Missile parts can be configured without a warhead and will be considered kinetic energy weapons. Upon impact, they will apply their kinetic energy as damage to the target.
			- Change missile drop time increment from 0.5s to 0.1s.
			- Missiles are now capable of intercepting each other at orbital speeds and will not phase through each other, even without the ContinousCollisions mod.
			- Modular Missiles can be selected to intercept missiles if they have Engage Missiles enabled.
			- Modular Missiles with Orbital Guidance now perform vacuum clearance maneuver (similar to HEKVs in space).
			- Improvements to regular missile orbital guidance, missiles can now use homingType = orbital without RCS.
			- Missiles with RCS will use RCS to offset gravity.
			- Add targetCoM configuration option for IR missiles. If set to true, the missile will target the center of mass instead of the hottest part.
			- Firing conditions for IR missiles tightened up, AI should no longer select rear-Aspect IR missiles against head-on targets.
			- Missiles with RCS can now have multiple forwardRCS transforms.
			- Adds new ModuleMissileMagazine, MultiMissileLauncher reloadable rails and missile pods can now resupply from external missile magazine parts.
		- Fixes
			- Fix Modular Missiles with Orbital Guidance not hitting vessel and missile targets.
			- Fix point defense missile interceptors not firing.
			- Missile turrets now track targets properly in orbit.
			- Fix missiles with no targeting type (i.e. AIR-2) not firing within engage range.
			- Fix IR missiles occasionally suddenly switching lock to allied craft behind them.
			- Fix edge-case issue where firing radar missiles would get soft-locked if trying to switch to a radar lock that didn't exist.
			- Fix missile exhaust plume FX scaling.
			- Fix missile softlock issue if AI tries to fire a laser/GPS missile at a target further than the targeting camera's max range.
			- Fix nukes in vacuum erroneously using the wrong mass value for calculating impulse from the detonation.
		- Parts / Balancing
			- Add new Kinetic Kill Vehicle (KKV) missile. The KKV is an orbital missile with 6 km/s delta-V and no warhead. It relies on kinetic energy from hitting a target directly to deal damage.
			- Re-balanced the HE-KV-1 missile. The HE-KV-1 now has 3 km/s delta-V with a 60 km range and is best at shorter ranges (under 30 km). The HE-KV-1 retains the same mass.
			- Orbital guidance missiles now have drag applied to them in atmosphere.	
	- Guns maxDeviation reduced following discovery they were miscalibrated last accuracy refactor; gun accuracy will see up to ~50% improvement across the board.
	- Fix delay-fuzed rounds occasionally not detonating.
	- Add support for guided bullets (needs radar/laser lock on target) for specialty ammo, new bulletDef field 'guidanceDPS', sets degrees/sec ammo can turn.
	- The part menu infocard for Guns now lists weapon accuracy.
	- The bullet stats section of Guns part menu infocards now lists fuze type.
	- EMP weapons will no longer shutdown asteroids.
	- Rockets:
		- Rework the rocket aiming to be consistent with how rockets fly, both in atmosphere and in orbit.
		- Add a "detonate at minimum distance" option to flak/proximity rockets (enabled by default).
		- Aero-stabilization is now stateless (doesn't depend on the time since launch, only on current aero-forces).
		- Hydra70 and S-8KOM rocket types updated and variants added.
		- Fixes S-8KOM rocket mass.
		- Optimizations to Incindiary rockets, should now be a bit better at settings things on fire.
	- Don't apply lead and weapon offset corrections to the pilot AI for turrets.
	- Proximity detonation now uses the target's "average radius" instead of its "max radius".
	- Shell ejection direction, variability (deviation), delay and lifetime are now customisable in the weapon config.
	- Mostly fix the bomb-aimer - bombs without significant lift work fairly well, but JDAMs can be fairly imprecise.
	- Avoid double-counting HP+armour of intervening parts in explosions and scale the damage reduction by the appropriate modifier.
- Spawning:
	- Allow specifying the reference heading for the first craft for circular spawning (loses precision within 1° of the poles).
	- Spawned Kerbs now have uniform G-tolerance.
- RWP:
	- Add S6R6, S6R7, S6R8, S6R9 and S6R10 defaults and custom logic.
	- Refresh various UI text fields from the settings values when updating from RWP settings.
- Evolution:
	- Various fixes for the evolution engine from user themonthlydaily:
		- Applies mutations to the correct craft.
		- Fixes subsequent mutations to be applied to the base craft instead of the most recently modified version.
		- Correctly save seed craft.
		- Adds a display of which parameters are currently being mutated/tested.
		- Fix various other internal bugs.

1.6.12.0
IMPROVEMENTS / FIXES
- General:
	- Fix Pwing HP scaling for large pwings being used as fuselages.
	- Fix PWing Control Surface Offset angle resetting on one side.
	- Add a time-sync logging option (with auto-enable for competitions) for logging in-game vs real-time timestamps for post-recording resynchronisation.
		- Toggle and logging interval options are available in the "Other Settings" section of the settings.
		- The timestamps are logged as compressed CSV files in the BDArmory/Logs/TimeSync folder.
	- Add Waypoint Mode Course Builder GUI tool (accessible from the Waypoints Section of the vessel Spawner GUI) for easy construction of custom waypoint courses.
		- Can either manually construct course from scratch or record a course as you manually pilot a craft along the course path. Courses/gates on loaded courses can be deleted via right-click.
	- List of things that cannot be set to Wood hull material expanded to other functional parts (servos/radiators/ISRU converters/RTGs) that couldn't logically be made out of wood.
	- Restore the 'ControlledActions' on the KAL too.
	- Restructuring of the localisation files (both layout and many tags) for maintainability and ease-of-editing in IDEs.
		- Adds a script for maintaining structure between localisation files.
		- Some entries in languages other than en-us will require updating — these are currently commented out with "???" as a placeholder.
	- Adds option to toggle LightFX for explosions on/off for performance/parallax compatibility.
	- Adds option to toggle off bullet water hit effects for performance.
	- Skip the 'ProgressTracking' scenario when creating a clean save to avoid triggering tutorials again.
	- Expand the debug info for missing elements when loading materials to be more helpful.
- UI:
	- Vessel Switcher GUI and competition Marquee now display Waypoint times to hundredths of a second.
	- Gravity Gun moved to the Lasers tab.
	- VTOL and Orbital AIs added to the AI GUI and adjustments made to the layout for the surface AI for consistency.
	- Make ammo bars show amounts respecting fuel flow priorities.
- AI / WM:
	- Fix Kerbal G-Loss of Consciousness implementation; AI now goes deadstick when pilot is knocked out.
	- Can now toggle AI radar shut-off behavior when targeted by HARMs either on a per-radar basis, or globally for all radars on a craft via the Weapon Manager.
	- AI now understands how to aim weapons not aligned with prograde for Schrage Musik-style weapon arrangements.
		- Note: depending on the airframe, angles outside of roughly -5° — 35° pitch and -10° — 10° yaw are dynamically unstable.
	- AI now understands how to aim fixed guns laterally offset from CoM for B Wing-style weapon arrangements.
	- Remove legacy noise added to fly-to-vessel that would throw off a craft's ability to snipe at long-range.
	- AI now takes evasive maneuvers when under attack from incoming INS/GPS missiles.
	- Fixes AutoTune infinite fuel not applying to Firespitter helicopter engines.
	- Remove the requirement of having a WM for the AI to work.
	- Add the post-terrain avoidance cool-down slider to the AI GUI.
	- AI now more intelligent about turning on Radars/Sonars; will not automatically turn on Active Sonar if present on a craft.
- Competition:
	- Save/load tournament score weights to/from the settings.cfg.
	- Waypoint Mode max laps can now be set to a user-specified value (WAYPOINT_MAX_LAPS, default 5) in the BDA settings menu.
	- Only show non-zero fields in the results.csv and when parsing multiple files separately.
	- Don't break spawning if a craft loses parts while waiting for the WM if "Start Comp. Despite Failures" is enabled.
	- Disable all FX and projectiles when clearing the field for spawning.
- Game Modes:
	- Waypoint Gates can now set AI speed limits on a per-gate basis to permit setting up braking zones before a turn/Rally courses with target speeds/etc.
	- 'Activate Guard After Gate n' setting now ends the course when FFA is complete, not when last alive craft completes the course.
	- Vengeance Mutator blast radius and delay can now be set in the BDA settings menu.
	- Don't check for fuel for afterburners if infinite fuel is enabled.
	- Fix issue with Subsystem Battle Damage option occasionally setting non-flammable parts/parts without subsystem modules on fire.
- Weapons:
	- Fix lasers being able to fire as long as > 0 EC is present.
	- Add bulletLuminance field for setting non-tracer brightness.
	- Fix weapons in salvo mode with symmetry twins firing when only enough ammo for one weapon to fire.
	- Fix heatRays not adding heat to hit parts.
	- Fix kinetic damage having damage reduction from armor being applied when hitting unarmored parts.
	- Fix sabot rounds reporting incorrect penetration values in the right click menu.
	- Missiles:
		- Fix missile exhausts not turning off.
		- Can now set cluster missile trigger distance when mounting cluster missiles on reloadable rails.
		- Nuke LightFX radius now set by effective blast range, not thermalRadius value.
		- Fix NRE when AI tries to fire Modular Missiles.
		- Fix heatseeking Missiles with very narrow sensorFOVs losing lock right before impact with a target.
		- Fix manually fired INS missiles using GPS coords if set.
		- Fix issue with AI fired radar missiles getting stuck and not firing if the first missile fired could not get a lock.
		- Fix an issue with unguided INS bomb guidance.
		- Improved inertial guidance performance when handing off to terminal radar guidance.
		- Added adapted rangeFac behavior to Kappa guidance to improve guidance performance, particularly for close ranged targets. Now an altitude limit is prescribed for the missile based on 10 * rangeFac * range^(vertVelComp).
		- Fixed maddog/dumbfire behavior of ARH missiles, missile should now be able to lock onto targets in front of it when launched.
		- Throttle now determines fuel burn, missile burnout for missiles with fuel burn now depends on fuel expenditure rather than just preset burn times.
		- Fix some typos and inconsistencies in the wording of the right click menu.
		- Improve logic for when and how AI attempts dumbfire launches when missing requisite sensors.
		- Improve logic for sonar-guided weapons, will no longer try to satisfy sonar need with radars if present.
- Detectors:
	- Visual improvements and variants added for the AN/APG-63 Radome (from Spartwo).
	- Fixed rare bug where, when spawning in vehicles while the on-screen debug elements are turned on the vessel radar cross-section would update too early, causing the radar cross-section to default to the vessel's mass.
- RWP:
	- Add S6R5 dynamic recoil gamemode; recoil scales with vessel thrust.
	- Improved handling of auto-adjusted BDA settings for RWP.
	- Update the RWP specific settings for recent and earlier rounds.
- ModIntegration:
	- Fix the type to unbox MidChordSweep to.

v1.6.11.0
IMPROVEMENTS / FIXES
- General:
	- Recompile the shaders on an older version of Unity so that they're compatible with KSP v1.9.1 and later.
	- Fix false positives of Krakensbane being active on vessel switches.
	- Add a part Tree Hierarchy visualizer to the BDA Craft Utilities Tool for checking part offset.
- UI:
	- Make the time-scaling slider visible without needing to activate time override.
	- Extend the camera-switch slider to up to 15s.
- AI / WM:
	- Clamp the vertical adjustment of the fly-to position to at most half the distance to the target (should fix the issue of being unable to attack targets directly below).
	- Add a slider for biasing the Immelmann pitch direction when not close to terrain/min altitude.
	- Add a slider for the initial roll-relevance and preserve the best roll-relevance between auto-tuning runs.
- Competition:
	- Add "Parts lost to asteroids" to the continuous spawn tournament score logs and parser.
	- Fix world switching for auto-resuming continuous spawn tournaments.
	- Make the "Auto-Quit On Tournament End" option apply whenever it's visible.
	- Suppress the "Dumping scores..." messages unless competition debugging is enabled.
- Game Modes:
	- Add Gun Game game option to the Mutator GameMode - craft progress through a list of mutators (weapon changes or otherwise) every time they score a kill. Ideally used with Continuous Spawn.
	- Asteroid Field:
		- Adjust the anomalous attraction strengths to scale better with typical asteroid radii.
		- Add an inter-asteroid repulsion at close ranges to prevent asteroids clumping too much.
		- Make the asteroids nigh indestructible so that they don't thin out over time.
- Weapons:
	- Reduce ECPerShot cost of electrolasers.
	- Heatrays now check for part occlusion.
	- Fix non-damaging lasers (gravity guns, etc.) from not scoring in competition.
	- Fix the luminance of tracers on pooled bullets not being reset (not every bullet is a tracer now).
	- Lasers now deal damage to buildings.
	- Missiles:
		- Fix Missile Exhaust FX issue.
- RWP:
	- Add RWP override settings (in RWP_settings.cfg) for automatically enabling/disabling RWP options when the RWP toggle is toggled or the RWP slider is adjusted.
		- Settings adjusted when RWP is enabled aren't saved, but can be manually added to the RWP_settings.cfg file.
		- Settings adjusted when RWP is disabled are saved to settings.cfg as usual and serve as the base that the RWP settings override.
		- Overrides for round 0 are global overrides and are applied first before round specific overrides are applied.
		- Toggling the RWP toggle or moving the slider first reverts settings to the non-RWP values, then applies the global and round-specific RWP overrides.
		- For convenience, a few settings are excluded from being reverted: settings section toggles and most spawn settings. Also, inf fuel / inf EC currently aren't affected.
		- The defaults for the RWP_settings.cfg file will be saved when settings are first saved and changes made to the file override the defaults.
		- Default RWP settings for previous rounds and the upcoming S6R2 have been added.
	- Restrict the RWP slider to only include rounds that have overrides and move it to the top of the section to avoid issues with layout changes while adjusting the slider.

v1.6.10.1
IMPROVEMENTS / FIXES
- UI:
	- Updated German localisation from EzBro.
	- Fix some localisation tags and duplicates.
- AI / WM:
	- Don't reset PID values to stored auto-tuning ones when switching the clamped/unclamped toggle.
	- Add an auto-tuning summary line to the AI GUI when auto-tuning is not running (when there's something to show).
- Weapons:
	- Fix rockets detonating too early.
	- Missiles:
		- Fix missiles not having their exhaust and boost FX.

v1.6.10.0
IMPROVEMENTS / FIXES
- General:
	- Fix Krakensbane adjustments when the active vessel dies.
	- Make sure various pooled objects are disabled when leaving the flight scene.
	- Battle damage fuel leak rates now scale by (bullet caliber)^2, instead of (bullet caliber). Fuel leak rates for 20mm caliber remain the same, calibers higher and lower than 20mm will now have higher and lower leak rates, respectively.
	- Fixes for Kerbal Safety not always detecting EVA kerbals.
- UI:
	- Updated Chinese localization thanks to user Marv1n-M.
	- Fix part filtering by search terms in the editors.
	- Adjust timing and conditions for auto-camera switching to and away from missiles.
	- Fix tracer visuals when the active vessel dies.
	- New Opacity option in BDA Team Icons to set icon opacity.
	- Adds CASE ammo explosion radii visualizer in the editors, enable via F3.
	- Continuous Spawn now shows lives remaining in the Vessel Switcher GUI.
	- Add a UI scaling option for BDA's windows.
	- Improve the logarithmic scaling in the radar windows.
	- Add a 'withZero' parameter to semi-log sliders that allows them to include 0 and uses lower precision for the smallest range.
	- Add a 'GUIUtils.HorizontalSemiLogSlider' for simplifying horizontal sliders for semi-log float ranges outside of PAWs.
	- Add a fractional component to the precision of semi-log sliders for rounding, e.g., sigFig = 1.5f gives '..., 8.5, 9, 9.5, 10, 15, 20, ...'. Switch the spawn distance slider to use this.
	- Add a power-law float range type and 'GUIUtils.HorizontalPowerSlider' for simplifying horizontal sliders for power-law float ranges outside of PAWs.
- AI / WM:
	- Add new "Kinematic Msl Evasion" toggle to Pilot AI under the evasion settings. When this is enabled the AI will evaluate the best maneuver to defeat a beyond-visual-range (BVR) missile using only kinematic maneuvers. The Time to Impact Before Evade setting on the weapons manager should be set to a high value when this evasion option is enabled. Maneuvers the AI will use are:
		- Crank - Fly at an angle to the target, while still maintaining radar lock.
		- Beam/Notch - Fly perpendicular to the missile.
		- Turn away/Turn cold - Fly away from the missile.
		- Notch & dive - This is the standard AI behavior if this toggle is disabled. It is also used if the toggle is enabled and the AI is within lethal range of the missile.
	- Invert the roll target when the fly-to direction is below and behind the craft within the Immelmann turn angle (fixes death spirals).
	- Fix automatic gun range adjustments in the WM again.
	- Prevent Orbital AI from changing attitude while launched missile is still near spacecraft.
	- Add Smoke CM timing/interval/repetition settings.
	- Fix the missile evasion direction using the wrong reference frame.
	- Automatically disable precision input mode when auto-tuning (KSP's UI element doesn't switch though).
	- Add a slider for prioritizing using brakes to slow down when braking is allowed.
- Armor / Hull:
	- Radar stealth coatings - can now apply radar absorbent/reflective materials on a per-part basis.
		- Armor coatings less than 10mm thick will provide lessened benefits.
	- Adds new radarReflectivity field to Armor materials to specify degree of radar absorbtion/reflectivity of the armor.
	- Adds new radarMod field to Hull materials to set degree of radar return off unarmored parts.
	- Adds new Radar Absorbent Coating armor type.
	- Adds new Radar Absorbent Foam hull material.
- Detectors / Countermeasures:
	- Fix missing resource for the Bubble CM.
	- Fix targeting cameras not being able to track targets.
- Weapons:
	- Corrections to penetration and ricochet velocity changes and ricochet positions.
	- Stop APS firing at dead missiles.
	- 'subProjectileCount' has been deprecated and replaced with 'projectileCount'; this specifies the number of pellets per shot (for shotguns, etc.) to make it more intuitive. Existing shotgun-type weapons will need to update their bulletDefs.
	- The subMunitionType field for beehive ammo now uses the syntax of "ammotype; quantity" (e.g. subMunitionType = 35x228AHEADPellet; 30) with number of projectiles released on detonation set here instead of the subMunition's bulletDef.
		- BDA will try to automatically detect and adjust old beehive ammo types, but mods should update their bulletDefs accordingly.
	- Fix the aiming reticles of guns (fixed and turrets) and auto-proxy-tracking when using MouseAimFlight (again).
	- Add new projectileTTL field to bulletDefs, use to set time in seconds beehive round subprojectiles will persist for. Optional, defaults to 0.5.
	- Switch the gun range sliders to use a power-law slider instead of a semi-log slider to keep typical ranges closer to the centre of the slider.
	- Missiles:
		- Fix issue with Rotary Rails trying to use missiles that have previously been blown off from combat damage.
		- Fix issue with MultiMissileLauncher Turrets throwing an NRE when AI firing.
		- Fix mass changes of missiles that decouple boosters and add missile mass debug telemetry.
		- Fix radar and heat targeting leading targets excessively (most apparent in orbit).
		- Fix missile drag curve having negative drag at ~25 deg AoA.
		- Fix AI occasionally not firing radar missiles; Git Issue #573.
		- Change target offset on missiles with continous rod warheads from Detonation Distance / 3 to Min(Blast Radius / 3, Detonation Distance / 3).
		- Fix missile RCS FX constantly displaying.
		- Missiles with RCS/Orbital homing types (i.e. HEKV) in vacuum now perform turn maneuver after launch to face target and only throttle up once facing target.
		- Fixes to anti-missile missile point-defense logic to support missile turret launched interceptors.
		- Fix radar missiles not locking and firing until well within their max engagement range.
		- Add new dragArea configuration variable for missiles to set reference area for drag independently from the lift area. If not set, this defaults to the liftArea setting in the missile configuration file.
		- Fix missiles ignoring guns with priority.
		- Added missile g-limiting. Now you can set a missile maximum g-limit using the "gLimit" field. Additionally a "gMargin" field exists which allows you to specify an allowable margin the missile can miss by to optimize drag. I.e., the missile is allowed to pull only gLimit - gMargin if pulling gLimit will result in too much drag.
		- Corrected pronav and augpronav normal acceleration using the g-limiting feature.
		- Improved missile turning behavior, turns should be slightly smoother overall.
		- Added Kappa guidance, an optimal type of midcourse guidance for in-atmosphere missiles. This re-uses the LoftAngle, LoftMaxAltitude and LoftRangeOverride fields, though LoftRangeOverride is now the range where the missile will switch from lofting to the midcourse guidance. Introduces a new field, "kappaAngle" which is a trajectory shaping angle, higher values mean a steeper terminal trajectory.
		- Fixed missile contact detonation logic, a bug was present which lead to inaccurate detection of missile contact.
		- Improved AAMLoft performance against maneuvering targets.
		- EMP warheads only detonate when armed and no longer do additional damage.
		- Add dumbTerminalGuidance bool (default true) to missiles; setting dumbTerminalGuidance = false will have missiles continue to use primary guidance until terminal targeting mode has a lock, vs immediately switching to terminal guidance the moment the distance trigger is satisfied.
- Competition:
	- Add an option for the continuous spawn central point to follow the centroid of surviving craft (biased back towards the original spawn point).
	- Add an option to automatically resume continuous spawn and to automatically shutdown KSP when continuous spawn ends due to having fewer than 2 craft left.
	- Update the continuous spawn log parser to handle multiple files, either separately or combined, and to only show non-zero columns.
	- Bias the continuous spawn's "bubble shuffle" to prioritise craft with fewer spawns.
	- Hide the ALIVE / DEAD string in continuous spawn when the UI is hidden.
	- Delay spawning craft in continuous spawning while the death cam is active to avoid lag during that shot.
- RWP:
	- Add RWP S6R1 specific overrides.

v1.6.9.0
IMPROVEMENTS / FIXES
- UI:
	- Fix the alternate (hidden UI) window locations (for scores and vessel switcher) not being saved correctly.
- General:
	- New texture for 1.25m radomes.
	- Add a max distance threshold setting to Team Icons.
	- Fix "Camera Switch: Incl. Missiles" not switching to missiles about to hit their target.
- AI / WM:
	- Add new Orbital AI part for spacecraft in orbit:
		- The Orbital AI will use orbital maneuvers to close within gun range of the target to fire weapons. It will also automatically fire missiles when able.
		- The AI will maneuver at the Maneuver Speed setting and once within gun range try to fire guns while at the Strafe Speed setting.
		- It will evade missiles based on the countermeasure settings on the Weapons Manager and evade gunfire using AI settings similar to those on the Pilot AI.
		- When spawned at orbital altitudes using the BDA Vessel Spawner, craft with the Orbital AI will be automatically spawned into orbit (other options for orbital spawning are cheat menu and HyperEdit mod).
		- Orbital AI is adapted from the StockCombatAI (KCS) mod, check it out here https://github.com/Halbann/StockCombatAI/releases!
	- Base the Immelmann turn pitch direction on the local pitch angular velocity (i.e., pitch down if already rotating that way — fixes the pitch oscillation behaviour when targeting an opponent behind the craft while inverted near terrain).
	- Don't summon the NaN-Kraken when the post-terrain avoidance cool-down is 0.
	- Tightened up 'on target' threshold for dumbfiring missiles.
	- Perform banked turns when the target is behind us at long range and extending is allowed instead of Immelmann turns or turning directly to target. Threshold is clamp(8 * max speed, 1000, 4000).
	- Pilot AI turns will now turn harder (using Max AoA setting) towards the notch direction the closer the missile is to impact.
	- Factor the user-defined steer limit into the turn radius calculations.
	- Use a more gentle take-off slope for the initial take-off.
	- Add an Evasion Min Range Threshold option to only trigger evasion from an attacker using guns when they're beyond that distance.
	- If enemies are detected nearby but beyond gun range and we're not aiming, perform nonlinear (evasive) weaving to avoid long-range sniping.
	- Make the gun range slider more tolerant to following increases in the max gun range.
- Detectors:
	- Can now set targeting camera slew speed using "traverseRate" field in ModuleTargetingCamera.
	- Improve Targeting Camera ability to track moving/flying targets.
- Weapons:
	- Fixes for initial bullet placement and simulated hit position when Krakensbane is not active.
	- Account for the initial bullet placement in the bullet traveled distance.
	- Fixes for aiming reticles of guns (both fixed and turrets) when using MouseAimFlight.
	- Show where aimer lines in the SPH are blocked and by what.
	- Add Deploy toggle to see where weapons with deploy animations will point when deployed vs retracted (e.g. M230 chaingun).
	- Fix lasers using wrong armor thickness value for damage reduction calcs.
	- Fixes point defense/APS turrets not engaging incoming missiles.
	- Fix proximity/flak/beehive ammo detonation timing when used in orbit.
	- Missiles:
		- Add new Orbital guidance option for Modular Missiles.
			- Missile will attempt to intercept orbital target at the user-set Max Speed value.
			- homingType = orbital replaces homingType = RCS in missile configuration files (BDA is still backwards-compatible with homingType = RCS).
		- Improvements to modular missile AAM guidance types so that they work in orbit.
		- Fix for HEKV launching unguided in non-ideal situations.
		- Fix clustermissiles launching copies of themselves instead of submunitions.
		- Fix clustermissiles not respecting submunition trigger distance.
		- Fix clustermissiles acting like reloadable missiles when not set up for reloading.
		- Fix Guidance Type None missiles not holding course.
		- GPS missiles now require a target cam or radar lock for GPS coords.
		- INS missiles can now use either radar or IRST tracking.
		- INS missiles now have datalink capability for mid-flight target coordinate updates (uses gpsUpdates field), update rate clamped to Radar/IRST scan speed.
		- ECM can now jam GPS/INS datalink if missile within hostile ECM AoE.
		- Fix error with Inertial guidance target prediction for non-updating missiles.
		- Fix Missiles having 10 armor instead of 2.
		- Fix SARH missiles that relock to a new target not updating their target vessel.
		- Changed missile missed check, missiles now check if they have come within 400m, are post-thrust, or are more than 1km behind target, and have exceeded a grace period of maxTurnRateDPS/15.
- Countermeasures:
	- Add vessel's velocity to chaff ejection particle effect.
	- Use vessel acceleration instead of velocity for chaff decoy factor calculation when in space.
	- Add option in WM's CM settings for auto-deploying CMs when not in guard mode (e.g., for manual combat).
- Vessel Mover / Spawning:
	- Check for outdated loadMeta files when refreshing the craft list in the vessel selection window and update them since KSP doesn't update them when you save your craft!
	- Fix the spawn point selection sometimes not registering.
	- Vessels with an orbital AI that are spawned at safe orbital altitudes are spawned into circular orbits. Vessels are spawned pointing away from each other.
	- Increase maximum spawn distance to 200km.
	- Add a "bubble shuffle" to the waiting craft in continuous spawning to increase the randomness of the spawn order.
- ModIntegration:
	- Fixes for inhibiting CameraTools when initial spawning during continuous spawning and disable auto-switching to newly spawned craft joining the competition.
	- Provide helpers for CameraTools so that the camera can aim at missiles' targets (requires CameraTools v1.31.0).

v1.6.8.0
IMPROVEMENTS / FIXES
- General:
	- Add tracking of 'named modules' (from non-dependency DLLs) to the VesselModuleRegistry.
	- Optimise "Vector3.Distance(from, to) < dist" type checks.
- UI:
	- rcsOverride enabled ECMJammers now properly affect RCS in the SPH/VAB RCS GUI.
	- Fix Equivalent Armor Thickness readout in the Armor GUI.
	- Fix custom ammobelt UI overwriting belts on heterogeneous weapon groups.
- AI / WM:
	- AI GUI fixes for surface AI.
	- Fix AI disengagement from launched nuclear/EMP ordnance if within projected blast radius.
	- Expose the weave strength factor as a tunable parameter for the surface and VTOL AI.
	- AI will now toggle/disable ECM Jammers if under fire from GPS/antiradiation ordnance.
	- Adjust the off-boresight angles for DLZ checks for extending to prevent super long-range extends.
	- Fix FSM not being started when initially deploying landing gear.
- Weapons:
	- Fix BurstFirelength and FireAngleOverride toggles not working in flight.
	- Fix APS parts getting mixed in with global weapon shortnaming and overriding barrage settings.
	- Anti-Ballistic APS no longer assigns multiple turrets to a single incoming shell, now respects reloading/overheated state of the weapon during target assignment.
	- Guns now properly respect crossfeed.
	- Don't apply the unity integrator correction to the unsupported gravity component of the aiming (improves on-orbit aiming).
	- Improve the estimate of the required OverlapSphere for Vessel-Relative Bullet Checks for hypervelocity craft.
	- Abrams Turret maxDeviation decreased to 0.1; Abrams bullet spread should reliably hit a tank-sized target from 2km again.
	- Missiles:
		- Add new Inertial guidance mode.
			- Add new 'inertialDrift' missileLauncher field for INS drift, in meters/sec.
		- Have torpedoes head to last known contact point and start circling it, instead of current sink to bottom behavior.
		- MultiMissileLauncher deploy anim toggle now affects symmetry twins.
		- Fix various NullReferenceExceptions when trying to use Modular Missiles.
		- Antirad missiles using antiRadTypes = 9 now properly home in on active ECM jammers.
		- Craft without Radar/radarlock will now wait to fire radar LOAL missiles until target distance is close enough that radarTimeout < (tgtDist - activeRadarRange) / optimalAirspeed.
		- Fix NRE when trying to fire laser-guided missiles from a turret with no targeting cam.
		- Single stage Modular Missiles now activate their engine on launch without needing an AG setup.
		- Continuously-updating GPS-guided ordnance can now be jammed by a ECM jammer if within the jammer's garble radius.
		- Missile Interception reworked, tied to PD logic. Missiles set to engage missiles will automatically launch to intercept incoming missiles (assuming viable launch geometry).
		- Hopefully fix the Missile Turret phantom force issue.
		- Fix GPS missiles fired from a cargo/custom bay losing lock immediately on firing.
		- Fix typo in Dynamic Launch Zone calculation that was preventing some missiles from launching.
		- Remove global toggle to use Dynamic or Static launch range for missiles and replace it with a per-missile toggle. When toggled on, the missile will launch missiles at their max engagement range without taking into account craft velocities.
		- Incorporate missile frontAspectHeatModifier value into missile selection logic so rear-aspect missiles are not selected if they cannot be fired.
- Competition:
	- Include last-damaged-by tracking for bullet explosions that damage vessels, not just hits.
	- GM kill when weaponless now looks for no weapons with ammo instead of no weapons.

v1.6.7.0
IMPROVEMENTS / FIXES
- General:
	- Kerbal Foundries wheel and track HP now properly scales with wheel size.
	- ProcArmor now has symmetry attach.
	- Fix Armor panels < 10mm thick resetting to 25mm.
	- Toggling Battle Damage will disable Paintball Mode, if enabled.
- UI:
	- Windows that show despite the UI being disabled (i.e., Vessel Switcher and Score windows) store a separate size and location for that mode.
	- Use a resize handle instead of buttons for horizontally resizing the Vessel Switcher window.
- AI / WM:
	- When ramming, if the target is also trying to ram us, aim more directly at them (avoids unstable dynamics).
	- Fix some depth-keeping logic with Submarine AI.
	- Guard Mode toggles off if enabled when loading into a battle site from the KSC that had active combatants at the time player previously exited to Space Center.
	- Fix secondary target assignment logic assigning targets irrespective of target priority settings.
	- Add UNDERWATER_VISION view distance option so ships require sonar to detect submerged subs, and submerged subs require sonar to detect other vessels vs being able to see them as long as they are within guard range.
	- Add attack logic for gun-armed submarines when BULLET_WATER_DRAG is disabled.
	- AI now respect target priority settings when looking at landed or splashed targets.
	- Fix issue with ground vehicle AIs not selecting missiles against ground targets in some circumstances.
	- AI now less jittery when doing bombing runs.
	- Add new 'Maintain Min Range' toggle for Land AI; if enabled Vees will stop/reverse to maintain minimum engage distance to target.
	- Change Surface AI cruise behavior; if MaintainMinRange, craft will slow as before until minRange reached; if disabled, Vees will maintain flank speed regardless of target distance.
	- Add missing combat Depth slider to AI GUI for Subs.
	- AI now has longer object permanence for stationary/slow land targets it has lost sight of.
	- VTOL AI makes sure Landed status is disabled during take-off.
- Countermeasures:
	- Add missing Active Sonar countermeasure.
- Detectors:
	- Fix Radars utilizing a max of 3 locks, regardless of radar-lock capable radars present on a vessel.
	- Enemy passive sonars no longer show up on the Radar Warning Reciever.
	- IRSTs now return the hottest enemy target they detect, rather than whatever is first on the targets list when using it for manually firing heatseeking missiles.
	- Fix multiple radars locking the same targets; radars will now properly distribute targets to lock amongst themselves.
	- Fix Radar GUI not properly displaying radars using custom radarTransforms.
- Weapons:
	- Bullets now take relative velocity into account when calculating damage.
	- Fix Dual-mode APS turrets getting slaved to radar when firing on standard targets and not subsequently engaging incoming missile targets.
	- Fix APS occasionally getting stuck on phantom targets.
	- Rework aiming logic for improved long-range aiming for vessels moving at orbital speeds (still not entirely correct for low Kerbin orbit at longer ranges, but significantly better).
	- Missiles:
		- Fix missiles not firing on surface ships.
		- Missiles now properly receive explosive damage from point defense HE rounds/interceptor missiles in paintball mode.
		- Fix missiles occasionally getting stuck when fired from VLS.
		- Fix Missiles failing LOS check due to kerbins curvature for ship vs ship engagements.
		- Fix for GPS missiles fired from multiMissileLaunchers losing lock when fired.
		- Fix guidance type = none missiles detonating 5km from launcher.
		- Fix NRE from manually firing GPS missiles from a multimissilelauncher.
		- AIs attempting to dumbfire multimissileLaunchers will now take missile launch vector into account instead of vessel prograde.
		- Adds new Settings option 'LIMITED_ORDINANCE' to clamp multimissilelaunchers and reloadable rails to a single salvo's worth of ammo.
		- Fixed GPS coords not updating for bombs.
		- Fixed occasional NRE when using laser-guided missiles in a surface to surface role.
		- AI can now aim unguided/dumbfired missiles with the missile turret.
		- AI can now use JDAMs/other guided bombs as unguided bombs when lacking targeting cam instead of aborting.
		- Improve Bomb lead calcs for better bombing accuracy against moving targets.
		- Fix turrets spinning wildly about when AI loses track of target and target position goes stale.

v1.6.6.0
IMPROVEMENTS / FIXES
- General:
	- Procedural Wing max armor thickness now based on mean thickness of the wing.
	- Adds new Acoustic Decoy CM dropper.
- UI:
	- Add Japanese localization files thanks to user Taka005.
- AI / WM:
	- Fix the cubic solver giving invalid results for nearly degenerate cubics (used in aiming).
	- Fix the debug line trajectories not showing the final part of the trajectory.
	- Add experimental Submarine AI option to Surface Driver AI.
	- Various weapon selection logic tweaks to support sensible weapon selection/use when submerged and firing on non-submerged targets.
	- Add torpedo bombing logic to pilot AI.
	- AI will now lead moving ground targets when bombing.
	- AI will start dropping bombs from reloadable rails/bomblet dispensers early for proper carpet bombing instead of dropping them behind a target.
	- Fix AI dropping bombs several hundred meters behind target.
- Detectors:
	- Add new radarTransformName field to ModuleRadar/new irstTransformName field to ModuleIRST to allow setting custom radar direction/setting multiple radars to a part using custom radar models.
	- Add new sonarType field to Radar for setting up Active or Passive sonars.
- Countermeasures:
	- Add Acoustic Decoy CM support via 'countermeasureType = decoy'.
	- APS point defense target acquisition and assignment logic rewritten, APS will now semi-intelligently identify and distribute targets among guns in the PD network.
	- APS weapons now respect Fire Interval and Burst Length settings.
- Weapons:
	- Missiles:
		- Fix some NREs when manually firing missiles.
		- Add new guidanceDelay field to allow setting a delay between missile launch and missile beginning to maneuver towards a target.
		- Dynamic Launch Range now uses missile EngageRange max instead of static launch range.
		- Improved launch behavior for missiles set to be fired at very short range.
		- Add LineOfSight check when firing missiles.
		- Fix torpedoes not working.
		- Missile/Bomb fratricide prevention now based on team instead of sourcevessel.
		- Add Salvo size slider to MultiMissile Launchers, enabled via the new MultiMissileLauncher .cfg 'setSalvoSize' bool.
		- Improve launch of missiles from reloadable rails.
		- Add new MultiMissileLauncher 'deploySpeed' field to set deploy animation duration.
		- Add intrinsic scaling option to MultiMissileLauncher for missile pods and the like, use new fields 'scaleTransformName' and 'lengthTransformName'
		- Fix issue with air-dropped torpedoes exploding on impact with the water despite being within their waterImpactTolearance.
		- Fix torpedo behavior if trying to target something with a CoM above water level
		- Tweaked weapon lead aim calcs for guns firing beehive shells, Oerlikon should hit more often now.
		- MultiMissileLaunchers can now support GPS guided missiles launching at multiple simultaneous targets.
- Competition:
	- Add new GM Kill conditions for planes that have lost engines/weapons/set percentage of their parts and LandedKillTimer conditions for surface AIs that have found themselves in water/water AIs that have beached themselves/sunk.
	- Don't auto-resume tournaments when custom spawn templates are selected.
- Vessel Spawning:
	- Allow using custom spawn templates for airborne spawning too (with altitude >10m).
	- Add option to immediately set airborne-spawned vessels (with a pilot AI) to their idle speeds.
	- Tweaks to initial focussed vessel after circular spawning.
	- Always perform vessel validity checks and wait for WMs to appear in the Vessel Switcher during post-spawning even when not immediately starting a competition.
- Vessel Mover:
	- Make the vessel selection more resilient to corrupted vessel files/loadmeta.
	- Default the vessel selection window to using the VAB if the initial vessel is spawned through the launchpad.

v1.6.5.0
IMPROVEMENTS / FIXES
- General:
	- Fix Pwing HP error with Pwing edges not contributing as much HP as they should.
- UI:
	- Fix numeric input fields not updating when they should.
	- New Team Icons toolbar icon for easier identification.
	- Add colour coding to the number of parts in the vessel selection windows.
- AI:
	- Add a toggle to the pilot AI to disable ramming ground targets.
	- Add a toggle to the pilot AI for treating the min altitude as a hard limit.
	- Include the TWR of a vessel when determining the gain altitude slope, allowing much higher slopes.
	- Include a climb rate at half the take-off climb rate while evading below min altitude.
	- Prevent inverted loops when below min altitude and improve the inverted loop threshold calculation.
	- Improve vessel collision avoidance by prioritising non-debris and by prioritising potential collisions by size.
	- Add a "post-avoidance cool-down" slider to the pilot AI to increase pitch away from terrain for a short period after avoiding terrain.
	- Add a Manoeuvering steer mode similar to NormalFlight steer mode, but with Aiming mode's roll behaviour.
		- Switch a number of inappropriate uses of Aiming steer mode to Manoeuvering mode.
	- Add a green debug line for showing the pitch target direction the AI is aiming for (which is not necessarily the same as the position the AI is told to go to).
- Armor:
	- Allow changing the unclamped min/max dimensions for proc armor in the settings.cfg (PROC_ARMOR_ALT_LIMITS).
- Weapons:
	- Fix APS point defenses not respecting Infinite Ammo cheat.
	- Fix APS weapons not activating when Guardmode enabled, if they aren't already active.
	- Anti-Missile weapons can now shoot down missiles in Paintball mode.
	- Missiles:
		- Add option (in Show Missile and Countermeasure Settings) to allow missiles to be fired from their full dynamic launch range instead of static launch range.
		- Add trigger range setting for cluster missile submunition launch.
		- Fix MultiMissileLaunchers resetting detonation Distance.
		- Fix MML "TNT Mass Equivalent = -0.0018726" PAW label.
		- Fixed Missiles with ModuleMissileRearm improperly launching.
		- Fixed MMLs resetting detonation distance.
		- Multi Missile launchers now check clearance based on tube orientation regardless of overrideReferenceTransform setting.
		- Missile/bomb fratricide prevention now also checks the source vessel name to allow explosives to be destroyed by explosives of the same type from another vessel.
		- Fix NRE from SARH missiles fired without a lock.
		- Missiles now properly calculate offboresight angle from missile orientation, not vessel prograde.
- Competition:
	- Adjust round progress strings in tournaments: ranked => 0→N, shuffled => 1→N.
	- Report total number of rounds for ranked tournaments properly.

v1.6.4.1
IMPROVEMENTS / FIXES
- UI:
	- Add an option for disabling the self-updating of the text in numeric input fields.
		- When the value fails to parse (after the delay) the text will turn red.
		- Toggling the numeric fields or closing the windows will reset the field to the most recently successfully parsed value.
		- The text will still be updated if the parsed value becomes clamped within the limits of the field.
	- Make the delay for the "read and interpret" logic of numeric input fields customisable (default 0.5s).
- AI:
	- Some QoL improvements for auto-tuning: automatically enable AI and engines and move the craft to the autotuning altitude.
- Detectors:
	- Fix Conformal Decals throwing off RCS calculation in editor (SPH/VAB).
	- Hide scenery during RCS calculation in editor (SPH/VAB) to prevent scenery from affecting calculation.
	- Add for/aft/side/top/bot RCS readout to the On-Screen Telem debug option when ASPECTED_RCS is enabled.
	- Add slider for ASPECTED_RCS_OVERALL_RCS_WEIGHT to the BDA Settings menu.
- Countermeasures:
	- Fix exceptions caused by ECM jammers.
- Competition:
	- Fix a bug in the score window for teams competitions.
	- Automatically enable the teams score toggle in the score window if the "Teams" slider in the vessel spawner window is set to teams mode on start-up.
	- Dump a "team scores.log" file to the Tournament folder for teams tournaments after each round.

v1.6.4.0
IMPROVEMENTS / FIXES
- General:
	- Make ammo consumption respect staging and priority order unless "externalAmmo = false" in the weapon config.
	- Don't auto-switch vessels when MouseAimFlight is active.
	- Fixed an issue where modules on a vessel re-entering the PRE range weren't being updated in the VesselModuleRegistry.
	- Fix a number of issues with Pwing+FAR HP calc.
	- PWing Thickness-based Mass+HP now takes PWing Edges into account if PWing Edge Lift enabled.
	- Fix armored cockpit mass resetting on load.
	- Add search tags to all BDA parts.
- AI:
	- Make the autotuning re-centering distance customisable.
	- Add unclamped max values for auto-tuning speed and altitude.
	- Prevent weapon selection from choosing weapons when target is closer than the weapon's minSafeDistance.
	- Fix AI potentially seeing beyond viewrange.
	- Increase preemptive lead distance AI will begin leading target before entering engagement range.
	- AI will now switch off of Afterburner if AB is out of fuel (for Rapiers/other LF/non-air AB-mode engines).
- Vessel Spawning:
	- Disable gravity easing when using 'Warp Here' above 10m altitude.
- Vessel Mover:
	- Add support for browsing craft in subfolders of the SPH and VAB (also in the custom spawn templates).
	- Allow resizing the vessel selection window and remember its position.
- Weapons:
	- Fix various NREs related to missiles and multi-missile launchers.
	- Adds optional tracer smoke.
		- new 'smokeTexturePath' setting for ModuleWeapon to set custom smoke trail FX, leave blank for default bullet FX
	- Properly support weapons with multiple ModuleWeapon modules.
	- Turret integration with ModuleMultiLauncher for MML style Hydra Turrets, etc.
	- Fix missiles fired from same source vessel causing each other to explode when they cross within proximity detonation distance.
	- Add flareEffectivity = 1 in missile configs. Modifies how the missile targeting is affected by flares, 1 is fully affected (normal behavior), lower values mean less affected (0 is ignores flares), higher values means more affected.
- Countermeasures:
	- Add rcsOverride field to ModuleECMJammer to enable setting craft RCS to a set value.
	- Split CM time into missile evade time and CM deploy time to allow setting a craft to begin evading, then deploy CM, etc.
	- Fix an issue with chaff vessel modules summoning the Kraken on undocking.
	- Fix an NRE related to jammers enabling.
- Competition:
	- Make the saving of backup tournaments optional (hidden setting TOURNAMENT_BACKUPS in settings.cfg).
	- Added a ranked tournament mode.
		- Ranked tournaments begin with a single shuffled round (craft assigned to heats randomly), then continues to generate ranked rounds (craft assigned to heats based on their current rank) until the number of ranked rounds run matches or exceeds the rounds slider (which can be adjusted during a tournament).
		- Ranked tournaments only work for FFA style tournaments. nCr and gauntlet style tournaments aren't supported.
		- For teams tournaments, the combined score for the teams is used for the ranking.
		- Enable the score window via the "Sc" button on the Vessel Switcher window.
		- Use the "UI" button to keep the window visible even when the rest of the UI is disabled (F2).
		- Use the "±" buttons to adjust the font size.
		- Use the "W" button to adjust the score weights.
		- Use the "T" button to switch between individual and team scores for teams competitions.
		- Left click and drag the drag handle to resize the window.
		- Right click the drag handle to switch to auto-adjusting height.
		- Scores update after each round (not heat) in a ranked tournament.
	- The tournament.state file uses a new format (recursively encoded JSON due to Unity's limited JSON functionality), contains a lot more information and isn't compatible with older tournament.state files.
		- A script (parse_tournament_state.py) can convert the tournament.state file to proper JSON (tournament.json) and back again for ease of editing.
	- Fix a minor bug in the tournament log parsing script where wins weren't always being counted for the score.
	- Make the saving of backup tournaments optional (hidden setting in settings.cfg).
	- Add NPC support for FFA-RNG tournaments (both ranked and non-ranked).
		- To use NPCs, create a "NPCs" folder in the folder for the tournament (e.g., "AutoSpawn/MyTournament/NPCs"), add the NPC files to this folder, then set the "NPCs Per Heat" slider to the desired number of NPCs.
		- NPC files will be reused as necessary to provide the appropriate number of randomly selected NPCs each heat.
		- When generating heats, the number of NPCs is taken into account for the total number of vessels per heat (e.g., 8 vessels per heat with 2 NPCs per heat would give 6 players + 2 NPCs in each heat).
		- The "Tournament Scores" window will only show the scores for non-NPCs.
	- Add an "auto" setting for the "Vessels Per Team Per Heat" in teams tournaments where the teams will simply be all the craft files in each team's folder.
- Detectors
	- Add settings toggle ASPECTED_RCS that enables real-time RCS evaluation based on the target aircraft's azimuth and elevation relative to the radar evaluating it.
		- Enable from the BDA settings menu under Missile & CM settings: "Real-Time Aspected RCS."
		- The real-time aspected RCS is dependent on a weighted average against overall craft RCS, so lower overall craft RCS will lead to better aspected RCS.
		- Overall craft RCS weighting in this average is dependent on ASPECTED_RCS_OVERALL_RCS_WEIGHT = 0.25 in the settings.cfg file.
		- Final aspected RCS will be = (1-ASPECTED_RCS_OVERALL_RCS_WEIGHT) * [Aspected RCS] + ASPECTED_RCS_OVERALL_RCS_WEIGHT * [Overall RCS].
	- RWRs now activate when they first detect a missile instead of when missile enters visual range.
	- RWRs now track active Radar missiles regardless of missile visibility if VARIABLE_MISSILE_VISIBILITY is enabled.
- RWP:
	- S5R10 special settings.

v1.6.3.0
IMPROVEMENTS / FIXES
- General:
	- Archive the defunct KSPedia files, reducing the size of the BDArmory zip file by around 24MB.
- UI:
	- Add a button for resetting the scroll-zoom rate to 1 when "Debug Other" is enabled.
	- Lock input to the numeric field when inputting values in custom log and semi-log sliders.
	- Don't apply slider rounding when setting up log and semi-log sliders.
- Vessel Spawning:
	- Adjust intra-team spacing to scale better with distance.
	- Fix the inward/outward facing direction when spawning teams and use the same facing direction for all members of a team.
- Detectors:
	- Now properly sends correct radar lock to SARH missiles when firing at multiple targets with a multi-lock radar.
	- Properly lock SARH missiles when manually firing them.
	- Equipping multiple lock-capable radars increases total radar locks the vessel can support.
	- Attempting a radar lock will now check all radars capable of locking instead of just the first.
- AI:
	- Smoothly vary the roll target during gain alt behaviour from the surface normal to vertical to avoid clipping wings into terrain when taking off on uneven terrain.
	- Don't store/restore fields that are reference types.
	- Make sure Time Override gets disabled when the AI gets destroyed if auto-tuning was enabled (should prevent it from being active unintentionally during competitions).
	- Hide the 3-axis dynamic damping button when dynamic damping is disabled.
	- Move the dynamic damping toggles to before the sliders to stop them from jumping around when toggled.
	- Fix the PID field ordering when the PAW is first opened.
	- Change the localisation for "controlSurfaceDeploymentTime" to "Vessel Reaction Time" to be more representative of its function. Also increase its range when unclamped.
	- Fixed guard mode behavior with radarLOAL = false missiles when Max Missile Targets > Max Radar Locks on fire control radar.
	- AI will now start leading a target when a gun is equipped 2s before entering max range.
	- Adjust AI search pattern/drift when trying to find a recently lost target.
	- Fix AI being able to see targets beyond set visual range.
	- Fixes AI unlocking radar lock while in-flight missiles are using it.
- Weapons:
	- Added (or corrected) penetration value for shaped charges to missile/gun/rocket part-menu infocards.
	- Fixed armor penetration calculation for display in the part-menu infocards.
	- Add an option when setting weapon groups to apply the group name to that weapon, symmetric weapons, all weapons of that type, all weapons of that class or applying to all guns/rockets/lasers.
	- Missiles:
		- New 'canRelock' field (default: true), sets if SARH radar-guided missiles will re-lock onto the active radar target if the original radar lock is lost.
		- Further improvements to loft guidance, added a new field "terminalHomingType" which allows for selection of terminal homing logic.
			- "aam"/"aamlead", "aampure", "pronav" and "augpronav" are currently supported.
			- Both pronav options allow for user defined gains using "pronavGain" (recommended values of ~1-7).
			- IMPORTANT: "LoftTermRange" has been renamed to "terminalHomingRange"!
		- Fixed MultiMissileLauncher behavior with loft guidance, as well as pronav/augpronav.
		- Added new missile field "terminalHoming", when true the missile uses its original homingType until "terminalHomingRange" is reached, then it will switch to "terminalHomingType".
		- Fixed bug in heat seeker detonation behavior which caused some missiles to not detonate when they should.
		- Some tweaks to multimissile decouple speed/direction and drop time.
		- Fix DLZ NRE with multi-missile launchers.
- Competition:
	- Fix Laser mutators.
- RWP:
	- Add MAX_SAS_TORQUE setting to autoset max non-cockpit SAS torque across vessel at competiton start.
	- Add Runway_Round S5R10 setting to autoset necessary AI settings/fields for Space combat.

v1.6.2.0
IMPROVEMENTS / FIXES
- General:
	- Fix TweakScale config for Typhoon engine (again).
	- Add Toggle/Enable/Disable pivot action groups to the Claw variants.
	- Add an action group option to give unlimited pivot range to the Claw variants.
	- Tweaks so that asteroids have the proper HP in flight mode.
	- Optimisation of some vector operations.
	- Adds variant texture for ground radars.
	- Fix SIDAM texture variants for standard brown or greyscale.
- Armor:
	- Make the adjustable armor 'clamped' and 'triangle type' options persistent and initialised correctly in the PAW.
- UI:
	- Adjust formatting of some debug telemetry.
	- Fix EMP Hellfire texture URL.
	- Add an indent for missile and CM settings.
- Vessel Mover:
	- Don't apply "Don't Avoid Collisions" while lowering vessels.
- Vessel Spawning:
	- Re-register EVA Kerbals in spawned vessels as active, since KSP de-registers this for some reason.
	- Add a default text for the custom template name field.
	- Automatically add the current custom template to the list if it's not already there when clicking 'save' without requiring clicking 'new' first. (I.e., don't require 'new'→'save' for the initial template.)
	- When using "Fill Seats" = "Cockpits or Combat Seat", include the first command seat if neither a cockpit nor combat seat are present.
	- Fix an issue with the spawning routine hanging when using asteroids game modes.
	- Fix the inward/outward spawn orientation for circular spawning.
- Detectors:
	- Adds a new dish-only AWACS radar variant.
- Weapons:
	- APS turrets now function when GuardMode is off to let them work on player-operated craft.
	- Adds new 'dualModeAPS' field (default false) for APS turrets; if true, they can also be selected and used as standard weapons.
	- ABL/GoalKeepers/Oerlikon are now configured as dual-mode anti-missile APS.
	- Fixed aiming cursor remaining while turrets are slaved to a GPS target.
	- Missiles:
		- Fix AI not selecting laser missiles.
		- SARH missiles now properly follow whatever the active locked radar target is.
		- Added new loft guidance logic under the homingType "aamloft".
			- Enables longer ranged engagements at high altitude by enabling higher terminal speeds.
			- Added various tuning parameters accessible in the hangar (as well as in part configs) to tweak performance as desired.
			- A more thorough explanation of the guidance law and the tuning parameters is available on the Github wiki https://github.com/BrettRyland/BDArmory/wiki/1.2.5-Missile-configuration#3-loft-guidance-missiles.
		- Implemented missing pure pursuit guidance ("aampure").
		- Add new 'boosterFuelMass' and 'cruiseFuelMass' fields to missile config that allow missiles to have a fuel usage that can affect mass when the new field 'useFuel' is true.
- Competition:
	- Add some checks for lacking an AI or an airborne AI being landed/splashed to the scoring for being considered as wrecked (MIA).
	- Add competition messages about vessels colliding with asteroids.
- RWP:
	- Use the current planetary body, not Kerbin for remote orchestration.

v1.6.1.0
IMPROVEMENTS / FIXES
 - General:
	- Fix TweakScale config for Typhoon engine.
	- Reduce min size, scaling increment for procArmor panels.
	- Internal refactor of vessel spawning/moving.
	- EAS-2 External Combat Seat now has a unique model(credit: Eclipse) to help differentiate it from the stock EAS-1.
- UI:
	- Maintain the camera angle and distance when switching vessels with the Vessel Switcher (page up/down).
- Vessel Mover:
	- Abort vessel selection and reset state when closing/hiding the VM window.
- Vessel Spawning:
	- Use the better Vessel Mover lowering routines to lower spawned craft to the terrain. 'Ease-in Speed' is now the same as 'Min Lower Speed' in VM.
	- Fix the black screen caused by an invalid camera target during custom template spawning.
	- Maintain the camera angle when switching to spawn locations.
	- Also maintain the camera distance if bringing the current vessel with us when switching to spawn locations.
- AI:
	- Lower the minimum extend abort time to 1s.
	- Set the main throttle axis group for the VTOL AI and the wheel throttle axis group for ground AI. (pitch, roll, yaw axis groups are already being set.)
- Detectors:
	- Adjust IRST display implementation.
	- Adds new 'omniDetection' field to RadarWarningReciever (default true). If false, RWR will only detect Radar missiles immediately, some changes to missile detection and CM response.
	- Adds 'VARIABLE_MISSILE_VISIBILITY (default False) BDA setting for setting visual detection range of missiles based on their boost/cruise/post-thrust state.
	- Add 'irstRanging' field (default false) to IRSTs to let them determine range and work like 'heat radar'.
- CounterMeasures:
	- Add optional 'cooldownInterval' field for jammers/thermoptic CMs to add a cooldown before they can be used again.
	- Implements smoke CM triggers, so the AI will actually use these now.
- Weapons:
	- Adds 'minSafeDistanceDistance' field (default 0) to ModuleWeapon, for setting default weapon min ranges; AI will no longer fire if within min range. ADJUST AT OWN RISK.
	- Fix ground Vees from firing wildly into the dirt if they lose sight of engaged ground target.
	- Adds LoS check to direct-fire weapons.
	- Missiles:
		- Heatseeking missiles no longer home in on engine plume of engines that have turned off their Afterburner.
		- Fix targeting offset for CR missiles.
		- Fix NRE with jettisoning Multimissile Launchers.
		- Adds ModularMissile ground target weapon selection logic.
		- Give unguided/GPS missiles without coords/Radar missiles sans Radar/Laser missiles without Targeting Pod a dumbfire reticle.
		- AI can now use dumbfired missiles (Targeting Mode = None / Radar/Laser missile without the necessary sensor), if no better option available.
		- Add new 'radarTimeout' field to missile configs to permit dumbfired inertial guidance LOAL radar missiles.
		- AI can now attampt to use guided bombs against air targets if engage Air = true and nothing else available.
	- Fixed turret manual fire behavior, guns should now no longer fire unless they are correctly aligned with the point of aim.
	- Fixed explosive erroneous cone-of-effect calculations for standard and shaped charge warheads. Should now function correctly.
- Competition:
	- Pinata mode now temporarily disables Camera AutoSwitch, switches camera to Pinata until it is destroyed.
	- Update the tournament parser to compute non-negative scores per round for waypoint races.

v1.6.0.2
IMPROVEMENTS / FIXES
- UI:
	- Add a toggle for aim assist mode (Target = reticle placed at the closest point of approach of the projectile to the target, Aimer = reticle placed at the aiming position).
	- Add localisation for 'Multiple' ammo type.
- Missiles:
	- Fix missiles being able to fire.

v1.6.0.1
IMPROVEMENTS / FIXES
- General:
	- Restore compatibility with KSP 1.9.1.
	- Cleaned up some lingering issues with repulsor functionality when used outside of the 'Enable Repulsors' gamemode.
- UI:
	- Expand 'Edit Inputs' scrollview enough to show all the shortcuts.
- AI:
	- Don't turn on peace mode when auto-tuning.
- Gamemodes:
	- Add BD_PART_STRENGTH BattleDamage option to have part/joint strength weaken as parts take damage.
- Weapons:
	- Fix clustermissiles being non-functional.

v1.6.0.0
IMPROVEMENTS / FIXES
- General:
	- Add restore/wipe functionality to the controlled axes of the KAL.
		- Toggling the "Restore KAL" toggle in the GamePlay section of the settings will restore or wipe the controlled axes from KALs on all loaded vessels.
		- Vessels spawned via BDA+'s spawning routines will automatically have this applied.
		- The KALs on all loaded vessels will also be restored/wiped on competition start.
	- Update the defaults for a number of BDA+ settings.
- UI:
	- Auto-switch UI focus to new input text fields in Vessel Mover and Custom Spawn Templates.
	- Move the "Auto-Disable UI" toggle to the UI section of the settings.
	- Fix the AIR-2 Genie manufacturer localization tag.
- AI:
	- Axis groups: set the various axis groups when setting the flight control state, allowing the BDA+ AIs to use these axis groups.
		- Pilot and VTOL AI set the main throttle, pitch, yaw and roll axis groups.
		- Surface AI, additionally, sets the wheel steer axis group.
	- Battledamage is automatically disabled when Autotuning; no more craft setting themselves on fire from fueltank fires.
- Detectors:
	- IRST now properly returns data to heatseeking missiles.
- Countermeasures:
	- rcsReductionFactor in ECMJammers can now be set > 1 for making radar reflectors and similar.
- Weapons:
	- Gun recoil now properly takes propellant mass into account.
	- Multiple fireanim support for single barrel weapons.
	- Fix impulse for lasers.
	- In light of the increased damage following the HE damage calc fix in 1.5.9.0, the Explosive Damage Multiplier default has changed from 0.65 to 0.55. Note: this needs to be reset by the user.
		- FireAngle default reduced from 1.4 to 1.0.
		- Gun accuracy refactored across the board.
		- Browning accuracy changed to 0.32.
		- Vulcan accuracy changed to 0.88.
		- Vulcan Turret accuracy changed to 1.02.
		- GAU-8 & GAU-22 accuracy changed to 0.6405.
		- Goalkeeper accuracy changed to 0.675.
		- Chaingun accuracy changed to 0.45.
		- Sidam accuracy changed to 0.42.
- Missiles:
	- Fix issue that had broken MultiMissileLauncher parts last update.
	- Add ability to jettison Multi-Missile rails via 'permitJettison = true' in their .cfg.
	- Add 'displayOrdinance' bool for MultiMissileLaunchers for missilepods/bomb dispensers or similar where ordnance does not need to be visible.
	- Add 'OverrideDropSettings' bool for MultiMissileLaunchers for reloadable rails and similar to fix missile settings getting overwritten on launch.
	- Fix issue with detonation distance and heat seekers targeting the engine exhaust plume.
- GameModes:
	- Add 'RepulsorOverride' bool to ModuleSpaceFriction, to allow Repulsors to be used outside of the SpaceHacks Gamemode (for making repulsor wheels and similar).
- Competition:
	- Add sorting and "scores" for waypoint runs in the Vessel Switcher for waypoints game mode.
- VesselMover:
	- Add option to immediately place the vessel after spawning.
	- Adjustments to movement in map mode.
	- Safer placement-lower.

v1.5.9.4
IMPROVEMENTS / FIXES
- GameModes:
	- Rewrite how repulsors work, using the default altitude as the target altitude and a decaying exponential balanced at the target altitude and with velocity damping. Include a slider for setting the strength of the repulsor effect, which affects the scale of the exponential.
- UI:
	- Update some Immelmann Turn text that was missed.
	- Favour craft close to going through waypoints to switch the camera to.
- Weapons:
	- Correction to manual aiming when the Krakensbane frame velocity is non-zero.
- RWP:
	- Season 5 Round 5:
		- Adjust how drag is applied to kerbals in S5R5 to give a smoother response.
		- Set the Immelmann angle to 0 for S5R5 since the craft designs don't pitch well.
		- Add a custom message for the GM kill for S5R5.

v1.5.9.3
IMPROVEMENTS / FIXES
- Internal:
	- Add a Semi-Logarithmic FloatRange slider UI, which gives ranges where the values are of the form: 0.8, 0.9, 1, 2, 3, ..., 8, 9, 10, 20, 30, ..., 80, 90, 100, 200.
- AI:
	- Adjustments to terrain avoidance defaults and how the threat range is calculated for better default terrain avoidance.
	- Add a slider for setting the angular size of the cone for performing an Immelmann turn, in which the craft will simply pitch up to turn to a target in that direction.
	- Fix for auto-tuning if the user moves the number of samples slider to lower than the current sample number.
- UI:
	- Add a case-insensitive filter to the vessel selection windows in Vessel Mover and Custom Spawn Templates.
	- Add a custom GUILayout.TextField with a grey placeholder string for nicer text entry boxes.
	- Set turret slider step sizes based on the config limits: 20—200 steps.
	- Add a close button to the VM window and tweak the colour scheme of other close buttons.
- Mod Integration:
	- Add reflection utils from CameraTools.
	- Add initial support for the MouseAimFlight mod.
		- Disables the prevention of firing weapons when the mouse is over windows when the Mouse Aim mode is active.
- VesselMover:
	- Better failure handling when VesselMover fails to spawn a vessel.
	- Adjust movement speeds to better match that of the original VM.
	- Adjust orientation for changes in the local up direction.
	- Add an option to automatically close the VM window on competition start.
- Competition:
	- Add an option to generate a CSV file for the overall PVP scores in the PVP parser.
	- Use natural sorting to get the most recent tournament in the parser.
	- Add a killer GM time threshold for running waypoint competitions, default: 60s. Craft that don't pass a waypoint within this time are killed off.
	- Adjust the camera selection to favour craft near their max speed during waypoint races.
- RWP:
	- Season 5, Round 5:
		- Only clamp, not set, the maxBank and maxSpeed to the limits.
		- Add drag to kerbals when exceeding 605m/s, scaling with the amount of overspeeding, to bring them back into line with the limit.

v1.5.9.2
IMPROVEMENTS / FIXES
- AI:
	- Fix incorrect terrain avoidance critical angle conversion (degrees vs radians).
	- Add a slider for setting the control surface deployment time used for terrain avoidance and reduce the amount the control surface deployment time affects the terrain detection distance.
		- Note: the default is now lower than it was before and lowering it further can significantly reduce the terrain avoidance distance for highly manoeuverable craft.

v1.5.9.1
IMPROVEMENTS / FIXES
- General:
	- Adjust how PartsBlacklist.cfg is read/written to merge the defaults with any existing custom values.
	- Fix known exceptions and NaNs.
- Weapons:
	- Use the combination of DEBUG_LINES and DEBUG_WEAPONS for showing the targeting component debug lines instead of only having them in the debug build.
	- Further tweaks to the aim assist targeting reticle to account for the floating origin.
	- Missiles/Bombs now arm their warheads when they reach a safe distance from their launching craft, to prevent anti-missile systems fragging craft by detonating ordnance immediately after launch.
- UI:
	- Add a toolbar button for the BDA Vessel Mover.
	- Make window states persistent across scene changes.
- Competition:
	- Remove drag from seated Kerbals in the Waypoint race gamemode.
	- Repulsor craft now spawn horizonally instead of nose down.
- RWP:
	- Enable various RWP S5R5 overrides to settings.
		- Max speed fixed at 600m/s.
		- Min altitude clamped to below 50m.
		- Max altitude enabled and set to 100m.
		- Max bank fixed at 40°.
		- Post-stall AoA fixed at 0°.
		- Independent throttle disabled.
		- Global lift multiplier increased to 0.1 from 0.036.

v1.5.9.0
IMPROVEMENTS / FIXES
- General:
	- Blacklist the PotatoRoid due to it not having a valid prefab (they get procedurally generated) and causing NREs.
	- Add try-catch around setting the gear action group due to the FSM sometimes breaking it and breaking pilot initialisation.
	- Remove HP rounding and lower HP limit for MM-patched parts. Apply health modifier after applying rounding and lower HP limit for non-MM-patched parts.
	- Add Infinite Propellant and Infinite Electricity Gamemode toggles to BDA settings menu.
	- Some minor debug message cleanup.
	- Updated German localisation from EzBro.
	- Add Vessel Mover functionality directly in BDA:
		- Spawning:
			- Choice of classic or custom vessel selection:
				- Classic is the built-in vessel selection window (slow to load, but gives more details).
				- Custom is faster and remembers the scroll position.
			- Crew selection (optional):
				- The chosen crew are added to the spawned vessel in the order selected, up to the capacity of the vessel.
				- If the "Fill Seats" option in the Vessel Spawner window is set to "Minimal", then only the selected crew are used, otherwise the remaining crew slots are filled with random kerbals.
				- Option to create or remove kerbals from the roster (excluding Jeb, Val, Bill and Bob).
			- Spawning uses BDA's spawning routines:
				- Corrects for badly sorted part trees in craft files.
				- Mostly fixes staging sequences (some parts, such as parachutes, still don't stage properly).
				- Aligns craft with terrain/scenery normals based on control point orientation and facility the craft was built in.
				- Default spawn orientation matches that of the KSC runway or launchpad, depending on which facility the craft was built in.
		- Moving:
			- Movement and rotation speeds scale with altitude instead of at preset speeds.
			- Movement and rotation have a ramping up period to allow for fine adjustments.
			- Movement automatically maintains altitude AGL but will adjust to avoid buildings and other craft.
			- Movement coordinates are relative to the local coordinate frame with forward aligning with the camera. In map mode, forward is aligned with north.
			- Tab/Shift+Tab jumps to preset altitudes (50km, 10km, 1km, 100m, 10m / minimum safe), 'x' jumps to the minimum safe altitude, other keybinds are the same as for the VesselMover mod (see the help button).
			- Vessels are lowered to the terrain and then eased in for up to 10s to allow them to settle.
			- Vessels can be dropped.
			- Option for setting the minimum lowering speed.
			- Options for enabling brakes/SAS when lowered.
			- Option for placing vessels on terrain below water (also affects terrain following while moving).
			- Option for placement-lowering (jump to safe height, then lower the rest of the way).
			- Option for not worrying about colliding with stuff (for getting really close to things for screenshots).
			- Movement indicator scales with the vessel's radius (+2m).
		- Movement and spawning don't require the active vessel to be landed.
		- Includes a button to recover the active vessel (i.e., remove it) from flight.
		- Doesn't conflict with the VesselMover mod, but actively using both at the same time may cause weird interactions.
		- Limitations:
			- Sometimes, when moving beyond the limits of PRE, KSP can break due to automatic vessel switching.
			- If the mouse is over a window when moving, the camera often lags behind (this is likely due to krakensbane and may be fixable).
			- The camera may act weirdly if CameraTools is enabled while moving a vessel (also likely due to krakensbane).
- UI:
	- Add a keybind for targeting the next GPS target.
	- Add labels to the vessel switcher score entries for rockets, missiles, rams and tag.
	- Parts with zero lift now appear as grey in the lift visualizer.
	- Fix issues with wing stacking calculation. Calculation now returns ratio of non-separated vertically stacked lift area to total lift area (capped at 100%). Wings spaced sufficiently apart will not contribute to the stacking value.
	- Add option "Camera Switch: Incl. Missiles" to switch to and follow a missile fired by the active vessel until it explodes or misses (requested from FJRT, requires CameraTools v1.27.0 for optimal behaviour).
	- Add whitelist option for guns/rockets/lasers to report hits in the competition marquee.
	- Fix manual aim assist UI placement for fixed weapons.
- AI / WM:
	- AI will start evading missiles once the missile engine activates instead of waiting for 1 second after launch.
	- When orbiting, adjust altitude for terrain variation when below 1000m and account for terrain in the way when below 500m.
	- Remove the 'premature dive fix', which causes weird flight behaviour when flying inverted.
	- Terrain avoidance improvements:
		- When avoiding terrain and roll is inverted by more than the critical angle (default 120°), reverse the roll target so that terrain avoidance is done while fully inverted and enable Aiming steer mode for more yaw control.
		- Remove the terrain avoidance cool-down period for faster recovery after avoiding terrain.
		- Restrict the avoidance radius (default is twice the "radius" of the vessel) to the min altitude to allow cruising at min altitude despite without triggering terrain avoidance.
		- Include all detected colliders in the terrain avoidance path and use a weighted average of normals to determine the appropriate terrain avoidance direction to fly (this helps with avoiding buildings).
		- Remove the secondary raycast for upcoming terrain as it doesn't seem necessary and is doubtful it was helping.
		- Adjust the max deflection for avoiding terrain to be based on the maxAoA clamped to within 45° and 70°.
- Armor / Materials:
	- Steel Hull Material melting point increased.
	- Fix issue with armor panels potentially spalling away more than the entire volume of the plate and getting instantly deleted.
- Countermeasures:
	- Add selection priority to countermeasures to allow staggering of dropping countermeasures — higher priority CM dispensers trigger first.
- GameModes:
	- Add ability to disable cornering multiplier when using space hacks by setting it to 0.
	- Space Friction no longer applied to root part at the position of the CoM; large craft whould have an easier time turning now.
- Weapons:
	- Weapon burst length/fire angle overrides now respect symmetry.
	- Fix heatseeker missiles fired from relaodable rails occasionally losing lock on firing.
	- Fix NRE spam when trying to fire Modular Missiles.
	- Fix NRE when firing Modular Missiles and Missile Icons are enabled.
	- Modular Missiles will use RCS when fired in space.
	- Heatseekers now target the hottest part on a craft, not the CoM.
	- Fix HE beehive ammo submunitions not exploding on hit.
	- Re-add HE ammo option to Oerlikon Millennium turret.
	- Fix some issues with Explosion damage calcs, HE damage is now consistant regardless of hit location.
	- Fix ammo count in WM GUI for reloadable missiles.
	- AI will now properly respect per-missile engage range when selecting and firing missiles of the same type.
- Competition:
	- Add toggle for setting maxAltitude and GM Kill limits to ASL or AGL.
	- Add Kill timer for GM Altitude to give violators a chance to get back to safe altitude instead of immediate kill.
	- Add customisable fields for the intra-team separation conditions when starting competitions (default: 800m + 100m per member) (FJRT request).
	- Add a per-round PVP score parser.
	- Fix accuracy calcs when using beehive ammo.
	- Fix vessel spawn altitude if RWP slider is set but not the RWP toggle.
- RWP:
	- Fix issue causing the web API to not report scores.
	- Tag heats run via the web API with competition, stage and heat numbers in the file names.

v1.5.8.0
IMPROVEMENTS / FIXES
- General:
	- Fix Firebottle mass not resetting if a part switched from fueltank to structural.
- UI:
	- Fix layout of vessel switcher window buttons and version label.
	- Add debug button when DEBUG_OTHER is enabled for dumping part info.
	- Add a 'Start competition automatically' button to the Vessel Spawner window for use with 'single spawn'.
	- Updated German localisation from EzBro.
	- Fix some AI GUI infotext.
	- Clean up ordering and consistency in the AI GUI and in-flight WM windows.
- Competition:
	- Tweaks to sequenced competition start-up to allow a single plane to perform the sequence despite not having enough teams for a competition.
	- Add an option to save the image from plot_summary.py with a transparent background.
- AI / WM:
	- Fix max collision avoidance strength in AI GUI.
	- Fix NRE when adjusting autotuning fields in the SPH.
	- AI will no longer dive into missiles approaching from directly below.
	- Reset the auto-tune PID values to the best ones when lowering the learning rate.
	- Add a keybind for arming/disarming the WM.
- Detectors
	- Fix radars/IRSTs with ability to detect/lock targets with a signature of 0 not being able to detect/lock targets with a signature of 0.
	- Fix a division by zero in the standoff jamming effect calculation when the radar signature is 0.
- Weapons:
	- Fix bug in nuke impulse calculation and some NREs.
	- Fix turrets on non-active vessels following the mouse unless Remote Firing enabled.
	- Fix missiles fired from reloadable rails resetting missile settings on Launch/Spawn.
	- Add new engineFailureRate (default is 0, max is 1) config file variable for missiles. This is the probability the missile engine will fail to start. It is evaluated once on missile launch.
	- Add new guidanceFailureRate (default is 0, max is 1) config file variable for missiles. This is the probability per second the missile guidance will fail (0-1). It is evaluated every frame after launch.
	- Add new fuseFailureRate (default is 0, max is 1) config file variable for BDExplosivePart modules. This is the probability the explosive fuse will fail. It is evaluated once when an explosive attempts to detonate.
- RWP:
	- Reset the killer GM between competitions and don't enable the killer GM for S5R3 (the altitude limit is still active).
	- Add option to have Pwing mass and HP scale with thickness.

v1.5.7.0
IMPROVEMENTS / FIXES
- General:
	- Add option in BDA settings menu to set a max HP limit for parts.
	- Armor Tool in the VAB/SPH renamed to BDA Craft Utilities Tool.
	- Added experimental 0-100% indication of stacked lift surfaces to the BDA Craft Utilities Tool.
- AI / WM:
	- Fix bug in collision avoidance that sometimes resulted in more collisions between teammates.
	- Add action group to the WM for removing EVA kerbals' helmets (once the vessel becomes the active one).
	- Re-centre between epochs during auto-tuning if the vessel drifts more than 15km from the start position.
- Detectors:
	- Fix anti-aliasing settings affecting craft RCS. Craft will have consistent RCS regardless oF MSAA settings, note that craft may have slightly different RCS across different GPUs/graphics APIs.
	- Adjust RCS scaling value to give 1 m^2 cross-section for a 1 m^2 cross-section sphere (a 25% increase). This setting was most likely previously set with MSAA enabled, so it was set incorrectly.
- Weapons:
	- Fix a bug in bullet hit calculations within the initial bullet offset distance.
	- Fix AP rounds not penetrating rear side of parts they penetrate.
	- Beehive ammo deployment range now adjustable.
	- Fix ExplosionFX spawnpoint for Shaped Charge bullets.
	- Some fixes to nuke behavior in space.
- RWP
	- Update NPC Swap code to work with current web API.
	- Orbital deployment moved to Runway Project Round S5R3.
	- Fix AIs chasing GM killed planes.
	- Runway_Project toggle now sets all control surface actuation speeds to 30 deg/s.
	- Re-implement PinataMode - Craft will spawn on the same team in a circle around a Pinata craft, FFA begins when Pinata dies.
		- Use settings.cfg field PINATA_NAME to set name of pinata craft. Craft should be in same autospawn dir as the rest of the craft for the competition.
	- Sequenced Competitions now work with Web orchestration.

v1.5.6.2
IMPROVEMENTS / FIXES
- General:
	- Fix kerbal flags exploding from overheat when placed.
	- Add some missing parts to HPFixes patch.
- UI:
	- Fix IRSTs not responding to Radar Display hotkeys.
	- Fix Radar Analysis Window Radar select UX.
- AI / WM:
	- Add 'Random Part' subsystem targeting option.
- Weapons:
	- Nukes now work in space again.
	- Fix IR missiles not locking on when manually firing.
	- Fix Lasers not hitting missiles.
	- Tweaks Oerlikon Millennium turret to improve missile interception ability, reduce lag.
	- Add frontAspectHeatModifier variable to missile definitions, explained further in sidewinder.cfg. Allows you to create IR missiles that behave more like early IR rear-aspect/tail-chase missiles.
	- Remove the clamp on heat signature drop-off with range above 6 km. Prior to this change, any heat signatures more than 6 km away were capped at their 6 km value.
- RWP
	- Add option for setting NPCs to a single team to Settings.cfg - REMOTE_ORC_NPCS_TEAM = [Teamname]. Leave blank for FFA NPCs.

v1.5.6.1
IMPROVEMENTS / FIXES
- Fix issue causing radars to return a cross-section of 0.0 for all craft.

v1.5.6.0
IMPROVEMENTS / FIXES
- General:
	- Russian localisation thanks to user Akteon_.
	- Add missing part localizations for radomes and combat seat.
	- Fix EVA kerbals not always deploying their parachutes properly with Kerbal Safety enabled.
	- Fix part costs for materials with cost modifiers equal/greater than 1.
- UI:
	- Show the lift information even when the reset armour toggle is enabled.
- AI / WM:
	- Allow selecting which fields to auto-tune in the AI GUI. (Fixed-P option removed from the PAW.)
	- Show the best loss value in auto-tuning.
	- Log the latest best auto-tuning values to the KSP.log even without debug AI enabled.
	- AI will now try to recover from flat spins by idling engines and pointing nose downward.
	- Allow damping values to go down to 0.1 instead of 1.
	- Prevent the AI GUI from rounding slider values when not adjusted by hand (e.g., during auto-tuning).
	- Craft with empty Multimissile launchers will now properly go into ramming mode (if enabled) if no other weapons.
	- Make the burst fire override respect the firing interval.
- Weapons:
	- Add a stagger option to barrage mode that fires barrages in bursts and adds variability to the reload times. Mostly only suitable for slow-firing ship guns.
	- Hellfire/EMP Hellfire now better differentiated in Weapon Manager selection list.
- Competitions:
	- Add a --no-header option to the tournament parsing script.

v1.5.5.1
IMPROVEMENTS / FIXES
- Fix NRE in trajectory sim.
- Fix active vessel not firing under AI control.
- Fix firing of missiles via hotkey not respecting ripple/single setting.

v1.5.5.0
IMPROVEMENTS / FIXES
- General:
	- Add a --tsv option to the n-choose-k parsing script to output a TSV file instead of a CSV file.
	- Tweaks to scroll-zoom prevention.
	- Exclude weapons from the bounds calculations as they sometimes give weird values (e.g., lasers when firing).
- UI:
	- Add an option in the UI settings for disabling scroll-zoom prevention when over BDA windows.
	- Add version watermark to Competition UI and Vessel Switcher window.
- AI / WM:
	- Fixes for Stationary surface vessel mode.
		- No longer panics, even if airborne (allows for floating/free-fall turrets).
		- Attitude control (using RCS and reaction wheels) is applied when an enemy is within the engagement range.
	- Add 'Target Damage' Target Priority setting.
	- Add keybindings for "Next Weapon", "Prev Weapon" and "Fire Missile" in the WM (keybindings for firing guns are on the weapons).
- Detectors
	- Some optimizations to the ECMJammer code.
	- Active jammers now appear on Radar Warning Receivers.
- Armor:
	- Fix stack overflow in ToggleScaleClamp for symmetric parts.
	- Further fixes for post-penetration bugs.
- Weapons:
	- Remove the extra delay from dropping the final countermeasure in a sequence.
	- Fix non-damaging lasers not scoring.
	- Tightened up firing angle when using subsystem targeting; AI will now fire when subsystem part is within angle, not entire vessel.
	- Fix missing NukeFX Flash.
	- Fix the targeting reticle placement at very short range.
	- Add a custom fire keybinding to weapons that can be used to temporarily enable and fire weapons with keys other than the main firing key.
		- Click the toggle on the weapon PAW, then press the desired button. Left click to cancel, escape to clear.
	- Add an action group for jettisoning rocket pods and toggle deployable rails.
	- Fix the trajectory simulation and targeting reticle placement for rockets.
- Spawning:
	- Allow a specific list of observers to be excluded from being removed during spawning and competitions.
	- Allow spawning custom templates with only 1 team if not immediately starting a competition.
	- Allow spawning non-valid craft via the custom spawn templates if not immediately starting a competition.
- RWP:
	- Fixes for remote orchestration.
	- Improvements to Spacehacks repulsor code; will no longer shred landed ships.
		- Landing gear will now serve as repulsors when Repulsor mode is enabled instead of effect propagating through CoM, should result in more stable hovercraft.

v1.5.4.1
IMPROVEMENTS / FIXES
- General:
	- Fix a crash-to-desktop due to firing missiles with action groups but without a WM.
	- Add a 'recentlyFiring' property for CameraTools that checks all guns for having fired recently (instead of just the current one) and for having fired a missile recently. Make the camera vessel selection use this too.
	- Internal fixes for hull/armour/HP setup logic.
	- Fix Rocket and 25mm Ammo box HP.
- AI / WM:
	- Fix not finding the AI in the SPH for the AI GUI.
- Weapons:
	- Don't activate all engines on modular missiles when firing them, leave it up to the configured action groups.
	- 0 damage beam lasers will no longer cause battledamage.
	- Adjusts post-penetration calculations to prevent non-physical penetration/bullet mass adjustments.
- Spawning:
	- Spawner will now spawn craft facing inwards if spawn distance is larger than competition distance.
- Armor/Hull:
	- Armor Tool Hull Visualizer now displays all materials, not just Wood/Al/Steel.
	- Aluminium armor plates now register their mass for Total Armor cost/mass in the Armor tool.
	- Fix issue with parts using custom materials with greater than stock maxTemps still exploding at stock maxtemp.
	- Add crashTolerance modifier to hull materials.
	- Fix Hull Material modifiers not applying in Flight.
	- Add user-customizable exclusion list (BDArmory/PluginData/PartMaterialsBlacklist.cfg) for IgnoredParts/parts that shouldn't have material options.
	- Fires from incendiary rounds igniting flammable parts now generates heat if BD FIRE_HEATDMG enabled.
- RWP:
	- Add Min Altitude Increases on Death game-mode.

v1.5.4.0
IMPROVEMENTS / FIXES
- General
	- Fix Structural Pwing causing vessels to explode in flight.
	- Fix Structural Pwing still shifting CoL sphere in SHP/VAB.
	- Structural Pwing moved to structural tab.
	- Rework the BDGUIComboBox.
- Armor / Hull:
	- Setting material to wood and then back to Al/steel now properly resets maxTemp to default.
	- Expanded Hull material functionality; users can now implement custom hull materials, similar to how the current armor system works.
		- Adds new BD_Materials.cfg
	- LEGACY_ARMOR toggle now properly sets armor panels back to having BDAc-era HP amounts.
- AI / WM:
	- Allow kamikaze ramming of ground targets by overriding terrain avoidance and min alt behaviour when on final approach.
	- Improved cornering by only reducing throttle to match speed when in aiming steer mode and increasing the max speed clamp for tight cornering when at higher AoA.
- Spawning:
	- Custom Spawn Templates
		- Set up your desired template by spawning vessels with VesselMover (or otherwise) and assigning teams.
		- Create a new template from the current configuration or save over the current one.
		- Edit the templates directly in BDArmory/PluginData/spawn_templates.cfg to adjust headings, etc.
		- Load/delete existing templates.
		- Assign vessels and specific kerbals to the template's slots, then spawn and start a competition without having to muck around with VesselMover or the "turning bug".
- Radar:
	- Fix Radar GUI display range for datalinked radars.
	- Fix IRST being unable to activate VRD without a radar enabled.
- UI:
	- Fix the internal GUI rects being updated properly and add option to disable their visibility to the mouse.
	- Scroll-zoom prevention while the mouse is over BDA+ windows.
	- Fix various Armor Tool functionalities.
	- Fix accuracy readout when Telemetry debug option enabled.
- Weapons:
	- Add a penetration depth stat to weapons' partmenu infocards.	
	- Adjustments to post-penetration for high-velocity projectiles near L/D = 1.
	- Fix Barrage rate of Fire for multi-barrel weapons with a singe fire animation.
	- Fix Gravity gun (and other 0 damage lasers) annhilating their target/crashing the game.
	- Weapons that only use ECPerShot (requestResourceAmount = 0) now properly fire again.
	- Adds new field to bullet definitions [subProjectileDispersion] to allow setting custom dispersion cone for shotgun/beehive ammunition.
	- Beehive ammo explosive submunitions are now properly explosive.
	- Fix weapons nulling current target and throwing off lead offset calcs on vessels with long TargetScanIntervals.
	- Missiles:
		- Missiles/bombs in a salvo no longer fratricide each other when the first one detonates.
		- Add launch offset param to MultiMissileLauncher.
		- Fix MMLs unable to fire if using salvos smaller than total launcher count.
		- MML salvoes now add one missile away per target fired on, not just primary target.
		- MML missiles no longer labeled as [vesselname] debris when using Missile icons and Vessel Label UI Icon options.
		- Fix mass for MultiMissileLauncher rails.

v1.5.3.1
IMPROVEMENTS / FIXES
- Spawning:
	- Only spawn SpawnProbe for dead current vessel if spawning is aborted.
- AI / WM:
	- Fix AoA limits above 90° not behaving as expected by only limiting the AoA if the limit is below 90°.
	- Add an Afterburner Override Threshold slider (force AB active below this speed threshold if at full throttle).
	- Add a post-stall AoA threshold for switching flight-mode when beyond this threshold.
- Weapons:
	- Fix weapons with startup/shutdown animations getting stuck, preventing them from firing.

v1.5.3.0
IMPROVEMENTS / FIXES
- General:
	- Use an alternative method of calculating vessel bounds to get the vessel radius. — Fixes some weird results with parasite fighters from KSP's internal function for this.
	- Missile and countermeasure settings are now accessible in the Gameplay Settings section of the BDA Settings menu.
	- Animate animations in the physics update so that they work with time-scaling.
	- Localisation corrections/updates. Also in German.
	- Lots of optimisations.
	- Add Notes.md for devs with notes on optimisation and the current branches.
	- Add caching for all AudioClips to reduce GC.
	- Optimised access to Krakensbane and FloatingOrigin adjustments.
	- Fix proc structural panel, now properly no longer has lift.
	- HP log scaling now on by default when RUNWAY_PROJECT is enabled.
- UI:
	- Updated German localization by EzBro.
- Competition:
	- Add option to automatically disable the HUD on tournament start.
	- Fixes nukes causing hit craft to be reported as 'Crashed and Burned' in competitions.
- Spawning:
	- Fix spawning breakage due to PRE not being enabled and enable PRE checks and warnings during spawning.
	- Recover KSP's camera after spawning failure.
- Damage:
	- Fix the bug preventing explosive damage applying to buildings.
	- Rework how damage is applied to buildings and how they regenerate.
	- Add a building damage multiplier.
	- Fix reverse raycasts that were using the wrong rays.
	- Fix detonate direction in BDExplosive part, missiles/rockets with ContinuousRod/ShapedCharge warheads should now have properly oriented AoEs.
	- EMP warheads can now be set to be hard/soft EMP in their configs.
- AI / WM:
	- Add a "Debug Extending" button when AI debugging is enabled that prints extending debug info when clicked if the active vessel is extending.
	- Fix GPS missiles not obeying max missile per target setting when the target is traveling at high speeds.
	- Add an Extend Abort Time slider to the AI, where the AI will abort extending if it fails to gain distance for this amount of time. (Note: this isn't a pure timer; while not gaining distance the timer increases, but will otherwise reduce to 0 at half the rate.)
	- Add a 5s cooldown on extending if the Extend Abort Time is triggered (overriden for various extend requests, e.g., dropping bombs/nukes).
	- Dynamically update the extend distance for launching a missile while extending.
	- Limit the DLZ calculation for the extend distance for firing missiles to being maxOffBoresight off-target - avoids extreme extending distances.
	- Expand the WM's Self-Destruct AG to arm and detonate all explosive parts too.
	- Adjust the smoothing for the AoA and G-load limiting from a moving window (with a ~0.6s delay) to double exponential smoothing (with a ~0.1 delay compensated for by a 0.1s ahead prediction).
		- Note: this doesn't fix AoA/G-load limiting, it just improves the response time of its calculations.
- Detectors:
	- Random position noise due to chaff no longer scales with RCS, is instead fixed to a random number between 16 and 256.
- ECM:
	- ECM Jammer and Cloaking devices now can specify resource used when operating (default is EC).
- Weapons:
	- Fixed bug where the target velocity and acceleration was not being reset once a target was no longer tracked which resulted in lead being erroneously compensated for while mouse aiming.
	- Added ability to manually aim guns using GPS coordinates, primarily for artillery. This behavior is not a functionality in Guard Mode, however when a GPS target is manually selected, turrets will now aim to attempt to hit said target.
	- Improved shaped charge warhead behavior, now armor penetration and beyond-armor effect is much more realistic.
		- Warheads now approximately match real-world penetration performance, given the warhead size and caliber are accurate. Dual-purpose and other multi-function warheads will overperform as the equations assume all of the warhead is a shaped charge. Older and larger warheads may also overperform due to modelling being based on modern warheads.
	- Fixed issue with missile and rocket warheads where direction of blasts were not along the directions of their warheads.
	- Added "caliber" field to the BDExplosivePart module, it's an optional field for shaped charge projectiles which influences its effectiveness.
	- apBulletMod now influences shaped charge projectile penetration, modifying this allows for the penetration of shaped charge shells to be tweaked.
	- Added optional "apMod" field to the BDExplosivePart module, it's functions the same way as apBulletMod for bullets and its primary purpose is to allow users to create dual-purpose shaped charge warheads, where part of the tntMass of the warhead isn't going into the shaped charge effect, reducing penetration.
	- Added optional "apMod" field to rocket configuration file. This allows tweaking of rocket penetration, functioning the same way as apBulletMod for bullets, affecting physical armor penetration as well as shaped charge armor penetration if the rocket is equipped with a shaped charge warhead.
	- Armor protection against explosions is now influenced by angling, angling armor now makes it more difficult for the blast to punch through the armor plate.
	- Added global setting that allows for tweaking of armor effectiveness against explosion blast penetration. The higher the setting, the harder to damage parts behind armor plates via blast damage.
	- Tweaked several missiles, bullets and rockets to reflect the new shaped charge mechanics:
		- RBS-15 and RBS-15AL have had their warheads decreased from 300 kg to 200 kg to reflect their real counterparts. Added caliber field, set at 500 mm.
		- AGM-114R Hellfire missile has had its warhead decreased from 12 kg to 8 kg, with a 172 mm caliber to reflect performance estimates of earlier known models of the Hellfire. Warhead may not match -114R performance.
		- AGM-65 Maverick missile is set to have a 305 mm caliber and an apMod field added with performance set to 950 mm of penetration. No good estimates of the warhead penetration were found so an approximate estimate based on a 27 kg charge was used.
		- BGM-71 TOW missile has had its warhead decreased from 10 kg to 3.9 kg and has a 152 mm caliber to be around TOW/ITOW performance.
		- Hydra-70 has had its penetration tweaked with apMod to match estimates of the M151 HEDP warhead penetration performance.
		- AGM-86 now has caliber field, set to 620 mm.
		- Adjusted 120 mm HEAT and AP rounds to have around the same amount of penetration, balanced for gameplay (210 mm / 216 mm). Realistic configs also exist under the names "120mmBulletHEAT" and "120mmBulletSabot", a commented out line in m1Abrams.cfg can be uncommented in order to use these.
	- Offset beam-riding missile laser to the right and up from the targeting camera to mitigate issues of the camera locking on to its own missiles when on CoMLock mode, causing the targeting camera to drive missiles into the ground. Mostly affected Guard Mode behavior.
	- Fixed missile behavior with Detonation Distance set to 0, missiles should no longer phase through armor.
	- Reworks ModuleMissileRearm, now works, integrated with WM, etc.
	- Missiles with a ModuleMissileRearm can now have reloads, be affected by Infinite Ammo.
	- Adds MultiMissileLauncher module.
	- Adds new Infinite Ordnance toggle, for missiles with ModuleMissileRearm/MultiMissileLauncher.
	- Fixes NRE with APS missile interception.
	- Inaccurate or multi-shot APS (CIWS rotary cannon, etc) no longer guaranteed to kill incoming projectiles with first shot.
	- Fixes Max Turret Targets not targeting more than 2 vessels.
	- Fix Gravity gun and other impulse/gravitic laser weapons dealing damage.
	- Fix manual rocket turret aiming.
- Armor:
	- Improved hypervelocity projectile post-penetration effects. Now Whipple shields should work properly, the more spacing between the armor plates the better the performance against hypervelocity rounds.
	- Modified behavior of penetration formula below a projectile L/D ratio of 1 so penetration values are more consistent.
	- Re-added temperature effects to armor protection levels, if the armor reaches its max safe temperature or goes above said temperature, performance is degraded.
	- Added new Armor Aluminium material, based on Aluminium 7039 to provide a larger variety of armor materials to select from.
	- Adds Armor Mass Mult slider to allow tweaking armor weight in-game.
	- Armor Type "none" now disabled armor thickness slider, should fix PAW issue with 1.9.1 installs.
	- Armor Tools now displays total wing srf. area, and wingloading kg/m2.
	- Fix Armor tools mass/cost readout giving incorrect values when using global armor type.
	
v1.5.2.1
IMPROVEMENTS / FIXES
- Fix a variety of exceptions in pre-1.11.1 KSP due to missing API functions.
- Allow deploying to multiple KSP instances when compiling in Linux (add the extra KSP locations as lines in the ksp_dir.txt file).

v1.5.2.0
IMPROVEMENTS / FIXES
- General:
	- Fix packaging issue in recent releases that contain incorrect capitalisation of certain files and folders.
	- Adjust capitalization of "sounds" folders for parts to be consistent.
	- Fix memory leaks caught by KSPCF.
	- Make wheels susceptible to bullets and explosions too.
	- Fix off-centered arrow on inline radome texture Git Issue #409
	- Re-fix lead issue on Apple Silicon.
	- Adds optional adjustable Logarithmic HP clamp, replacing the Proc Part Max HP slider.
	- Adds optional toggle to disable lift from colliderless PWing edges for better balance with stock wings/prevent pwing abuse.
	- Apply the gapless particle emitter option to 'DecalGaplessParticleEmitter's too.
	- Add Attachnode to the Ordnance bay to fix issues with Breaking Ground Robotics.
	- Adds debugging messages to assist with making custom weapons.
	- Adds MM patch to add liftless Proc Structural Panel if B9 Pwings installed.
	- Reduce frequency (hopefully to none) of null FX object pool entries by catching unloading events too and triggering OnJustAboutToBeDestroyed before recovering vessels.
	- Allow use of the combat seat as the root part.
- UI:
	- Fix exception when resetting colours in Team Icons.
	- Prevent the kill timer from showing in the Loaded Vessel Switcher window for surface vessels.
	- Updated German localization by EzBro.
	- Adds Accuracy readout to the Weapon Debugging telemetry.
	- Setting the Armor Type to 'None' now disables the armor thickness slider; fixes PAW issue in KSP 1.9.1 installs.
- Competition:
	- Fix exception in auto-resuming tournaments when SpawnProbe.craft isn't found.
	- Fix incorrect Kill Steal attribution from 1v1 fights.
	- Abort competition if a team leader still isn't ready to engage (airborne for pilot AI) by the time the start-competition-now timer runs out.
	- Fixes AI/WM not attached to Root Part warning messages on competition start when using combat seats as the root part in RWP.
	- Add option to start competitions despite failures occuring. For tournaments, this only applies after the third attempt fails.
- Spawning:
	- Wait until after vessels are unpacked before reverting the spawn camera - fixes an exception with EVA kerbals and KSPCF.
	- Fix freezing when vessel removal throws an exception.
	- Account for wheels protruding into the ground during instant lowering of vessels.
- GameModes:
	- Space Combat Tools:
		- Better implement SpaceFriction initialization at round start.
		- Fix AI sometimes limiting to idle speed instead of max speed in space.
		- Add limits to prevent G/AoA limiter returning infinity values in space.
	- Battle Damage:
		- Add selfsealing options to Monoprop tanks.
		- Tanks using B9PartSwitcher for fuel switching now get selfsealing options.
- AI:
	- Fix incorrect inputField for off-target dynamic roll damping.
	- Fix RippleIndex Errors from weapons overheating/reloading.
	- Fix AI ignoring max missiles per target setting for GPS missiles
	- Spaceborne pilotAIs will now dodge via RCS translation.
	- Craft with guard mode enabled now automatically receive radar contacts via the datalink from friendlies if they have an onboard radar that can receive radar data (canReceiveRadarData = true in part).
	- Corrections to aiming at orbital speeds and long distances (for deep space combat).
		- Caveats:
			- There is a discontinuity in the way KSP handles floating origin/Krakensbane adjustments at 100km above each world that can adversely affect trans-100km orbit aiming slightly (high bullet speeds mostly negates this).
			- KSP won't load surface vessels when the current vessel is over ~90km (on Kerbin) for some unknown reason despite a sufficient PRE range, so orbital bombardment only works from LKO.
			- The targeting reticle currently isn't being correctly placed when manually aiming at closeby targets (will be fixed later).
- Detectors:
	- Fix IRST preventing Radar GUI close.
	- Fix NRE in targeting camera when the camera parent transform is null.
	- Re-work IR occlusion to look at engine and engine plume heat for non-prop engines, weight parts by mass and proximity to heat source for occlusion, and incorporate occlusion from the engine outside of a 50 deg angle of the engine exhaust.
	- Correct spelling of "receive" (and variants) and adjust BDA parts that use "canRecieveRadarData" to use "canReceiveRadarData" instead ("canRecieveRadarData" is retained for compatibility, but other mods should make this adjustment!).
- ECM
	- Radar missile position distortion due to chaff now relies on the ratio of ECM jammer strength to craft signature with RCS reduction to bias the position distortion from chaff to further behind the craft. Net effect is craft with jammers, and especially low RCS craft with jammers, will have an easier time evading radar missiles.
	- Lockbreak from jammers now affects RCS with RCS reduction instead of base RCS. Craft can now mix RCS reduction parts and jammers to break locks without worrying about them conflicting.
	- Incorporate stand-off jamming effects. Friendly craft with jammers now result in your craft being harder to detect and lock. Strength of this effect is determined by the lockBreakerStrength of the friendly jammers, relative distance of friendly jammers (friendly jammers closer to enemy will have a stronger effect), and if the jammers are close in field of view for the enemy (friendly jammers in same field of view will have a stronger effect). Debug readout is available by enabling the Detectors debug option.
	- AI no longer will turn off jammers automatically if they were manually enabled prior to being turned on by the AI.
- Weapons:
	- Fix FXLookAtConstraint modules on various turrets.
	- Fix incorrect charge sound path for lasers.
	- Make the ABL use proper looping audio and add a cool-down sound.
	- Fix the ABL laser beam continuing to show while overheated when used manually.
	- Fix for NRE when heatseeker is manually selected prior to activating guard mode.
	- Fix Weapon manager PAW engagement options not affecting AI weapon selection in flight.
	- Missiles and nukes will now properly play their explosion sound effects.
	- AI controlled turrets will no longer return to rest position when overheated/reloading.
	- Fix terminal heat guidance for missiles, including not being decoyed by flares.
	- Improve consistency of anti-radiation distance target check.
	- Add paramater gpsUpdates for GPS guided missiles. gpsUpdates >= 0 in the missile config will allow the missile to get position updates of the target from the craft that launched the missile (if it can still see the target) every gpsUpdates seconds.
	- Corrections to tracer placement and alignment at orbital speeds (for deep space combat).
		- Note: Enable "Vessel-Relative Bullet Checks" when at these speeds for correct collision checks between bullets and vessels. Disable it at lower speeds as it can be a CPU hog.
	- Fix delay/penetrating fuze rounds sometimes not detonating.
	- Penetrating rounds now register damage to all parts they hit, not just first.
	- Fix 'Weapon requires EC' message spam if active vessel is not the one with the weapon in question.
	- Weapons using ECPerShot now only drain ElectricCharge if the vessel has sufficient EC to fire the weapon.
	- Use the explosion models and sounds given in MissileLauncher if none are specified in BDAExplosivePart.
	- Adds Active Protection System implementation.
		- Adds new fields: 'isAPS = T/F', 'APSType = [ballistic, missile,omni]'.
		- Adds new Settings.cfg field 'APS_THRESHOLD = n' to set threshold bullet/rocket size for interception.
- Armor:
	- Adjusted post-penetration behavior of high velocity rounds, rounds now erode instead of slowing down at high velocities.
		- Multi-plate armor schemes now behave more realistically and will require more careful material selection and configuration.
		- Whipple shields for hypervelocity rounds are now viable and desirable. This behavior is however still very crude and does not qualitative match realistic behavior.
	- Adjusted stats for S-Glass and Kevlar materials to have realistic RHA equivalency.
		- Re-implemented Tate-Alekseevksy equation for low-ductility materials.
	- Added debug console output for armor penetration behavior. Now when Debug -> Armor is on, console will output armor penetration parameters.

v1.5.1.2
FIXES
- Fix adjustable armor unclamped scaling.
- Loosen distance checks for anti-radiation missiles fired at fast-moving targets (fixes instances when AI would not fire anti-radiation missiles at fast-moving targets).
- Fixes for some issues occuring on KSP 1.9.

v1.5.1.1
FIXES
- Fix AI not firing anti-radiation missiles at targets detected via RWR.
- Fix KeyNotFoundException error in weapon selection code.

v1.5.1.0
IMPROVEMENTS / FIXES
- General:
	- Remove the "-pre" from the version string, fix some typos.
- AI:
	- Allow a vessel that's lost parts after launch to still be auto-tuned.
	- Don't reset the assigned fly-to position when arriving at an orbiting point so that planes actually orbit the targeted point.
	- Resume various pilot commands if interrupted once the cause of the interruption is removed.
	- Adjust the fly-to point's altitude closer to the default altitude when at longer ranges so planes with higher default altitudes will attack from above and vice-versa.
	- Reduce the half-life of the velocity smoothing for the turn radius calculation to allow faster updates for terrain avoidance.
	- AI can now fire antirad missiles at targets detected via RWR.
	- Fix AI not firing heatseekers.
	- Fix launch authorisation check throwing an NRE for modular missiles.
	- Further fix to bombs ignoring max missiles/tge.
- Competition:
	- Calculate the proper separation between teams for starting a competition - fixes the competitions not starting bug.
	- Set the number of teams to 0 in one-at-a-time waypoint mode tournaments so spawning works correctly.
	- Ignore modular missile engines when activating all engines during spawning.
	- Fix the waypoint altitude slider to actually apply to waypoints when starting a waypoint run.
- Weapons:
	- Add pro-nav gain parameter as tunable parameter for missile parts (pronavGain), set pro-nav gain to 3 by default.
	- Anti-rad missiles now continue to target the last known GPS point instead of disabling guidance.
	- Fix ShapedCharge warheads doing no damage.
	- Activate modular missile engines directly instead of using staging (which sometimes doesn't work).
	- Apply Floating Origin/Krakensbane corrections to missile guidances - fixes missiles detonating partway to target due to miss checks.
- Armor:
	- Fix ProcArmor max scalar clamp not appearing.
	- Add Yield and YoungModulus fields to armour for reflection - fixes armour definitions without these properties not loading properly.
	- Tweak penetration calcs for ultra-low ductility armor materials.
- UI:
	- Missile names now linked to launching craft teamcolor.
	- Set the AI GUI window rect in Start, not Awake, to guarantee that BDArmorySettings values have been read - fixes the 0-height AI GUI window.

v1.5.0.0
FIXES
- Fix 'resizeSquare' texture not being loaded sometimes (due to a race condition?).
- Clean up log spam from ExplosionFX.
- Fix Ammo Selection Tool GUI when selecting a weapon using legacy ammo definitions.
- Fix ATG missiles not respecting maxMissilesPerTarget.
- Fixes Procwing HP and Armor calcs when using FAR.
- Fix ProcParts not updating HP/Armor volume.
- Adds missing FFAR rocket ammo to universal ammo boxes.
- Fixes TOW missile FX.
- Fixes Proc Armor bugs.
- Fixes broken hydraulics on Chaingun, Hydra Turret and Patriot Launcher models.
- Fixes custom armor volumes in .cfgs being ignored.
- Fix some EMP weapon Selection logic.
- EMP AMRAAM and EMP Hellfire missiles now have different names to differentiate them from vanilla variants.
- Fixes Armor explosion resistance.
- Armor panels no longer indestructible.
- VTOL AI no longer toggles off guard mode in competitions.
- Fixes Debris icons not appearing when Team Icons enabled.
- Fixes Chaingun/Rocketpod Rounds Per Minute slider values when reverting to VAB/SPH.
- Fixes ripplefire issue with weapons with different rates of fire in one weapongroup.
- Fix for issue where AI was not leading target when KSP was running on M1 Macs (Apple Silicon).
- Fixes JDAM inaccuracy issue.

IMPROVEMENTS
- General:
	- Rebranded as "BDArmory Plus" (BDA+) on SpaceDock/CKAN (from "BDArmory for Runway Project") and forum thread created.
	- Major internal refactor to better organise code.
	- Switch to a single DLL release.
	- Add missing HP rounding to some parts.
	- Stop continuous single spawn when running a tournament.
	- Optimise the PartExploderSystem to minimise creation of new vessels.
	- CM Flares optimized, now have much reduced performance hit.
	- Add a toggle to the UI settings section to disable flare smoke.
	- Add a toggle to the UI settings section to disable gapless particle emitters (mostly used for engine trails).
	- Debug labels now organized by type for easier debug tracking.
	- Refactor the debug settings to be more specific and to have an on-screen only debug labels.
	- Adds SelfSealingTanks/Firebottle options to Proc Part Tanks.
	- Bullets/explosions/etc now ignore flags.
	- Adds new CameraTools switching modes, right click the cameraTools button [A] on the VesselSwitcherGUI.
		- [S] - Camera will autoswitch to vessel with highest score.
		- [D] - Camera will switch to furthest vessel from dogfight centroid.
	- Restore the precision of Vector2d persistent fields.
	- Update the continuous spawning log parsing script.
	- Add some extra layer masks (internal kerbals are 1<<16, wheels are 1<<26).
	- Add a BodyUtils.GetTerrainAltitudeAtPos function.
	- Adds optional setting to clamp proc part/proc wing max HP to a configurable maximum when Runway Project enabled.
	- Adds UI Icon team color reset button.
	- Adds missile names to missile warning icons when vessel names enabled.
	- Add a config option for the maximum time scaling.
	- Add a new logarithmic float range PAW slider type.

- AI:
	- Add a 5° deadzone around being on target for dynamic damping to avoid feed-back loop in PID.
	- Add a check for requested extending already being satisfied.
	- Add terrain awareness to the pilot AI's waypoint fly-to direction.
	- Add a 'Waypoint Terrain Avoidance' slider to the pilot AI to control the range and strength of the waypoint terrain avoidance reaction.
	- Fixes AI GUI slider increments to match AI PAW.
	- Adds Dynamic Damping P/Y/R readouts to AI GUI.
	- Fix AI takeoff behavior.
	- Add Store/Restore option to save control surface configs in Pilot AI.
	- Add extend angle to AI to clamp climb/dive angle when doing Air-to-air extending.
	- Add Air/Ground target preference weighting to Target Priorities.
	- Make the extend toggle apply to air-to-air missiles as well as air-to-air guns.
	- Update the AI GUI help text for the current extending settings.
	- Make the AI GUI vertically resizable.
	- AI will now head to target's last known position if contact lost (out of sight range/angle/radar detection), with accuracy of predicted position decaying over time.
	- AI will now enable radars when guard mode enabled.
	- Add an altitude steer limiter to the pilot AI.
	- Apply user-defined steer limiters to roll.
	- Force VTOL AI to aim towards targets when trying to fire missiles (if it can't already fire the missile).
	- Add a PID auto-tuning mode:
		- The AI will use gradient descent to optimize the plane's ability to turn to a range of headings and stabilize in those directions.
		- The loss being minimized is ∫f(x,θ)dθ over the range θ ∈ (30°,120°) (using the midpoint Riemann sum), where f(x,θ) is ∫(δp²·(α+t²)/θ² + γ·δr²·(α+t)/100/θ)dt for the current PID values (x) and heading change (θ), where δp is the pointing error, δr is the roll error, α is the fast response relevance and γ is the roll relevance (which is automatically adjusted over time to balance the contribution from the pointing and roll errors).
		- Usage: Once the plane is airborne (and not in combat), enable auto-tuning and set the sliders to the desired values (the defaults are reasonable starting points and can be preset in the SPH; adjusting some of the sliders will restart the auto-tuning), then allow the auto-tuning to run until it stops automatically when the learning rate (LR) decreases to below 1e-3. The PID values will revert to those giving the lowest loss and these will be stored so they can be restored in the SPH.
		- Recommendations:
			1. Set the auto-tuning altitude and speed to those expected to be used in combat.
			2. Use 5-10x time-scaling.
			3. Avoid mountainous terrain.
			4. Tune without dynamic damping first and use the result as the starting point for dynamic damping with all the damping values set to the tuned static damping value and the dynamic damping factors set to 1.
			5. Since the PID values are (currently) being optimized for flying to fixed points, the tuned I value may not be optimal for moving targets in combat and a slightly larger I may be desirable.

- GameModes:
	- Waypoints:
		- Add support for multiple waypoint gate models.
		- Add waypoint scaling from 50-1000m.
		- Altitude overrides for S4R10.
		- Remember the previously used HoSTag.
		- Add right click to 'Run waypoints' to spawn with the vessel spawner coordinates instead of the hard-coded ones.
		- Add multiple courses and a selection UI.
		- Convert Waypoints from hardcoded courses to a config based implementation.
		- Add support for unique Waypoint names.
		- Add support for independently scaling (model and approach threshold) individual waypoints.
		- Add support for independently setting individual waypoint altitudes.
		- Waypoint Scale and Waypoint Altitude are now global overrides that will set all WPs to the specified value if not set to default; else will use values from the course data.
		- Adds support for off-world waypoint courses both locally and API-run competitions.
		- Add a slider for activating guard mode when passing a waypoint.
		- Allow multiple laps for waypoints.

- Weapons:
	- Use min of missile drop time or 2 sec instead of fixed two second period for check target will be within missile maxOffBoresight at future time.
	- Sidam Turret retextured (thanks Concodroid!).
	- Allow turrets to fire outside of visual range if they have a radar lock.
	- Issue 348; weapons will no longer manually fire if mouse cursor is over Weapon Manager GUI.
	- APBulletMod now implemented for sabot rounds.
	- Adjusted Sabot depth calculation, should no longer overpenetrate quite so much.
	- Sabots now recognized as AP ammo in ammo labels.
	- Weapons and explosions no longer cause armor damage/shrapnel/spalling damage in paintball mode.
	- Add charge-up mechanic for weapons.
		- Adds new .cfg fields: ChargeTime = n; ChargeEachShot = T/F; hasChargeAnimation = T/F; chargeAnimName = animName.
	- Weapon debug lines now account for frame velocity and flight integrator delay.
	- Rockets now support beehive/nuclear warhead options.
	- EMP weapons fired at targets with AI/ WM off will not cause them to activate when target reboots.
	- Bullets now support shaped charge HE fillers (for HEAT rounds and similar):
		- Bullet.cfg 'explosive =' field no longer true/false, now select from 'Standard' or 'Shaped' in place of explosive = true, or 'None' in place of explosive = false.
	- Missiles:
		- Adds Missile multi-targeting.
		- Adds new Max Missile Tgts setting in WM to set max targets to engage with missiles.
		- Adds incoming missile alert.
		- Shift some missile targeting code from OnUpdate to OnFixedUpdate.
		- Prevent heat-seeking missiles from targeting debris.
		- Remove restrictions on heat-seeking missiles attacking ground targets.
		- Prioritize anti-rad missiles first in using missiles against ground targets with active radars.
		- Adjust DLZ calculation to allow for better missile usage at close ranges, small angles to target.
		- Possibly fixed the 'Radar Stuck' bug.
		- Add option to display distances on the RWR logarithmically.
		- AI will now break off and extend away from target when firing nukes if within projected blast radius.
		- Continuous Rod warhead missiles now target a point a few meters above their target to better take advantage of planar AoE.
		- Missiles no longer prematurely detonate if DetonateAtMinimumDistance is enabled.
		- Fix HARMs ignoring max missiles on target.
		- Add chaffEffectivity parameter to missile configs. See AIM-120 config for more details.
		- Modular Missile ActiveRadarRange can now be set to 0.
		- Deprecate allAspect parameter, missile modders should now use uncagedLock instead (old missiles will automatically have the uncagedLock parameter value set to the value of allAspect.
		- Implemented Proportional Navigation and Augmented Proportional Navigation as missile guidance options for missile parts and modular missiles. For missile parts, set:
			- homingType = pronav [for Pro-Nav].
			- homingType = augpronav [for Augmented Pro-Nav].

- Armor:
	- Adds Oblique Triangle Proc Armor panel.
	- Proc Armor nodes on triangular panels now orient themselves to current angle of panel edge.
	- Proc Armor max scale can now be set in .cfg, unclamped in SPH/VAB.
	- Armor penetration formula now uses the Tate/Alekseevskii formula. Penetration depths should be similar in most cases for modded ammos, but may need recalibration of their apBulletMod.
	- Add Lift Visualization, Total Lift, and Wing Loading readouts (stock only, disabled when using FAR) to the BDA Armor Tool.

- Detectors
	- Adds IRST implementation for thermal detection alternative to radar.
		-Adds thermal occlusion mechanic; heatsources hidden behind other parts will be harder to detect by IRST.
	- Adds support for optic/thermal cloaking countermeasures.
	- Adds new AN/AAQ-42 IRST Pod part.
	- Radars must now be capable of detecting a target before it can be locked.

- Spawning:
	- Refactor spawning into more modular coroutines for use with the spawn and orchestration strategies.
	- Add an 'instant' lowering mode for vessel easing after spawn (VESSEL_SPAWN_EASE_IN_SPEED = 0).
	- Add a test for spawning a vessel into an active competition using the SingleVesselSpawning class (debug build only).
	- Randomise team spawn order (similar to random FFA ordering).
	- Switch the camera to a random plane after spawning instead of the last plane spawned.

- RWP:
	- Hall of Shame now supports multiple craft.
	- Add HoS support to Waypoint mode.


v1.4.18.4
IMPROVEMENTS
- Add slider in the pilot AI for controlling the waypoint pre-roll time.
- Add slider in the pilot AI for waypoint yaw authority time to switch from normal steering mode control of yaw to aiming steering mode of yaw when approaching waypoints.
- Add relevant AI GUI entries for these too.
- Also check for WM when checking that a waypoint competition is running.

v1.4.18.3
IMPROVEMENTS
- Waypoint visualization added.
	- 3 rings with radii 500m, 100m and 10m, with a central crosshair and animated arrows.
	- Togglable in the Waypoints Options section of the Vessel Spawner window.
	- Waypoint model can be customized to whatever, provided the model URL is "BDArmory/Models/WayPoint/model".

v1.4.18.2
IMPROVEMENTS
- Predict the minimum deviation on the frame before passing a waypoint to avoid the bad fly-to direction for the frame after passing that waypoint.
- Roll into waypoints 0.5s ahead of the waypoint in preparation for the next one.
- Add initial support for using splines.

v1.4.18.1
FIXES
- Check waypoint completion when in waypoints mode even if a different action is being taken (fixes extra large deviations and missed waypoints).
IMPROVEMENTS
- Interpolate the waypoint deviation to give a better estimate of the minimum deviation.

v1.4.18.0
Note: Due to some internal refactoring, CameraTools also needs to be updated to version 1.21.0 to work with this version of BDArmory.
FIXES
- Add checks to only adjust scores when a competition is active.
- Fix interpretation of demo vessel optimisation script.
- Fix CASE-2 ammo reduction when cloning part.
- Fix laser battledamage.
- Fix DebugLines not disabling when toggled off.
- Reorder custom bay toggle branch so it's not overwritten by airstream check (fixes custom cargo bay not being deployed).
- Fixed Anti-Radiation missiles not working properly.
- Fix barrage mode fire rate decrease/guns never overheating.
- Fix armor panels being too protective against HE.
- Fix selection logic for missiles when targeting missiles.
- Fix ammo belt exploit.
IMPROVEMENTS
- General:
	- Major internal refactor for code organisation and maintainability.
	- BDArmory is now a single DLL (the old BDArmory.Core.dll will be detected and removed).
	- Add a 'Generate Clean Save' toggle for auto-loading to the KSC without generating a clean save (tournaments and evolution still generate a clean save).
- AI:
	- New AI part: AI Vertical Takeoff and Landing Pilot (for helicopters, VTOL jets, and airships).
		- The VTOL AI behaves like the Surface AI in combat.
		- The AI flies your craft by using throttle to control altitude and pitch to control speed.
		- The AI will try to stay above the minimum altitude at all times and if it can, at the default altitude outside of combat and the combat altitude during combat.
		- The AI will obey the max pitch and max bank settings and fly no faster than the set maximum and combat speed settings.
	- Don't treat passive (non-radar-guided) missiles outside visual range as incoming missile threats until they enter visual range.
	- Lower the altitude at which gear is toggled to the minimum of 50m or minAltitude/2.
	- Lower the minimum of the terrain avoidance sliders to allow values below 1.
- WM:
	- Extend MMG smartpick selection logic.
	- Targets in guard mode no longer receive RWR warnings for missile launches outside their visual range.
	- Craft in guard mode will turn off their radars if they have an incoming anti-radiation missile within visual range.
- Armor:
	- Explosive Reactive Armor HP is now customizable.
- Weapons:
	- Remove the 0.04s delay on firing a rocket.
	- Add explModelPath and explSoundPath to Sidam.
	- Clean up rocket aiming, switch it to use the more accurate leap-frog numerical integrator and use ballistic aiming once the thrust period is over.
	- Set laser weapons to use standard FX pipeline.
	- Create new antiradTargetTypes variable for missiles that allows you to specify the RWR Threat Type that the anti-radiation missile should target. Default is 0,5 (SAM,Detection). See the HARM config file for more details.
- GameModes:
	- Paintball Mode now affects Nukes.
	- Waypoint Mode added for racing/time trials instead of combat.
- Tournamements:
	- Add checks to only adjust scores when a competition is active (fixes differences in the API scores due to timing issues).
	- Use base64 encoded vessel names internally in the parser to avoid issues with craft naming (e.g., craft with ':' in the name).
	- Adds NPC swapper functionality to remote orchestration tournaments.
- RWP:
	- Add Hall of Shame code.
- UI:
	- Add a Waypoints Mode section to the Vessel Spawner window when the Waypoints game mode is enabled.
- Internal:
	- Replace hard-coded RWR threat types with RWRThreatType reference.
	- Remove reference to TargetingModeTerminal since TargetingMode is updated to be equal to TargetingModeTerminal once terminal guidance activates.
	- New spawn and orchestration strategies are partially implemented.
	- Some refactoring of the spawning code is in progress.

v1.4.17.0
FIXES
- Fix auto-resume evolution not finding the evolution.state file.
- Fix localization for target priority on weapons manager.
- Configure the paths when loading the statefile if they're not configured.
- Avoid NRE in ModuleResourceDrain due to detonating when the parent part is being destroyed.
- Fixes Ammo belt Configuration, can no longer be used to stick ammo from one gun into the belt of another.
- Fixes Weapon Manager GUI weapon selection glitch.
- Fixes gun reticles floating a few meters in front of the weapon.
- Fix subMunitionCount = 0 in custom bullet/rocket defs breaking weapons.
- Fix Protect VIP(s) target priority for when there are more than 2 teams.
- Give default gpsTargetName as Unknown instead of empty to avoid KSP's flightstate autosave from complaining.
IMPROVEMENTS
- General:
	- Add in the remaining localisations for parts.
	- Add hotkey option for time scaling.
	- Add options (in Radar Settings section) to invert the mouse in the targeting window.
	- Add an Auto-Load-To-KSC option (in the GamePlay settings section).
- AI:
	- Use maxAllowedAoA in post-stall test in FlyToPosition instead of hard-coded 30°.
	- Tweak the clamped altitude and speed min/max values to give more usable sliders.
	- Scale steer limiter based on atmospheric density in order to account how dynamic pressure will vary based on this value.
	- Add the target's average radius to the vessel-avoidance detection.
	- Adjust the default vessel-avoidance values and increase the upper limit of the avoidance strength slider.
	- Use an average of the recent speed instead of the max speed in determining the turn radius.
	- Adjust the extending to update the extend-from position when the extend-from target is a vessel.
	- Replace the extend multiplier with explicit extend distances for air-to-air, air-to-ground (guns) and air-to-ground.
- WM:
	- Add a Protect Teammates target priority.
- GameModes:
	- Add options for respecting the flow state of stealing (in)/stolen (out) resources.
- UI:
	- Add a "Slider Resolution" slider to the pilot AI (currently just PID, Altitudes and Speeds) to allow finer or coarser adjustments to those sliders in the PAW (not the AI GUI for now).
- Weapons:
	- Add in option to set an action group toggled for when weapons are selected/deselected (can be used for deploying weapons or for other actions).
	- Ammo belt tool now loads in existing belts, if present.
	- Abrams can now properly select ammo types in flight.
- Armor:
	- Configurable Armor panels should cause less lag on loading in.
- Tournaments:
	- Add option to save the summary plot to a PNG file. Use '-s' to save to a random tempfile, use '-s fig.png' to specify the file.
	- Tweak the auto-vessels-per-heat optimisation for when we're just over the limit.
- Internal:
	- Add option to use average radius in Vessel.GetRadius instead of max.
	- Rename Misc.Misc to Misc.Utils to fix naming conflict between namespace and class.
	- Some debug message cleanup to reduce log spam.
	- Replace loading a clean.sfs save file with generating a new clean sandbox game.

v1.4.16.1
FIXES
- Fix for tournament.state files with craft filenames containing commas (don't use filenames containing '],['!).
- Fixes issue breaking some guns in v1.4.16.0.
IMPROVEMENTS
- Adds localization for various parts.
- Adds Deployable Missile Rail demo part.

v1.4.16.0
FIXES
- Don't clamp values when switching from text input to sliders and the unclamped option has been toggled.
- Fix wrong component type in BD check.
- Fix rocketpod RoF slider.
- Fix barrage-firing burst-fire weapons; these will now properly ripple again.
- Remove the restriction on the target being ahead of the weapon for opening/closing cargo bays as it messes with missile bays while planes are evading.
- Fix ammo selector issue.
- Fix various NREs.
IMPROVEMENTS
- General:
	- Add Waterfall config for the Saturn engine.
	- Increase the HP of the combat seat to the same as a kerbal (500).
	- Add a time scaling option to the GamePlay section of the settings for speeding up/slowing down the game rate while competitions are active.
		- This does not affect the physics time-step, which remains at 0.02, but simply tries to make the in-game clock go faster with respect to a wall clock, so it should not affect the physics (if they're implemented correctly).
		- WARNING: This is likely to mess with any other mod that adjusts the time rate, e.g., TimeControl, if they're active at the same time.
		- WARNING: Consistency of the results (compared to running at normal speed) is not yet verified, but initial results look promising.
- Internal:
	- Add the script for evaluating the score weights and the old dmg_analysis (for .50cal, 20mm and 30mm ammo) to '_Other Stuff'.
	- Remove executable status of the vessel-trace plotting script.
	- Replace hard-coded layer mask numbers in raycasts and similar with bitwise combinations of the LayerMasks enum. Many of these raycast include questionable/unknown layers.
	- Move the main competition update loop (death checks, etc.) to be run consistently from the physics updates instead of from the rendering updates to remove results bias due to computer performance when PHYSICS_FRAME_DT_LIMIT is large.
- AI:
	- Tweaks to VacuumAI terrain avoidance.
	- Add the off-by-one frame fix to ramming and missile guidance.
	- Add logic for planes in Follow mode for the period between taking off and reaching their min altitude.
	- Add unclamped values for the low- and high-speed steer limiters.
- Weapons:
	- Move finalFire checks into a single function that runs in AimAndFire during the FashionablyLate timing phase instead of being spread between Update and FixedUpdate.
	- Add check to AI when using a weapons group to grab the lead offset from a weapon that can fire (has ammo/not reloading/overheated/pointing at self), not merely the first weapon found.
	- Reduce spin up times for Vulcan/Gaus.
	- Fix shrapnel radius of missiles/bombs/shells using standard warheads.
	- Add support for multiple laserbeamFX textures.
	- Add DeployableRail module for missilebays.
	- Explosions from impact-fuzed HE bullets now properly bypass armor when calculating damage to the hit part.
	- Add weapon priority slider allowing setting custom weapon selection order for Missiles/Bombs.
- Armor:
	- Add additional check to ArmorTool, can no longer make engines out of wood.
	- Proc Armor panels no longer clamped to 0.5m increments.
	- Fixes proc armor panels slightly shifting attached parts on load.
- Tournamements:
	- Add some timestamp and duration output to the tournament summary.
	- Include damage taken in the console output of the parsing script.
	- Adjust spacing in output from parsing script.
	- Add an optional title to the summary plots.
	- Add debug statement about which savegame is loaded with auto-resume functionality.
	- Simplify the score calculation slightly and make it slightly more easily customisable.
	- Update the score weights in the tournament parsing script to be more balanced.
	- Remove version strings from the python script filenames and add a --version option to the scripts instead.
	- Add a new (default) 'Fill Seats' option to fill all cockpits, or fill the first combat seat if no cockpits are found.

v1.4.15.0
FIXES
- Adds some checks for inerted tanks catching fire in some edge cases.
- Fix firebottle gui not updating when they're used.
- Make nukes detonate when fired.
- Fixes for continuous spawning.
- Only report scores to the remote API and stop the heat if the competition actually starts (avoids the empty result from a competition failing to start).
- Register the collision detection time for the case where the other vessel has disappeared (fixes some invalid death times).
- Move evolution path configuration from constructor to Awake to satisfy MonoBehaviour conditions.
- Fix cost of aluminum armor panels.
- Fueltanks will no longer randomly explode when shot.
- Fix ModulePartVariants giving negative money with wooden parts.
- Fix LeakFX not appearing.
- Fix fuel leak duration.
- Fix InertTanks/SelfSealing Tanks/Armored Cockpits not persisting through reloading.
- Fix various NREs.
IMPROVEMENTS
- General:
	- Option for forcing gliders. Specify 'NoEngines' in the RWP cheat-code box to toggle it for now, or just edit the settings.cfg file.
	- An updated continuous spawning log parser.
	- Adjust the ballistic trajectory simulation time-step multiplier based on the distance to the target to give improved debug lines/targeting line visuals.
	- Armor Panels now use Armor Integrity instead of HP.
	- Nukes now support custom FX.
- AI:
	- Also avoid 0 altitude (terrain avoidance) for bodies without solid surfaces or oceans (i.e., Jool).
	- Reworked the integral component of the PID to work as an actual PID again:
		- The integral is no longer reset to 0 when the pitch error changes sign, nor decays with time.
		- The integral is now vector valued to account for coupling between the yaw and pitch axes due to roll and the individual pitch and yaw components are projected out from this integral.
		- The maximum contribution to the steering from the integral component is 1 (similar to the magnitude of the individual components before this change, but larger than the original 0.2 prior to the previous change).
		- The internal yaw damping factor is increased from 0.2 to 0.33 to keep the internal ratios between the axes consistent for each of the P, I and D components (1:0.33:0.1 for pitch:yaw:roll).
	- Use missile velocity vector for evasion instead of missile relative position to prevent turning into missiles when they are at close range.
	- Use soonest time to closest approach instead of closest distance to select highest threat missile.
	- Change closest approach point to ignore missile threats to 3 Blast Radius from 1.5 Blast Radius.
- Weapons:
	- Adds Chaingun functionality; chainguns have user configurable RoF in the SPH/VAB.
	- Adds Weapon Spool up time functionality (for Gatling guns, etc).
	- Lasers get damage/FX growth option for increasing damage/changing beam width/color the longer they've been firing.
	- Adds support for EMP, Beehive, Impulse, Gravitic, and Nuclear bullets.
	- Expands GUI ammo labels to include above types.
- Battle Damage:
	- Restore ability to add firebottles to engines.
	- Adds a toggle for whether burning fueltanks will explode.
	- Toggling paintball mode now toggles BattleDamage off.
- Tournaments:
	- Add the savegame field to tournament.state on tournament generation.
	- Add Auto-Quit at end of tournament hidden option (for automation: AUTO_QUIT_AT_END_OF_TOURNAMENT).
	- Add custom max number of rounds to tournaments (edit the settings.cfg file to set it: TOURNAMENT_ROUNDS_CUSTOM).
	- Make the auto-generated vessels-per-heat setting customisable (by editing the settings.cfg).
	- Rename the summary plotting script and allow specifying the tournament folder.

v1.4.14.1
FIXES
- Fix typo in 2x1 legacy armour panel.
- Fixes missile turret Cost.
- Fixes missile RMB warhead info.
- Fixes NRE with proc armor parts on loading a craft.
- Nukes no longer explode when destroyed (if engineCore = false, so S3R1 Chernobyl functionality still present, just not all the time).
- Account for starting resource cost modifier to part cost, fix discount to reduce up to 500 from cost.
IMPROVEMENTS
- Restores ability to set custom tracer stats in weapon.cfg. Use "tracerOverrideWidth = true" in the cfg to use override values instead of dynamically determined tracer settings.
- BattleDamage fire chance on hit now editable in the settings config.
- Teams:
	- Adds ability to set teams to neutral in team selector/VesselSwitcher/WM.
	- Right clicking on the team button in the Team Selector/WM will toggle non-default teams (A, B, Neutral) neutral status.
	- Right clicking on the [t] button to the right of a vessel button in the VS will open the Team Selector.
	- Left click will switch to next combat team, mouse-3 will switch to next neutral team.

v1.4.14.0
FIXES
- Switch worlds to the spawn point before spawning if the spawn point is on a different world (fixes broken tournament resuming on other worlds).
- Use GetRadarAltitudeAtPos instead of radarAltitude as the latter reads wrong for our purposes when underwater.
- Fix the bad check preventing competition start if a vessel doesn't take off.
- Fix NRE in CheckExtend.
- Remove extraneous trajectory simulation when firing a bullet.
- Fix infinite recursion bug in the evolution engine.
- Compensate for the delay in calculating the effects of collisions and properly attribute deaths (including death order and time) due to ramming correctly.
- Fix bug in part counting that was occassionally causing negative part counts in rams.
- Handle EVA kerbal disappearing during KerbalSafety configuring.
- Add null check to IsKerbalEVA extension.
- Fixes .50 turret explosion model.
- Fixes rocket aim reticle hovering a meter in front of muzzle.
- Fixes some localization typos.
- Fix Nuke FX scaling issue.
- Fixes Fuel Inerting mass discrepancy.
- Fix Inerted tanks still being able to catch fire.
- Fix Firebottles not extinguishing fires.
- Fix CASE II bug setting non-integer ammo amounts.
- Fix Armor of pretty much any thickness completely stopping explosion damage.
IMPROVEMENTS
- AI/WM:
	- Use CM threshold for determining missile closest approach instead of a fixed 2s value.
	- Add alternate max for strafingSpeed.
	- Switch turrets to use the Firing Angle instead of needing to be directly on-target.
	- Added a nonlinear oscillation ("Evasion/Extension Nonlinearity" in the pilot AI) when extending or evading to avoid going in a straight line.
	- Lasers now selectable by the AI for attacking ground targets.
	- Adds some catches to AI MMG selection logic.
- Armour:
	- Abrams Turret can now support more than 10 armor.
	- Armor type 'None' no longer takes damage/spalls.
	- Armor Plates can now be set to armorType 'None', used as structural panels.
	- Adds new BDAdjustableArmor module.
	- Armor panels replaced with new procedural armor panels. Old panels moved to legacy to prevent breaking saved craft.
- Weapons:
	- Adds underwater rocket trajectory calcs to permit AI to aim underwater rocket weapons.
	- Nuke damage falloff calcs corrected, blast radii no longer far larger than they should be.
	- Nukes will no longer hit craft that have managed to get out of the blast zone before the blast wave arrives.
	- Adds Clusterbomb rmb Info.
	- Adds shaped charge and continuous rod warhead options to Rockets/Missiles/Bombs, use "warheadType = "shapedcharge" or "continuousrod" in the BDexplosivePart Module of the part.cfg, or setting "shaped = true" in the rocket config.
	- BDA stock missiles updated with new warheads where appropriate - check RMB info in the editor.
- Tournaments:
	- Add option to auto-generate a tournament if auto-resuming and there isn't an incomplete tournament to run.
- Parser:
	- Use a more natural sorting order for rounds in the parser so the score-by-round is consistent.
	- Use more precision in the csv file for the cumulative scores.
- Evolution:
	- Maintain evolution state and properly add in support for auto-resuming evolutions.
	- Add current heat to the evolution window.
	- Include rockets fired and rocket strikes in the evolution scoring metric.
	- Update the set of parameters the evolution engine can modify for the latest pilot AI and remove invalid ones.
	- Limit evolved control surface authority to 150% (i.e., in-game limits).
	- Add auto-quit memory threshold between evolution groups.
- Spawning:
	- Add some checks for missing vessels during post-spawning.

v1.4.13.2
FIXES
- Fix comboboxes triggering force close on themselves when they should be opening.
- Use the correct spawn distance based on the spawn distance toggle for tournaments.
- Don't extend from ground targets when using a weapon that doesn't target ground targets, immediately look for another target instead.
IMPROVEMENTS
- Set the default evasionTimeThreshold to 0.1s.
- Make all custom paths relative to the KSP install directory to remove dependence on running location (PRE needs fixing for this to be usable though).
- Count rockets fired separately from shots fired and calculate rocket accuracy from the number of rocket strikes.
- Disable guard mode on spawned vessels during spawning and clear their current target (prevents using AG10 to activate guard mode earlier than should be allowed).
- Extend vessel easing during spawning until a vessel's cockpit is in the water (or it has stopped sinking) to allow it to settle a bit.

v1.4.13.1
IMPROVEMENTS
- Apply/de-apply the intake hack when toggling the option in the settings.
- Hack intakes (if enabled) on newly spawned vessels spawned by VesselMover or SPH→runway.
- Count rockets fired separately from shots fired and calculate rocket accuracy from the number of rocket strikes.

v1.4.13.0
FIXES
- Tournaments:
	- Fix some typos and bugs in assist counting in the local tournament parser.
	- Clear rocket dictionaries between heats. Compute assists under the same conditions for local and remote tournaments.
	- Cause a spawn failure instead of throwing an exception so that tournaments can retry spawning.
- Craft/Battle Damage:
	- Fix SelfSealingTanks being addable to engines.
	- Fix SelfSealingTanks not showing on/off status on load.
	- Fix SelfSealingTanks not respecting symmetry.
	- Re-add ModuleSelfSealingTank to Cockpits (for armored cockpits).
	- Fix fires not extinguishing if fuel < 0.
	- Fix engine fire behavior, now capped to max one fire at a time.
	- Fix Steel parts gaining more than the 1.75x HP they should be getting.
	- Fix fire generation on subsystem damage.
	- Fixes non-fueltank fires not burning out and extinguishing after a period of time.
	- Fix inert tanks not catching all possible sources of fire generation.
	- Fix invalid cast and NRE for modular missiles.
- AI:
	- Fix AI aim offset being offset.
	- Only extend when a bomb is selected once extending is requested.
	- Activate only the current mode of multi-modal engines.
	- Release pilot AI from attack command if they have a target within gun range (fixes bug with very long-range guns not engaging targets at competition start), regardless of whether RWP toggle is on.
- General:
	- Fix Paintball decals not appearing in paintball Mode.
	- Fix AIR-2 Genie cost.
	- Fix Explosions/Nukes not damaging buildings.
	- Fix RESET_ARMOR resetting hull material.
	- Fix Audio cutting out when firing lasers using looping SFX.
	- Fix for KerbalSafety sometimes being given the KerbalSeat instead of the KerbalEVA as the part.
IMPROVEMENTS
- Internal:
	- Allow BDGUIComboBox to be relocated/resized.
	- Rework Nuke EMP radius calc; EMP radius at lower alt/lower yield is now much smaller.
	- Bullet penetration depth capped to hypervelocity penetration depth.
	- Add option for laser mutators to use Team Color for beam color (set bulletType in the mutator config to "def").
	- Add part and vessel to debug info for AddDamage and AddHealth.
	- Add debug info for when fires get added if debug labels are enabled.
	- Slight buff to chaff factor.
	- Add some missing localisations.
	- Remove expensive Find call during spawning, since we already know which objects it needs to find.
	- Only run more expensive debug checks on the debug version, not the release version.
- BattleDamage:
	- Fix SelfSealingTanks maxing tank capacity when switching instead of simply adjusting maximum.
	- Increases CASE cost at higher levels (mass increase, ammo capacity reduction).
	- Reduce firebottle extinguish delay time to 4 sec.
	- Fire chance from HE rounds reduced from 33% to 20%.
	- Hits to Wings/ControlSurfaces/Subsystems/Cockpits with overpenetrating rounds will now only proc a single BattleDamage event.
	- Fires will no longer consume a firebottle per fire; on trigger, single firebottle will now extinguish all internal fires present on the part.
	- Surface fires will now extinguish if vessel moving > 120m/s.
	- Adds Fuel Inerting option to fuel tanks to prevent fires.
	- Adds Armored Cockpit option to cockpits to reduce/prevent pilot Kill battledamage.
	- Adds ProcWings support - can now add Firebottles/SelfSealing/Inerted tanks to Pwing fueltanks; Pwings with fuel can now catch on fire when shot.
	- Adds missing BattleDamage 'Subsystem Damage' toggle.
	- Makes BD to control surfaces less immediately debilitating.
- UI:
	- Add check for disabled PRE when competitions are active.
	- Add a check for the number of AIs and WMs during spawning (when RWP is enabled) and give an in-game message if there's not one of each.
	- Armor GUI submenu functionality based on current HP/Armor/Hull Reset toggle settings.
	- Adds Hull Material visualizer to SPH/VAB Armor GUI tool.
	- Improves Weapon Manager GUI infolink descriptions of target priority settings.
	- Add off-world spawning to Spawn menu (spawn locations and tournaments get automatically upgraded).
	- Add ability to add custom spawn sites to spawn menu.
	- Add Persistent UI button to Vessel Switcher to keep VS and Web Orchestration windows open when F2 UI toggled off.
	- Add an estimate of the current memory usage to the settings menu when Auto-Quit Memory Threshold is enabled.
	- Allow a user-set max value to the Time Scaling factor.
- Game Modes:
	- Add secret Disco Mode.
	- Zombie Mode option moved to cheat mode access.
- Competitions:
	- Adds Orbital Deployment round start mode - craft are spawned at 80km, and gravity hacked to 10 for 30 sec to accelerate craft downwards (request from SirJohn).
	- Distinguish between deliberate and accidental rams. Accidental rams don't contribute to the score.
- Tournaments:
	- Add a '-z' option to the tournament parser to shift the scores so that the lowest is 0.
	- Add taken counts to the summaries.
	- Add a '-z' option to the tournament parser to shift the scores so that the lowest is 0.
	- Adjust rocket parts hit and damage fields to match ruby schema in the remote orchestration.
	- Only adjust the altitude for failed spawns for ground spawns.
	- Allow specifying both '-c' and tournament dir to parse the specified tournament dir as a collection (i.e., without the tournament folder structure).
	- Rebalance the score weights in the parsing script.
	- Add a Gauntlet tournament style for teams tournaments (like N-choose-K, but between two groups of teams).
- Kerbal Safety:
	- Reconfigure inventories when the kerbal inventory slider is adjusted.
- AI:
	- Add additional control "Afterburner Priority" for afterburner toggling under Speed category of AI. Default value of 50. 0 and AI will not use AB, 100 and AI will always use AB.
	- Vary AB hysteresis based on "Afterburner Priority" setting using an exponential average to smooth the vessel's TWR (lag factor of 0.5s) to judge whether AI should toggle AB vs. using instantaneous acceleration.
	- Default Guard Range increased to 20km.
	- Allow custom/modded missile and bomb bays. Set which action group controls the bay toggling on the missile/bomb itself and the AI will automatically open and close the bay when dropping the ordnance.
	- New default AI and WM settings.
- Spawning:
	- Respawn the spawn probe when showing the spawn point if the active vessel has been destroyed.
	- Use the backup location 'KSP/Ships/SPH' as a fall-back for the spawn probe location as CKAN puts it there.
- RWP:
	- Enabling the Runway Project toggle will clamp guard range to a minimum of 20km.
ADDED/REMOVED/CHANGED SETTINGS VALUES
- Adds Intake Hack setting to autohack intakes to work in non-Oxygen atmospheres.
- Add a toggle in the Competition Settings section for closing the settings when clicking the start competition button.

v1.4.12.6
FIXES
- Add a check for tournamentState.rounds being null when checking whether to resume a tournament. (Fixes failure to generate tournaments under some conditions.)

v1.4.12.5
Re-release due to not having recompiled the release version before releasing it.

v1.4.12.4
FIXES
- Internal:
	- Don't update the VesselModuleRegistry for a vessel when it's not yet loaded. (Fixes the missing AI/WM issue when reverting/quickloading.)
	- Use a different function to reset the crew's inventory as the other one wasn't working properly.
	- Register survivors with the remote orchestration in case they're didn't get registered for anything else.
	- Also catch the LES as a SRB in ModuleSelfSealingTank.
- AI:
	- Fix off-by-one-physics-frame error in FlyToTarget that was affecting aiming (especially noticeable for lasers).
	- Remove extra Deg2Rad factor from low velocity correction to terrain avoidance so that it actually has an effect (post-stall behaviour near terrain).
	- Revert the 0.5s afterburner change as it caused issues with multiple engines not toggling simultaneously.
	- Sync the input fields the correct way on vessel switches (and loads). (Fixes the AI settings getting reset in flight mode when switching vessels.)
	- Fix NRE in targeting info caused by moving spawning point with a vessel that has a current target.
- UI:
	- Fix paintball mode not applying decals due to impulse weapons check.
	- Fix the length of the substring in debug message for vessels that fail to spawn.
	- Fix check in ExplosionFX for in-game messages about explosions (removes the rocket strike spam).
- RWP:
	- Remove the previous conditions for the RWP S4R2 condition as they aren't being used for S4R2.
IMPROVEMENTS
- UI:
	- Add "Show Self" option to Team Icons (icon + name only).
- Internal:
	- Use warning level log entries for issues with the BDAScoreClient. Expand debug message to include stage number.
	- Register and de-register game events in Kerbal Safety so as not to interfere with kerbals until the first competition is started.
- RWP:
	- Apply the S4R2 'fill seats' condition to vessel spawning.
- Tournaments:
	- Store unfinished tournament state files in 'PluginData/Unfinished Tournaments/' and remove them when they're finished. (Copy them to the usual tournament.state file when in the KSC screen to resume them.)
	- Add a --show-weights option to the tournament parsing script to show the current weights of the various components of the score.
	- Add an option to the parsing script to not show the cumulative scores by round.

v1.4.12.3
FIXES
- Sanitise null strings in paths.
- Fix armor panels reverting to 2 thickness.
- Fix some errors in the MM patch for parts.
IMPROVEMENTS
- Better in-game and log messages for when a competition fails to start due to a vessel disappearing.
- (RWP only) Add in-game reminder for AI and WM not attached to the root part.

v1.4.12.2
FIXES
- Fix negative HP issue with Reactive Armor.
- Fix CalcShrapnelDamage potentially reporting a negative number for damage.
- Add some recursion checks to ModuleCase.
- Add check to prevent setting Weapon material to Wood.
- Can no longer change Armor Panel hull material.
- SRBs no longer explode when empty if BattleDamage enabled.
- Fixes Fuel Tank explosion yield increasing when associated resource(s) is empty.
- Empty Ammo boxes will no longer explode when destroyed.
IMPROVEMENTS
- Re-add Firebottles, SelfSealing Tank option to Making History Soyuz tank.

v1.4.12.1
FIXES
- Fix stack overflow in CASE explosions from detonating SRBs.
- Fix NRE in PooledRockets.
- Fix ordering of Gameplay settings.
- Fix localisation for new Reset Material toggle.
- Take a copy of the collider list from overlapSphereColliders to avoid potential issues since it's static and ProcessingBlastSphere can be called recursively.
IMPROVEMENTS
- General:
	- Reduce the weighting of rocket hits in the parsing script.
	- Add some more debugging to inter-competition debug statements.

v1.4.12.0
FIXES
- Sort the protoVessel part list during spawning to fix the badly rooted vessel spawning bug.
- Fix BDA part category placement to be usable on low resolution screens.
- Don't add explosive forces when paintball mode is enabled.
- Armor will no longer take damage when using Paintball Mode.
- Subsection targeting GUI label no longer reverts to CoM.
- Paintballs will no longer overpenetrate if base ammo type is armor piercing.
- Shatterable armor materials now properly take full armor loss amount each shattering hit, instead of a reducing amount every subsequent hit.
- Armor panel armor values no longer vary based on part orientation.
- Armor Panel buoyancy fixed.
- Rockets no longer calculate shrapnel hits twice.
- Fixes unit conversion error in armor spalling calcs.
- Bullet Penetration calc now properly takes angle of impact into account.
- Minimal seat filling should fill the first non-weapon crewed command part, not the first non-weapon crewed part.
- Iteratively refine the aiming point (measured to take 2-3 iterations typically) to avoid the turret premature firing issue.
- Fix issue of NaN appearing in bullet damage.
- Add a check for failing to load the tournament state.
- Some fixes for continuous spawning, but it's still misbehaving.
- Apply hull modifier to proc wings also.
- Use the OS-dependent directory separator char for player-visible paths (fixes team names containing the 'AutoSpawn' folder in Windows).
- Replace ', ' with ',' in the summary.csv file for teams for consistent team member naming.
- Rework the extending code to remove the spaghetti and fix the bug where the plane would extend in a straight line from ground targets without AI control.

IMPROVEMENTS
- General:
	- Update the tournament parser to sort teams by wins, have the same column order in the csv as in the console and include cumulative score per round results.
	- Use RemoveVessel in VesselSpawner.cs for removing spectators for more consistent removal.
	- Disable guard mode on aerial spawn to be consistent with competition start sequence (in case there's a delay between spawning and starting where someone activated guard mode on AG10).
- UI:
	- Use a slightly more compact spacing in the vessel switcher when teams only have 1 vessel and short team names are used.
	- Remove unused "fire in range" toggle from weapon UI.
	- Add a UTC timestamp to the clock.
	- Armor Tool GUI now lists comparative strength of material vs steel, and provides a general estimate of material effectiveness against various forms of damage.
	- In Flight Armor GUI slider changed to Armor Integrity showing percent remaining armor.
 	- Clarifies armor debugging statements.
	- Armor Reset toggle split into separate Armor Reset and Hull Reset toggles.
- AI:
	- Add a 0.5s cool-down to the AI toggling the afterburner for when the hysteresis is insufficient.
- Countermeasures:
	- Add separate countermeasure settings to the weapons manager for chaff.
	- Update default values for flares and chaff to be more effective.
	- Lower default chaff factor to slightly nerf chaff performance.
	- Add Vessel-Relative Bullet Checks for more accurate bullet checks that work in high-velocity environments (enabled by default).
	- Replace smoothing of target velocity and acceleration with Brown's double exponential smoothing for improved aiming, particularly at longer ranges.
- Armor:
	-Armor panel thickness now starts at 25, can be increased up to old maximums.
	-Armor panel area (in m^2) can be set in .cfg via "armorVolume =" field.
	-Bullets will now only hit (and deal damage to) armor panels once.
	-Armor Panel HP now directly proportional to armor integrity.
	-ModuleReactiveArmor has been rebuilt and now works.
	-Adds Reactive Armor example part.

ADDED/REMOVED/CHANGED SETTINGS VALUES
	- Vessel-Relative Bullet Checks in advanced Gameplay settings.
	- Armor Reset toggle split into separate Armor Reset and Hull Reset toggles.

v1.4.11.2
FIXES
	- Fix Intake Battle Damage issue.
	- Intake Battle Damage now clamped to a minimum of 1/4 original intake area.
	- AP rounds that penetrate multiple parts now only register a single 'hit' for scoring.
	- Fixes Nuke FX scale and scaling.
IMPROVEMENTS
	- Adds Armour Reset toggle to BDA settings menu to reset craft armor/hull material to defaults.
	- Missiles can now use in-flight animations with the 'flightAnimationName =' field.
	- Adds config fields to BDModuleNuke for setting custom FX/sound.
	- Nukes now have Editor info cards.
ADDED/REMOVED/CHANGED SETTINGS VALUES
	- Added Armor Reset toggle.

v1.4.11.1
FIXES
IMPROVEMENTS
	- Adds AIR-2 Genie example weapon.
ADDED/REMOVED/CHANGED SETTINGS VALUES

v1.4.11.0
FIXES
	- Fix some exceptions related to flames.
	- Fix for spawning where VESSELNAMING tag is different from the vessel's name (the name gets reverted so that the VESSELNAMING tag is effectively ignored).
	- Fix bug where interrupted tournaments could lose team information.
	- Fix exception in Team Icons.
	- Allow extra attempt at spawning when no terrain was found as it sometimes works the second time.
	- Fixes laser damage calc incorrectly using laser part armor thickness instead of target.
	- Fixes AI not using AGMS against ground targets.
	- Fixes sabot deformation.
	- Fixes missiles not respecting max missiles per target setting.
	- Rockets will now properly score only a single hit if HE.
	- Scoring now tracks rockets fired.
	- EMPs from nukes will no longer repeatedly fry a hit vessel.
IMPROVEMENTS
	- General:
		- Add optional persistent FX for smoke/debris from explosions.
		- Explosions will now damage a part if detonating inside it.
		- Adds generic FX spawner.
		- Renames RWPS3R2NukeModule to BDModuleNuke, and expands it into a missile-usable module.
		- Adds some FX to nuke detonations.
		- Nukes now act like explosions and delay damage/heat/impulse imparted to target based on distance from detonation.
	- UI:
		- Reworks the BDA Settings Menu to be less cluttered/more organized/intuitive.
		- Less commonly used toggles/settings now enabled via Advanced User Settings toggle.
		- Disable Kill Timer setting removed, this is now handled by the Kill Timer slider.
		- Vessel tracing manual toggle moved from the Vessel Switcher Window to the Settings window (in the Other section when Advanced User Settings is enabled).
		- Settings window doesn't automatically close when starting a competition.
		- Settings are saved when switching scenes if the UI is open.
	- Tournaments:
		- Add an 'Auto-Resume Tournaments' option to automatically load the savegame associated with an unfinished tournament, enter flight mode and resume the tournament on KSP launch.
		- Add an 'Auto-Quit Memory Threshold' option (when auto-resuming tournaments is enabled) to automatically quit KSP between heats if the managed memory is above a threshold. Note: native (unmanaged) memory is not measurable from within Unity, so actual memory usage may be higher. In particular, the GfxDriver can use around 5GB of memory, but isn't measurable in non-debug versions of the Unity player. See the "DEBUG Memory Usage" lines in the KSP.log.
		- Add results.json parser for N-choose-K style tournaments to produce a table of who-beat-who."
		- Expand the 'Folders' teams mode for spawning and tournaments to 'Per Folder / Per Craft File' where, if no subfolders are found, then each craft file in the folder is treated as if it were in a subfolder with the name of the craft file (minus the '.craft').
	- Competitions:
		- Landed Kill Timer no longer affects vessels using Surface AIs.
	- AI:
		- Apply a correction to the roll target when a low-altitude inverted-roll is requested to avoid looping down and immediately triggering terrain avoidance.
	- Armor:
		- Adds numeric field to Armor GUI thickness slider.
		- Allow armor thickness adjustment in non-"integer of 5" increments.
		- Remove lowered max temp of aluminum/steel hulls.
	- Bullets:
		- Sabot rounds now identified via mass, caliber, and length instead of caliber and velocity.
		- Bullet deformation now controlled by caliber and HE ratio.
		- Rework bullet collision, bullets now do both entry and exit damage to parts they (over)penetrate.
		- Adds three new fuze types - Impact, Delay, and Penetrating.
		- Proximity/Timed fuze rounds will not detonate if they hit something within their arming dist.
	- Battle Damage:
		- Fires Add Heat no longer prevents damage from occurring.
		- Add Battle Damage option for fire damage to scale to fire intensity.
		- Engines and intakes now properly take Battle Damage relative to damage taken.
		- Engines now properly clamp thrust to thrust floor value when Battle Damage.
		- Default Battle Damage settings are mostly true by default.
	- Evolution:
		- Add a hidden AUTO_RESUME_EVOLUTION setting to resume evolution on restarting KSP (similar to and overrides the 'Auto-Resume Tournaments' setting).
ADDED/REMOVED/CHANGED SETTINGS VALUES
	- Performance Logging option removed as it did nothing.
	- InstaKill option removed (only affects lasers, use the InstaGib mutator instead).
	- Auto-resume tournaments and Auto-quit KSP advanced options added to the Gameplay section, plus a hidden Auto-resume evolution setting.
	- Persistent FX setting added.

v1.4.10.0
FIXES
	- General:
		- Consider 'splashed' vessels as 'landed' when spawning.
		- Symmetric parts are updated when armour type or hull material is adjusted in the editor.
		- Fix exception in updating radar locked targets.
		- Remove duplicate 'Detonate At Minimum Distance' toggle from non-modular missiles.
	- AI GUI:
		- Get the AI on the initial load when reverting to the editor.
		- Fix the AI GUI updating the values when switching vessels when using numeric fields.
		- Fix some surface AI values being initialised from the wrong variables in the AI GUI.
	- Mutators:
		- Fix speed mutators from setting engine throttle to 0.
		- Fix mutator mode interaction with weapon arenas and impulse weapons (gravity gun).
	- Weapons:
		- Fix some weapon selection criteria.
		- Fix lasers doing negative damage.
		- Fixes issue where AI would sometimes select rockets over guns for AtA when gun was superior option.
		- Fixes some typos in Stingray.cfg.
		- Torpedoes are no longer affected by Chaff.
		- Beam-guided munitions can now properly target splashed targets.
	- Battle Damage:
		- Heartbleed/Armor melting no longer occurs when game is paused
		- Adds check so empty fuel tanks will no longer catch fire if part temp exceeds fuel ignition point.
		- Autoigniting fuel tanks will only add a single fire.
		- Removes ability to add firebottles to SRBs.
		- Fuel Tanks/Ammo Boxes now require 'Fires' and 'Fires Add Heat' enabled in Battle Damage settings to catch fire if too hot.
		- Burning Fuel tanks now properly destroy the part if they explode.
	- SPH/VAB
		- The Armor Tool GUI will no longer reset armor thickness of all parts to 10 when opened.
IMPROVEMENTS
	- Weapons:
		- Adds clusterbombs to weapon selection logic.
		- Adds support for beam-guided AtA missiles.
		- AI should now select best, rather than first, bomb available when attacking ground targets.
		- Selection logic now weights cluster ammo for missile interception.
		- AI will can now select rockets/lasers to use at close range against underwater targets.
		- AI can now target flying targets with laser-guided munitions.
		- AI will not use EMP missiles against targets that are currently EMP'ed.
		- Adds water splash FX for bullets hitting water.
		- Bullets can now ricochet off water.
		- Added an "Underwater Bullet Drag" option for bullets and rockets to have considerable drag when in water. When enabled, the following applies:
			- Bullets with caliber < 75 and rockets fired from above water stop when entering water and explode if they're explosive.
			- Rockets with sufficient thrust duration can be fired from underwater at splashed/submerged targets that are close enough.
			- Weapons targeting nearly fully submerged targets will target the water surface immediately above the target.
			- Weapon selection updated to reflect the above changes.
			- AI will no longer select guns when underwater.
	- UI:
		- Add a toggle for showing the competition status messages with the UI hidden.
		- Add option to TimeWarp between tournament rounds (not heats) on planets with a solid surface (due to a technical constraint).
		- Add Underwater vessel status to LoadedVesselSwitcher window and put the status after the vessel name.
		- Expand the low altitude GM kill limit to depths of -10km.
		- A clearer message when a tournament stops due to spawning/competition start failures.
		- Small Warhead 'Detonate At Minimum Distance' toggle renamed to Warhead Trigger Distance, to avoid confusion when building modular missiles.
	- RWP:
		- Add S4R1 RWP option for globally adjusting the firing rate of weapons in-game.
		- Add S4R2 RWP option Zombie Mode where only root part takes damage.
			- Add non-headshot dmg multiplier slider to adjust how much damage non-root parts take.
			- Add toggle to allow battledamage to occur on non-root parts.
	- Internal:
		- Adjust camera weights for picking a better vessel to switch to.
		- Add a IsUnderwater vessel extension.
		- Adds hidden legacy armor toggle to disable armor overhaul changes (armor types/hull material) accessible via editing settings.cfg.
	- General:
		- Adjust armor panel buoyancy, armor panels will float again when at max thickness.
		- Automatically create a GameData/Custom/Flags directory for standardising the location of flags for BDArmory competitions.
		- Price rebalance.
		- Some RWP specific options (to be decalred once the rounds have been run).
ADDED/REMOVED/CHANGED SETTINGS VALUES
	- Low altitude kill limit expanded and "Off" value changed.
	- Legacy armour option added (config file only).
	- Competition status messages with hidden UI option added.
	- Underwater bullet drag option added.

v1.4.9.1
FIXES
	- Fix various fields in the AI GUI for surface AIs.
	- Fix broadside direction to not be reversed.
	- Set default mutator mode (for new installs) to false.
	- Add missing checks for empty mutator list (was causing competitions to fail to start).
	- Fix laser damage calculation.

v1.4.9.0
FIXES
	- Fixes an NRE in PartExtension.GetSize that was causing KSP to crash when deploying a flag.
	- Properly reset the AIGUI input fields when adding and removing multiple AIs.
	- Add missing field to surface AI input fields.
	- Fix Evolution UI bug and allow 0 adversaries.
	- Make the CASE-I explosion directed in the up direction of the part.
	- Check for null vessels in ForceUpdateRadarCrossSections (fixes competitions not starting due to this exception).
	- When setting HP of parts, use an alternate approach to getting volume based on partSize when GetAverageBoundSize gives ridiculous results. Failing that, just base it on mass. (Fixes HP on TweakScale and AP+ parts.)
	- Actually run the armour and hull setup functions in flight mode.
	- Add conformal decal exception to HP/Armor visualizer.
	- Make rendering of RCS snapshots and HP/Armor visualisers in the editor wait for ship changes to finish being triggered before rendering to reduce unnecessary renders causing flickering.
	- Various fixes for shrapnel damage.
	- Fix penetration velocity reduction.
	- Fix barrage mode not cycling through singlebarrel weapons.
	- Fix RPM for multibarrel weapons, actual RPM is now listed RPM, not listed RPM * num of barrels.
	- Fix occasional NRE in AnalyseCollision.
IMPROVEMENTS
	- Internal:
		- Add angle parameter for creating directed explosions (defaults to 100°).
		- Log 'StopCompetition' events to the log as well as the screen.
	- Armor:
		- Add attach node sizes to armor panels.
		- Add Editor RMB context info for armor panels to inform players of panel armor mass.
	- AI:
		- Allow collision avoidance detection from vessels approaching from behind.
		- Don't apply premature dive fix when evading.
		- Add an option to ignore gunfire from the current target for evasion purposes. (I.e., don't trigger evasion when jousting, only from other sources.)
	- Game modes:
		- Add Asteroid Field game mode, with anomalous attraction option.
		- Add Mutator mode:
			- Select one or more mutators to change up how weapons and craft behave for the round.
			- Mutators can be applied globally, per vessel, or on kill.
KNOWN ISSUES
	- Occasional graphical glitch for proc wings in the SPH/VAB due to HP/Armor visualizer. Doesn't affect flight mode and the color resets if the craft is reloaded or the proc wings color settings are nudged.

v1.4.8.2
FIXES
	- Fixes armor panel settings not persisting from Editor to Flight.
	- Fixes steel hull material massively increasing weight.
	- Triangular armor panels/wings now properly have 1/2 armor mass of rectangular panels.
	- Put the Gau-22 in the correct category in the SPH.
	- Fix minor mesh errors on the Sidam.
	- Don't detonate CASE ammo on vessel packing or unloading.
	- More fixes for proc-wings:
		- HP is updated properly on vessel load.
		- Mostly fixed interaction between the HP/Armor visualizer and proc wings shaders.
IMPROVEMENTS
	- Add a slider for controlling the distance threshold of showing team icons.

KNOWN ISSUES
	- Occasional graphical glitch for proc wings in the SPH/VAB due to HP/Armor visualizer. Doesn't affect flight mode and the color resets if the craft is reloaded or the proc wings color settings are nudged.
	- Flickering of the RCS window, particularly when the Armor window is open.
	- Tweakscale HP is misbehaving beyond certain size changes.

v1.4.8.1
FIXES
	- Fix (mostly) Pwing - HPVisualizer issue
	- Fix burstfire
	- Fix procwing HP bug
IMPROVEMENTS
	- Internal stuff:
		- Implement the AddPlayerToRammingInformation and RemovePlayerFromRammingInformation functions (not used yet).

v1.4.8.0
FIXES
	- Fix logic of which vessels to ignore in RCS snapshots.
	- onDisable -> OnDisable. Deactivate FireFX properly such that the parentPart always gets cleared (also in FuelLeakFX.cs).
	- Fix line-of-sight checks in ExplosionFX for exploding parts on vessels.
	- Don't detonate for surface fires, excess fuel explosions cause surface fires.
	- Don't trigger CASE ammo explosions on scene changes.
	- Fix rippleRPM.
	- Fixes to burstfire.
	- Fix checks for uncontrolled vessels.
	- Fix LangVersion in .csproj to build with later than C# 7.3.
	- Fix missing team in summary when the team is only dead.
	- Fix bug with 'dead teams' in tournament parser script.
	- A variety of minor bug fixes and optimisations.
IMPROVEMENTS
	- General:
		- Adds support for weapons with multiple fire animations or barrels (battleship guns/wirbelwinds/etc).
		- Adds Sidam quad 25mm to demonstrate multi-fireanim/multi-barrel functionality, and the GAU-22 to provide a fixed 25mm weapon.
		- Fix fuel fires/ammo explosions occasionally yielding larger than expected damage.
		- Ammo explosion max damage now capped.
		- Weapons with integral CASE will no longer add an additional 2000 funds to part cost on load.
		- Add N-choose-K style tournament option.
		- Variant engine for automated craft evolution.
	- AI/WM:
		- Added stand-off distance to try to avoid getting closer than this distance when tailing another craft.
		- Improved vessel-vessel collision avoidance based on look-ahead and avoidance strength and only avoiding as long as necessary (note: this uses different settings in the pilot AI, so old craft may need re-tuning for this).
		- Expand targeting logic for rockets.
		- Adds AI GUI, available in both editors and in flight, with configurable hotkey (default 'Numpad /') and optional toolbar button.
		- Expands Weapon Manager GUI, adds target priorities tab.
		- Adds togglable context labels and infolinks to AI and WM GUIs for on-hand info about what each setting does.
		- Ki improvements with 0.995 decay factor and fixed +1/-1 clamps.
		- Update target priority to work for ground targets.
	- Armor Overhaul:
		- Armor now adds mass to craft, relative to thickness and part size.
		- Can now select from multiple armor materials, each with their own strengths and weaknesses.
		- Adds spalling damage from near-penetrating hits.
		- Adds shrapnel damage from explosive detonations.
		- Adds Armor tool to SHP/VAB editors for easy armor manipulation across a craft.
		- Adds HP visualizer, to see HP of all parts across craft.
	- GameModes:
		- Adds Space Tools BDA setting.
			- Adds Space Friction toggle for starwars-style space dogfights.
			- Adds contragrav setting for atmospheric use for things that reasonably shouldn't fly - sky battleships/stock zeppelins/etc - or for null-atmo fights where wings can't generate lift.
			- Adds repulsor setting for hover vehicles.
		- Rework Tag mode to use the new scoring datastructure.
	- Scoring:
		- Rework the code interally for a more consistent approach.
		- Sliders for controlling the time limits for head-shots and kill-steals.
		- Head-shots are now separated into clean-kills (within the time limit and was the only plane to damage the target), head-shot (within the time limit, but not the only plane to damage the target) and kill-steals (within both time limits).
		- Separate scoring categories for rockets and battle damage, giving: bullets, rockets, missiles, ramming and battle damage (including self-inflicted).
		- Improve score-related UI messages.
		- Updated parsing script to handle these new categories.
		- Remote orchestration is not yet updated, so report rocket damage as missile damage to the remote orchestration for now.
		- Fix bugs in continuous spawning and integrate it into the new scoring datastructure.
	- UI:
		- Always show a clock during competitions and competition start for time synchronisation of video post-processing.
		- Add the AI/WM GUI toggle hotkeys into the hotkey settings so they can be set.
		- Increase the default width of the vessel spawner window a bit to fit the tournament status for long tournaments. Automatically adjust existing window width if running a tournament with >99 heats.
		- Extra damage sliders for rocket and battle damage multipliers.
		- Add an Advanced Tweakables toggle to the BDArmory settings for easier access.
		- Add a toggle for the BDA AI toolbar button.
	- Internal stuff:
		- Balance for 25mm round (tested in FJRT2).
		- Adjustment of battle damage damage.
		- Automatically create the AutoSpawn folder on entering flight mode if it doesn't already exist.
		- Move toolbar button logic to BDArmorySetup.cs and enable toolbar button in SPH and VAB too for accessing BDA settings window.
		- Move SpawnField class to BDArmory.UI.NumericInputField.
		- Track the current HP ignoring ignored parts as needed.
		- Deprecate BD_AMMO_DMG_MULT.
		- CASE now uses EST.BattleDamage.
		- Change competition update tick to 1s to match best precision of vessel state checks.
		- Detection of crew being killed in 'uncontrolled' checks.

v1.4.7.1
FIXES
	- Quick fix for craft names using invalid filename chars in the remote orchestration.
	- Hide the Asteroid Rain radius slider when Follow Spread is enabled.
	- Fix some NREs.
	- Bias testing:
		- Add a random spawn order toggle to the vessel spawner window, which applies in single spawn mode (i.e., everything except continuous spawning).
		- Add option to parsing script to only parse the first N logs for use in analysing trends in results.
IMPROVEMENTS
	- Compiled with KSP 1.12 assemblies.
	- Improve MIA (survived/not-survived) definition in results logs.
	- Add telemetry readout to crafts TeamIcons HUD.
	- Ammo belts:
		- Add API ammo option to Vulcans, .50 cals, GAU, and M230.
		- Add 35x228AHEADBullet ammo option to Oerlikon Millennium turret

v1.4.7.0
FIXES
	- Fixes weapons without ammo not firing if Infinite Ammo enabled
	- EMPs will no longer shutdown SRBs
	- Rounds with the 'Proximity' Fuze type now properly proximity detonate
	- Adjust Krakensbane adjustments in 'full' Kerbal Safety to hopefully reduce amount of Krakenation.
	- Make the default value for kerbal safety be 'partial' instead of 'full' due to stability issues with 'full'.
	- Fix various NREs and memory leaks.
IMPROVEMENTS
	- General
		- Make the WM, MMG, pilot AI and surface AI modules get ignored by explosions, bullets, rockets, lasers and missiles so that they can be placed externally without being easily destroyed.
		- Disable Kerbal Safety "R.I.P." in-game messages as they were too spammy.
		- Add option for tournament parser to parse multiple tournaments.
		- Allow turrets other than the current one to track the main target so they're ready to fire if the current one is unable to do so.
		- Optimizes RocketFx, reduces rocket performance impact
		- Adds score reporting to proximity-fuzed rockets
		- Rocket soundFX is now customizable in weapon .cfg using the 'rocketSoundPath' field
		- Expands Scoring metrics; Adds HP remaining (how much of the vessel is left at end of heat) and MIA (is the vessel a wreck falling out of the sky, or an intact plane?) fields
		- Minor tweaks to Ammo Type PAW descriptions
		- Pulse laser beam duration now clamped to fire rate
		- Adds Incendiary ammo, plus associated BattleDamage support
		- Adds Custom Ammo Loadouts; weapons with multiple ammo types can be configured to fire non-homogeneous loadouts (e.g. AP, AP, AP, HE, AP...)
		- Adds Custom Ammo Belt config GUI
		- Weapons can be configured to use custom ammo belts in .cfg with useCustomBelt = true and ammoBelt = foo; bar;
		- New VesselModuleRegistry class for much faster access to vessel modules which gives a nice overall performance boost.
		- New Asteroid Rain game mode added.
	- Resource stealing:
		- Change resource steal to drain and fill containers evenly w.r.t. fraction of the containers, still respecting priority settings.
		- Add option for counter-measure stealing.
		- Add a few fuel and ammo resources that were missed.
		- Steal integer amounts of ammo and counter-measures.
	- Altitudes:
		- Add Max Altitude (AGL) setting to pilot AI with a toggle to enable/disable it.
		- Add action group options for 'Toggle Max Altitude', 'Enable Max Altitude' and 'Disable Max Altitude'.
		- Change killer GM altitude limits to AGL.
	- Team Icons
		- Adds reminder message to toggle stock vessel labels if they are enabled
		- Adds check if legacy Team Icons is installed. Remove prior installations of Team Icons
		- Integrates Team Icons into BDA
		- Adds User-selectable colors
		- Team colors no longer change if a team is completely destroyed
		- Adds Team Color indicators to Vessel Switcher GUI
		- Paintball mode now uses Team-colored paintballs for easy hit tracking
		- Adds Rocket alert icons
		- Threat Indicators now show all vessels attacking a vessel + 200f
		- Adds Telemetry HUD to Craft Icons
	- Battle Damage
		- Adds Damage Multiplier slider for Battle Damage Ammo Explosion damage
		- Ammo Explosion now properly scales damage based on distance, ammo remaining in the box
		- Ammo Explosions now properly report damage from explosions to attacker vessel responsible for triggering the explosion
		- Fuel Tank explosions now less damaging, now use Ammo Explosion Damage Mult setting
		- Adds ability to set lower limit on Engine thrust reduction from battle Damage
		- Adds adjustable threshold for engine kills from Battle Damage
		- Crew Fatalities now report name of vessel pilot was in
		- Crew Fatalities now knock out AI if all pilots killed
		- Self-Sealing tanks now prevent leaks unless below 50% HP
		- Leak rate now dependent on tank pressure
		- Fire burn rate now dependent on tank volume and available fuel
		- Firebottles temporarily shut down burning engines to extinguish them
		- Fires can now add heat to burning part
		- If Fire Damage and Fire heat enabled, fires will begin do damage once part temp exceeds damage threshold
		- Fueltanks/ammo boxes that are too hot will cook off
		- Fires now properly recognize MonoPropellant tanks
		- Fires now distinguish between surface and internal. Internal fires require firebottles to extinguish, surface fires will burn for a short duration, but not consume resources

v1.4.6.2
FIXES
	- Add in steer limiter localization text (is used on Modular Missile Guidance)
	- Always score damage from lasers, but only score hits with pulse lasers or when the accumulator is sufficient.
	- Fix bug in advanced targeting for fixed guns.
	- Adjust intake damage amounts.
IMPROVEMENTS
	- Add SRB battle damage.
	- Filled command seats can extinguish fires.

v1.4.6.1
FIXES
	- Fix various occasional NREs.
	- Fix bug in parser for 'dead teams'.
	- When a missile has lost its MissileBase set its isMissile tag to false so it no longer counts as a missile.
	- Don't detonate CASE ammo when the vessel is null, packed or not loaded.
	- Fixed overheated guns sometimes not being detected as overheated.
	- Fix AI having issues avoiding terrain when in an inverted dive (would happen most frequently during missile evasion).
IMPROVEMENTS
	- Updated HP patch for AoA Technologies.
	- Add check for whether guns with low RPM can fire soon, switch to a different weapon if the next time a low RPM gun can fire is greater than the Weapon Manager fire interval setting.
	- Re-add multiple subsystem targeting to the advanced targeting.

v1.4.6.0
FIXES
	- Store the armed/IFF state in the craft files instead of just the GUI strings.
	- Use the correct ShipConstruct in the editor for setting the max gun range and set a minimum of 10 for the max gun range to avoid breaking the part window sliders.
	- Add another check for vessels disappearing during spawning.
	- Add a 0.1s time-out to the ballistic trajectory closest approach simulation to prevent freezes.
	- Pause fire effects when the game is paused.
	- Store the armed and IFF states of explosive parts, not their GUI strings.
	- Fix missiles not being targeted when Engage Missiles option was selected.
	- Fix for the AI stopping extending prematurely.
	- Fix extending to get enough distance to fire missiles not working.
IMPROVEMENTS
	- Migrate non-static configs to the PluginData folder to avoid invalidating the ModuleManager cache (should give slightly faster start-up times).
	- Add a Game Modes section to the settings and rearrange the various toggles to match.
	- Add Heart-Bleed and Resource-Steal game modes.
		- Fuel resources that can be stolen are 'LiquidFuel', 'SolidFuel', 'Oxidizer', 'IntakeAir' and 'ElectricCharge'.
		- Ammo resources that can be stolen are those ending in 'Ammo', 'Shells' and 'Rocket'.
	- Remove Target Missiles toggle from the weapons manager, this is now automatically set based on if weapons onboard the craft have the engage missiles option enabled.
	- Expose AI extending settings to be editable by user. The AI extends when all of the below conditions are true:
		- The target is outside of an angle in front of the craft (default of 78 degrees, now selected using Extend Target Angle).
		- The target's speed is less than the craft's speed (default of target's speed is less than 80% of craft speed, now selected using Extend Target Velocity Factor).
		- The target is close (default of within 400 meters, now selected using Extend Target Distance).
	- Advanced targeting setting deprecated - targeting options are now per vessel.
	- Max turret target setting deprecated - is now set per vessel.
	- Adds Max Turret Targets setting to Weapon manager.
	- Adds Targeting Options to Weapon manager.

v1.4.5.0
FIXES
	- Fix the floating origin corrections to the vessel traces and apply the corrective rotations to the coordinates such that the local coordinates are (east, up, north) and the identity rotation is a craft pointing nose up with the underside pointing north. Include a simple python script to plot the traces.
	- Re-enable the extending debugging (when debug labels are on).
	- Fix the smoothing of the target acceleration and velocity for long-range targets to be applied dynamically so as to not affect short range targets and to reset when switching targets.
IMPROVEMENTS
	- Update the in-flight Guard Menu to match the settings in the weapon manager in the SPH.
	- Dynamically adjust (max) gun range based on the guns that are actually on a vessel.
	- Add log and competition status messages about disabling a vessel due to EMP damage.
	- Upgrade the numerical integrator for bullets and ballistic trajectory simulations to use the 2nd order symplectic leapfrog method (this vastly improves the accuracy and speed of the trajectory simulations). Allows for ballistic aiming out to at least 50km.
	- Include dead teams information in the results.
	- Re-worked steer limiter. Steer limits are now based on two control points, defined by four variables
		- Low Speed Control Point: Steer limit and Speed
		- High Speed Control Point: Steer limit and Speed
		- Below the low speed control point speed, the limit will be equal to the low speed steer limit.
		- Above the high speed control point speed, the speed will be equal to the high speed control point limit.
		- Between the two control points, the steer limit will vary linearly based on the craft's current speed.
	- Add toggle for whether competition status messages are displayed.
	- Change clearance check minimum drop time to greater than or equal to 0.1s instead of greater than 0.3s
	- Add 1.5 safety factor to blast radius determination for missile evasion
	- Clamp the minimum radar missile FOV used for missile evasion to 40 degrees, results in fewer instances of craft turning back towards a missile at inopportune times.

v1.4.4.4
FIXES
	- Fix missiles firing without exhaust and heat-seeking missiles firing without a target.
		- Regenerate exhaust prefab object pools when they're detected to contain nulls due to scene changes or reloads.
		- Trigger missile exhaust prefab detachment on part.OnJustAboutToDie and OnDestroy as well.
	- Add KeyNotFound and NRE checks in CheckForMissingParts.
	- Add in SetupAudio fix in some other places for audioSource. Add check for broken animations and give error instead of exception.
	- Remove ramming debugging toggle and just use the regular debug labels toggle instead. Adjust the debug statements in DebrisDelayedCleanUp.
	- Don't update RCS if we've just fired a missile or are trying to fire a missile.
	- Correctly calculate turret gimbal limits check, taking into account bullet drop.
	- Add generic rocket resource for rocket ammo boxes (fixes rocket launchers not being able to use rocket ammo boxes)
IMPROVEMENTS
	- Add option to trace vessel paths and orientations. Traces are logged in GameData/BDArmory/Logs/VesselTraces/<VesselName>-<StartTime>.json

v1.4.4.3
FIXES
	- The improved aiming code is now fixed (properly accounts for movement of the aiming vessel). Planet curvature is not yet taken into account.
	- Re-initialise the missile audio sources if they're null (fixes failure-to-fire issue).

v1.4.4.2
FIXES
	- Revert the improved gun aiming code as it's not working properly for non-stationary targets.
	- Fix potential NRE in DetachExhaustPrefab.

v1.4.4.1
FIXES
	- Fix AI trying to evade missiles after they were no longer threats or did not exist.
	- Use object pooling for missile exhaust prefabs to avoid memory leakage.

v1.4.4.0
FIXES
	- Add safety check around parsing BDA settings values.
	- Re-add laser min range check.
	- Multitargeting:
		- Multitarget now multitargets missiles.
		- Fix part targeting not resetting properly.
		- Update the target parts lists correctly. Only triger target part list updates when toggling options instead of every frame when the settings are open.
		- Add check for the list of targetable parts being empty.
	- Remove arc length term from DLZ calculation for ground launched missiles (this was breaking VLS parts).

IMPROVEMENTS
	- Missile evasion:
		- Behavior changes to notch and dive against missiles, pull away before impact for heat seekers only (continuing to notch is more effective against radar missiles). Fix spinning in place behavior that had occurred occasionally.
		- Simplify entry conditions for missile evasion behavior (only occurs within threshold of when your craft is set to dispense chaff/flares regardless of whether it has chaff or flares onboard).
		- Proper throttle settings for chaffing vs flaring.
		- Add check if radar missiles are still boresighted towards craft as a condition to treat missiles as a threat.
	- Shift 'AimAndFireAtEndOfFrame' to occur during the FashionablyLate timing phase of FixedUpdate and rename it 'AimAndFire'. This synchronises firing with the physics instead of waiting until the scene is rendered. It also occurs before Krakensbane adjustments have been made.
	- Simplify target threat to either be 0 (not under attack) or 1 (under attack).
	- Make Kerbal Safety a slider instead of a toggle to allow disabling ejection from cockpits, but still have existing kerbalEVAs deploy parachutes.
	- Add 'Start Comp. NOW Delay' slider for automatically triggering 'Start Competition NOW' after a given delay.
	- Tournament results parser:
		- Add missile hits taken to the parser ('HitByMis' in console output, 'missileHitsTaken' in CSV file).
		- Hide empty columns in the parser console output.

v1.4.3.3
FIXES
	- Fix various NREs.
	- Add stacktrace to exception warnings in ModuleCASE.
	- Detonate bullets and rockets when they hit kerbals.
IMPROVEMENTS
	- Improve the gun aiming code.
	- Include missile hits separately from count of parts hit by missiles in scoring logic and update tournament parser.

v1.4.3.2
FIXES
	- Add missing Weapon condition checks.
	- Yet another attempt at avoiding the CometVessel bug.
	- Escape double quotes in vessel names when writing the logs to avoid breaking JSON parsing.

v1.4.3.1
FIXES
	- Add missing values for Hydra70 and 8KOMS rockets.
	- Fix smartpick not finding priority 0 lasers.
IMPROVEMENTS
	- Add gravity gun (RWP S3R4), F-86 launcher, generic rocket ammo and FFAR70 rocket definition.

v1.4.3.0
FIXES
	- Fix rockets overriding the weapon name and breaking the editor.
	- Maintain incoming missile warning while missiles are still incoming.
	- Limit 'firing at me' detection (from guns) to the range of the weapon being fired.

IMPROVEMENTS
	- Make altitude limits independent of RWP and change localisation.
	- Make missile targeting check depend on blast radius of incoming missile instead of fixed at 60m and include check for passing in close proximity.
	- Return a full list of incoming missiles sorted by distance in UpdateGuardViewScan instead of just the first found.
	- Convert 'under attack' and 'under fire' routines to maintain their state until 1s after last notification instead of simply resetting after a fixed period.
	- Adds Impulse/Gravitc functionality for ballistics/rockets/lasers
		- Adds some new configuration fields
			- impulseWeapon = foo //gun/laser will deal impulse instead of damage
			- Impulse = n //magnitude of impulse delivered per bullet/rocket/pulse laser shot, and impulse/sec delivered by beam lasers. setting this negative will make attractor lasers instead of repulsor lasers
			- graviticWeapon = foo //gun/laser will temporarily modify mass of hit part
			- massAdjustment = n //mass, in tons, added per sec by beams or per hit by bullets/rockets/pulselasers
		- Adds some new rocketdef config options
			- gravitic = foo //rocket will temporarily modify weight of parts hit by rocket and its explosion
			- impulse = foo //rocket applies non-damaging impulse to parts hit by rocket/explosion
			- choker = foo //rocket will temporarily disable air intakes caught in its blast radius
			- EMP = foo //rocket will apply EMP buildup to targets within blast radius

v1.4.2.10
FIXES
	- Prevent log spam from ModuleWeapon.CheckAIAutoFire.
	- Fix width of drag window in Loaded Vessel Switcher.

IMPROVEMENTS
	- Add a min altitude limit for the killer GM (once a competition is active).
	- Make the sequenced competition command sequence dependent on the BDA round.

v1.4.2.9
FIXES
	- Fixes for Killer GM scoring attribution and ramming detection.
	- Fix for if a rootpart is null during spawning.
	- Set the kraken eating things active for the correct RWP rounds.
	- Fix local tournament sequencing when using sequenced competition (S3R3).

v1.4.2.8
FIXES
	- Make the Kraken eating things code specific to certain RWP rounds and only active during a competition.
	- Fixes to sequenced competition for RWP S3R3 to work with the remote orchestration.
	- Update vessel switcher teams list as necessary.
	- Remove direction from explosions of impacting bullets as that makes no sense.
	- Add debug log warnings for previously silently ignored exceptions and fix a couple of NREs.
	- Fix exception in explosion handling when part.rb is null (but part.Rigidbody isn't).
	- Reloading/MultiTarget fix/weaponPriority
	- Multitarget fix
	- Chernobyl bugfixes
	- Various NRE fixes

IMPROVEMENTS
	- Separate bullet movement and collision detection into separate functions. Detect collisions in the initial frame of a bullet so point blank shots work.
	- Detect exit collision with objects when the barrel of the gun is within the object's collider, i.e., sub-point-blank shots.
	- Added a slider for configuration of specific RWP rounds.
	- Adjust parsing scripts for updated logging tags format. Add slider for setting the length of time of the death camera.
	- Standardise the format of debug log messages to '[BDArmory.ModuleName']: ...
	- Reload anim support

v1.4.2.7
FIXES
	- Add a "Kerbal Inventory" slider to configure how kerbals' inventories are adjusted when "Kerbal Safety" is enabled (default is "Parachute Only").

v1.4.2.6
FIXES
	- Fix bug in loading spawn locations on fresh installs.
	- Give vessel spawning more than 5 frames to wait for the reference transforms.
	- Add checks in various parts of the code to avoid potentially applying forces to physicsless parts.

IMPROVEMENTS
	- Tweak explosions from the nuclear engine code to include triggering on detachment (i.e., no WM) and give a 0.5s delay after detachment or running out of fuel before exploding.

v1.4.2.5
FIXES
	- Wait for reference transforms to be assigned during spawning to avoid NREs.
	- Tweak auto number of vessels for FFA with only a few craft.
	- Fix a variety of NREs in the nuclear engine code.
	- Avoid applying forces to physicsless parts (no rigid body), which removes the need for try..catch block. Clean up code.
	- Track last valid atmDensity of nuclear engine to ensure correct value while vessel being destroyed.
	- Use the approximate GetArea function instead of the radiative area if the radiative area is not available.
	- Clean up formulas for blast impulse. Only apply damage/impulse to each part once per explosion.

v1.4.2.4
FIXES
	- Fix various NREs.
	- Remove null-coalescing operators from Monobehaviours as they don't work in Unity.
	- Multi-Target barrage fix: weapons targeting a target outside their fire arc will now be skipped instead of bringing the barrage to a halt until the offending weapon can be brought to bear.

IMPROVEMENTS
	- Added a few more interesting spawning points (currently requires removing the old spawn_locations.cfg file in order to update, this will be changed soon).
	- Re-work rocket damage to do kinetic damage and penetrate armour and correctly report scoring info.
	- Shared bullet/rocket code moved to Misc.ProjectileUtils.cs.
	- Weapon priority adjustments:
		- Guns targeting ground will now prioritize biggest impact (bullet mass * velocity) instead of tntmass.
		- Guns targeting air will now prioritize RPM for fighter-sized targets, and prioritize larger caliber guns when targeting larger targets (bombers/zeppelins/Ace Combat superweapons).
		- Add weapon priority slider allowing setting custom weapon selection order for guns/rockets.
	- Added Chernobyl Nuke module for RWP S3R2.
	- Update the list of maintainers and contributors in the README.

v1.4.2.3
FIXES
	- Fix the issue of player names in the remote orchestration containing the separator character.

v1.4.2.2
FIXES
	- Correct logic for checking if a weapon is powering down/disabled.
	- Actually use the modified team starting distance for teams.
IMPROVEMENTS
	General:
	- Allow configurable muzzleTransformName.
	- Trigger RemoveCometVessel on onCometSpawned instead of onNewVesselCreated.
	- Allow middle click individual 'T' icons to set neutral team.
	- Small optimisation in explosion book-keeping.
	- Increase maximum firing angle to 4 in both the weapon and the weapon manager.

	Kerbal Safety:
	- Ejection from cockpits and cabins is now working. Note: ejecting lots (>100) of kerbals simultaneously can cause KSP to freeze for several minutes.
	- Set random rotation and torque to ejected kerbals. Disable collisions while manually moving the EVA kerbal.
	- Let the Kraken eat kerbals that get invalid positions (NaN). Note: this doesn't appear to be an issue now due to the fix above.
	- Self-destruct action group for WM (helps with testing things).
	- Remove the kerbals' jetpacks to save 45kg.

	Parsing script:
	- Add default interpreter (for Linux) to parsing script.
	- Default to looking for the latest tournament folder.
	- Rearrange display order so that the 'Score' column is first after the 'Name' column
	- Fix check for default team names in summary
	- Only print teams summary if it's not 'A', 'B', ... as those aren't consistent.
	- Update formatting of tournament parser output to console for consistent column spacing.
	- Add various options to tournament parsing script (run with -h flag for help).
		-q Don't print results summary to console. (default: False)
		-n Don't create summary files. (default: False)
		-s Compute scores. (default: True)
		-so Only display the scores in the summary on the console. (default: False)
		-w Score weights (in order of main columns from 'Wins' to 'Ram'). (default: 1,0,-1.5,1,2e-3,3,1,5e-3,1e-5,0.01,1e-7,5e-2)
		-c Parse the logs in the current directory as if it was a tournament without the folder structure. (default: False)

v1.4.2.1
FIXES
	- Fix a stack overflow due to recursion in IsValidVessel check.
	- Swap labels of 'high' and 'low' speed steer limiters.

v1.4.2
FIXES
	- Further adjustments to remove annoying space objects that get spawned during competitions.
	- Add warning about missing SpawnProbe.craft.
	- Bugfix for Scores when starting competition without using spawning.
	- Fix occassional NRE in SmartFindTarget
	- Adjust 'inhibiting gain alt' debug messages.
	- Fix for damage reduction formula, armor damage reduction occurs for armor thickness > 20. Max armor thickness of 1500 results in ~90% damage reduction.
	- Disable (missing) legacy code analysis tools in .csproj.
IMPROVEMENTS
	- Explosive damage penetration:
		- Basic explosive damage penetration handling. Parts closer to the explosion are ablated first with a small amount of bleed through for relatively weak parts.
		- Add comment on original BDA methodology source. Calculate positive phase time based on source method equations. Correct CalculateIncidentImpulse not bounding scaledDistance
	- Remote orchestration:
		- Add slider for inter-heat delay for remote orchestration. Also, doesn't rely on RWP option being enabled now.
		- Make remote orchestration baseURL configurable, defaults to FC.
	- Pilot AI:
		- Enable storing and restoring settings (keyed by vessel name) for tuning a vessel in-flight and setting those settings in the SPH.
	- Weapon manager / weapon configuration:
		- Rename Target Acceleration to Target TWR since that's what it is
		- Change firing angle to scale with distance and size of target.
			- Include maxDeviation/2 from the weapon in the firing angle calculation to allow more firing at longer range for spray-and-pray guns. Increase max firing angle to 3.
			- Prioritize weapons that are within their firing angle.
			- Adjust weapon prioritisation of being within firing angle for firing angle scaling with target size and distance.
		- Added VIPs, which allow you to set up behavior such as guarding your VIP, or attacking enemy VIPs and ignoring craft defending them.
			- Add new "Is VIP" toggle to the weapons manager. Allows you to set a craft as a "VIP" which opens up new target priority options.
			- Added new target priority options "Protect My VIPs" and "Attack Enemy VIPs". Setting positive values on these sliders will result in the craft targeting enemies that are targeting VIPs on its own team, or attacking enemy VIPs, respectively.
		- Don't try to engage torpedoes with guns/missiles/lasers.
		- Use other weapons for ground targets if missiles fired is greater than or equal to max missiles on target setting.
		- Don't use arc length calculation for torpedo DLZ since they can turn much more quickly in water than airborne missiles.
	- Advanced Targeting option in BDA Settings:
		- Enables turrets to target multiple simultaneous targets
		- Enables selecting CoM or non-CoM targeting options
	- General:
		- Updated tournament parsing script that puts subfields in their own columns in the CSV file.
		- Move GetRadius to VesselExtension.cs.
		- Localisation changes for steer limiter.
		- Update Typhoon engine (caesar_hone_60.cfg)

v1.4.1
FIXES
	- Fix missile hit attribution from missiles without BDExplosivePart modules.
	- Don't include negative thrust percentage drives (Danny2462 drives) in max acceleration calculation as they don't contribute to the thrust.
	- Fix BDRotaryRail stack overflow and give warning if the conditions that gave rise to it occur again.
	- Put chute into right state before deploying it with WM AG.
	- Don't assign gender to spawned kerbals, let KSP do it.
	- Fix CheckSafeToFireGuns for debris preventing firing due to being too close to the target.
	- Reduced (but not eliminated) exceptions due to comet vessels.
	- Change the minimum damage amount of 0.01 to 0 as this was the cause of the fire damage over time applying despite the game being paused or slowed with time control.
	- Fix NREs in explosions from ClusterBomb.cs
	- Add KSP version dependent checks for part.IsKerbalEVA and crew.ResetInventory.
	- Updates Rocket targeting, fixes aimer alignment
	- Updates laser Infos with proper resource usage
IMPROVEMENTS
	UI and quality-of-life tweaks:
	- Add fault tolerance for missing bullet defs in GetInfo.
	- Add similar handing of missing or broken rocket info as for bullet info.
	- Move ConfigNode functions to their own translation unit.
	- Add 'Clear Debris Now' and 'Clear Bystanders Now' buttons to the Vessel Spawner window (in Spawn Options).
	- Option for using the old format of the Vessel Switcher window ('t'). Option for reassigning teams on spawn or retaining the original team name defined in the SPH. Right clicking 'T' in the Vessel Switcher window resets vessels to their original teams. Spawning from 'Folders' assigns the folder as the team name if team reassignment is enabled.
	- Remember position of RWR, Radar and TargetingCamera windows.
	- Add optional extra parameter to CreateExplosion to specify the weapon name (to be used for in-game messages for missile strikes).
	AI:
	- Remove 150m constant from terrain avoidance and base the terrain alert detection radius on the vessel diameter to improve ground strafing.
	- New slider to control strafing speed of ground targets.
	- Lasers and missiles now respect minimum engagement range settings
	- Fixed issues that were preventing AI from finishing the extending routine
	- Speed Adjusted Steer Limiter
	Spawning and Tournaments:
	- Teams options in the spawning and local tournament settings, including custom serialisation (doesn't support commas in craft file names) and UI adjustments.
	- Configure how seats are filled in the Vessel Spawner Window: minimal, all control points, also cabins. Crewed weapons always get filled with 1 crew.
	- Option to reset maxHitPoints on vessels loaded into flight mode (e.g., during spawning). Uses the MM patched value if available.
	- More consistent addition of _1, _2, etc., to vessel names which should make teams of the same vessel have valid results summaries in many cases without having to rename each craft (which is still a better solution!), not just the files.
	- Add RESULT line to competition log to indicate overall result of the competition (needed for teams).
	- Updated format of log files for teams. Updated tournament parsing script.
	- Add break-down of deaths (clean Bullets, clean Missiles, clean Rams, Assists, Suicides) and kills (Bullets, Missiles, Rams), and normalised death order and death time to the results summary.
	- Set KSP version of SpawnProbe to 1.9.0 to avoid issues with spawning on older installations.
	Kerbal Safety:
	- Move kerbal safety code from autonomous combat seat check in BDACompetition.cs to KerbalSafety.cs with its own toggle.
	- Free-falling kerbals deploy parachutes.
	- Kerbals in falling command seats leave the seat.
	- Vessels (and kerbals therein) are recovered during spawning instead of getting destroyed.
	- Surviving kerbals are recovered and immediately available for flying in the next competition instead of being MIA.
	- Ejection from cockpits is still a WIP.
	Battle Damage:
	- Battle damage is now configurable with multiple sub-categories, with the following toggles. Per-hit proc chance is also adjustable.
	- Fuel Tanks
		- FuelTanks will now leak when hit
		- Tanks may be configured to be self-sealing, trading some fuel capacity for leak resistance
		- Tank leak rate and leak duration can be adjusted
	- Ammo Boxes
		- Ammo boxes will potentially explode if hit
		- Ammo Boxes can be set to explode when destroyed
		- Adds ModuleCASE to ammo parts. Caselevel can be set from 0-2, higher levels reduce ammo explosion damage, at the cost of increased mass and cost.
	- Engines
		- Engine thrust reduced when hit, will start leaking fuel/catch fire/shut down when badly damaged
		- Intakes performance reduced when hit
		- Engine Gimbals can fail when hit
	- Wings
		- Wing damage per hit reduced
		- Wing lift loss capped at 50% total lift
		- Wing damage per hit is now configurable
		- Ailerons can fail when hit
	- Subsystems
		- Subsystem components
		- SAS/Radar/etc can be disabled when hit
	- Command
		- Control damage when hit
		- Pilots can be killed from cockpit damage
	- Fires - if a tank is leaking fuel, chance for leak to ignite
		- Fire damage over time
		- Fires in cockpits or other crewed or crew adjacent parts will be automatically extinguished.
		- Adds ModuleSelfSealingTank, can be toggled to prevent tanks leaks until tank receives substantial damage. it also adds the ability to configure fueltanks and engines to carry firebottles to extinguish fires
	RCS:
	- Improved RCS calculation accuracy and speed, your craft's RCS may be slightly different from 1.4.0.7
	- Recalculate RCS occasionally when parts are lost (to account for damage or missiles firing)
	- Fix engine afterburner textures affecting RCS calculation (was an issue for Tiger and Cheetah engines from AirplanePlus)
	Missiles:
	- New variables that affect heat seeking missile performance: lockedSeekerFOVBias, and lockedSeekerVelocityBias. See Sidewinder config file for more details.
	- Fixed allAspect and maxOffBoresight to work as intended. Vertical launch systems (VLS) and high off-boresight missiles should work as intended. See AIM-120 config file for details.
	- Add ability for Air-to-Ground missiles to lead targets based on their velocity.
	- Fixed Dynamic Launch Zone calculation, should result in more close-range missile fires and high off-boresight missiles only firing when they are likely to hit their target.
	- Better explanation of what missile parameters do added to Sidewinder and AIM-120 config files (new heat seeker value description in Sidewinder config file).
	- Updated torpedo tuning from Kurgan.
	Target Priority:
	- Target acceleration target priority now returns TWR/10 instead of instantaneous acceleration/10. Is set to -1 when target craft loses engines.
	- Less teammates engaging target priority now returns -1 when all teammates are engaging the same target instead of 0 (allows for better ganging up on the same target).
	Parts:
	- New armor panels, rescaled armor panel part mass, cost, HP to scale properly based on size.
	- Remove AIM-4 missiles, are moved to the Flying Circus mod for now, planned to be re-released in a future BDA expansion mod.
	- Added new Typhoon engine to fill the gap between Juno and Panther.
	Effects:
	- New FireFX effect

v1.4.0.7
FIXES
	- Fix rendered elevations being negative of the intended elevation.
	- Fix logic for NRE check in TargetPriMass.
IMPROVEMENTS
	- Check that falling kerbals haven't regained their seat before deploying their parachute.
	- Force RCS update on competition start to allow landing gear and other robotics to have move into flight positions.
	- Adjust RCS normalization from 4.0 to 3.8 so sphere with 1m^2 cross section has 1m^2 RCS.
	- Change lockbreaking strength to 300, was agreed upon value after some discussion with BDAc communities.
	- Change minimum lockbreak to 0.

v1.4.0.6
FIXES
	- Fix spawning over water to use water height instead of terrain below. Allow negative spawn altitudes.
	- Fix stack overflow if collision avoidance period is 0.
	- Check for various NREs in target priority functions.
IMPROVEMENTS
	- Rename 'Steer Factor' to 'Steer Power', 'Steer Ki' to 'Steer Correction' and add '(P)', '(I)' and '(D)' to the three fields.

v1.4.0.5
FIXES
	- Fix craft being able to fire radar missiles at a target they could not lock when another target they could lock was nearby. This usually happened when the target launched missiles, since missiles have a 999 m^2 RCS by default.

v1.4.0.4
FIXES
	- Bugfixes for rocket turrets.
	- Bugfix for Oerlikon bulletType.
IMPROVEMENTS
	- Tweaks to fire angle:
	- Default of 3°
	- Adjustable for each weapon from 0° to 6°

v1.4.0.3
FIXES
	- Fix broken rotation caused by the radar snapshot rendering process.
	- Give the terrain renderer more time to spawn the terrain when spawning craft at a new location.
IMPROVEMENTS
	- Speed up the radar snapshot rendering.

v1.4.0.2
IMPROVEMENTS
	- Use values from BDArmory's default bullet definition for bullet definitions that are missing fields or have invalid values.
	- Warn about these in the logs.

v1.4.0.1
IMPROVEMENTS
	- Improved parsing of the bullet and rocket defs with feedback on what went wrong. Use grep "ERR.*\[BDArmory\]" KSP.log (or similar search functionality) to find the failures.

v1.4.0
FIXES
	- A whole bunch.
IMPROVEMENTS
	Note: Mod creators should look at the new BulletDef configuration options in order to update custom BulletDefs.
	- Major overhaul of ModuleWeapon thanks to SuicidalInsanity.
		- Now supports magazine-fed weapons that must be occasionally reloaded
		- Now supports burst-fire weapons (multiple shots per fire command)
		- Now supports crewed weapons that require a kerbal present to fire
		- Now supports shotgun-type weapons
		- RocketLaucher functionality has been folded into ModuleWeapon, Rocketlaunchers will need to be reconfigured.
		- RocketLaunchers can now be supplied from external ammo boxes.
		- Gyrojet guns now supported
		- Rocket class weapons can now use FlaK settings (airDetonation, proximityDetonation, maxAirDetonationRange)
		- Can set custom fire sounds for Rockets
		- Pulse Lasers now supported
		- Lasers can now use accuracy setting (MaxDeviation)
		- Lasers can do explosive damage on hit
		- Lasers no longer Aim-bot
		- Laser and rocket scoring implementation
		- Weapons now support multiple ammo types
		- Adds per-ammo tracer settings
		- Adds per-ammo fuze settings
		- Airdetonation/proximity detonation now per-ammotype, set in bulletdef via fuze setting
		- Changes to bulletdefs - added a fuze setting: none, timed,proxi,flak
		- Tracer stats moved to bulletdefs following ammoswap implementation
		- Tracer width now dynamically determined based on caliber; can be overridded in weapon cfg (laser support, mainly)
		- Tightened up Ai accuracy - missilefire; changed permitted firing tolerance from 2-4 deg to user-customizable 0-2 deg
		- Added cluster ammo weighting to bool smartweaponselect
		- Adds debilitated bool to TargetInfo/MissileFire for EMP weapons
		- Rockets use object pooling and are configured in BulletDefs/BD_Rockets.cfg.
		- New ModuleWeapon.cfg settings
			- BeltFed = False // enables mag-fed weapons
			- RoundsPerMag = n // shots per magazine or shots per burst if BurstFire = true
			- ReloadTime = n // time(sec) needed to reload
			- BurstFire = true // enables burst fire; use with RoundsPerMag
			- Crewserved = true // weapon part must have CrewCapacity > 0 and Kerbal occupant
			- ExternalAmmo = true // rocket class weapons use external ammo boxes
			- RocketPod = true // default true, used if rocketpod w/ rocket submodels (e.g. Hydra70)
			- Setting rocketPod = true will default RoundsPerMag to the # of rocket submodels
			- Setting rocketpod = false will default externalAmmo to true
			- RocketPod = true and externalAmmo = true will set BeltFed = false
			- PulseLaser = true // enables pulse laser functionality instead of beam, uses roundsPerMinute for firerate, Maxdeviation for accuracy, same as guns
			- HEpulses = false // enables laser impacts to act like HE rounds
			- HeatRay = false // beam lasers now AoE, add heat instead of damage
			- ElectroLaser = false // lasers now have EMP effect, use ECPerShot
			- BulletType = a; b; c // for ammo swap, add each ammo type the weapon can use separated with a semicolon
			- AirDetonation, proximityDetonation deprecated, moved to bulletDef.cfg
		- New Bullet_defs settings
			- subprojectileCount = n // number of projectiles per round, default 1
			- fuzeType = None // choose from None, Timed, Proximity, or Flak
			- projectileColor = 255, 15, 0, 128//RGBA 0-255, final color of shot if fadeColor = True
			- fadeColor = False //fade color from startColor to projectileColor?
			- startColor = 255, 90, 0, 32 // initial shot color if fadeColor = True
			- BlastPower, Heat, radius deprecated
		- New Rocket_defs settings
			- rocketMass = n //weight in tons (10kg rocket is 0.01, etc)
			- caliber = n // rocket diameter
			- thrust = n // thrust
			- thrustTime = n // rocket fires for n seconds
			- shaped = false //does rocket have shaped charge warhead
			- flak = false //air + proximity detonation
			- explosive = true //does it explode
			- tntMass = n //mass of tnt in kg
			- subProjectileCount = 1 //cluster rocket quantity, default 1
			- thrustDeviation = 0.1 //accuracy, higher = wider divergence from boresight
			- rocketModelpath = foo //file location of rocket model, e.g. "BDArmory/Parts/h70Launcher/h70Rocket/model"
	- Improvements to RCS/stealth/ECM:
		- Craft with a lower modified radar signature (from ECM Modules that reduce signature) no longer have increased lock range. The range at which craft are locked will be accurate based on the RCS Window in the SPH/VAB if no jammers are used.
		- Re-worked RCS system. Calculate 95 azimuth/elevation pairs across 0-180 deg Az, 23 to -23 deg El, take the 3rd quartile of the distribution to use as the total RCS.
		- Scale RCS up by 4 to better match reality and provide better balancing against stock radars.
		- Display worst three Az/El pairs in the BDA editor window so that users can improve their design.
		- Fix to turn on all ECM jammers when an incoming radar-missile is detected.
	- Improvements to missiles:
		- Allow firing multiple missiles at the same radar target without losing radar lock. Firing missiles at multiple locked targets needs considerable work to be feasible.
		- Fix known issues with terminal guidance.
		- Add option for configuring FireFOV of a turret (fires when pointing within this angle of target). Reduce step size of fire interval to 0.5s.
	- Improvements to pilot AI:
		- Allow users to set "Firing Angle," the angle the weapons are within of being on target before firing. Default is 1 deg. Setting is on Weapons Manager. Setting only affects weapons with a yaw and pitch range of less than 5 degrees for both axes.
		- Make wing commander 'spread' and 'lag' values persistent.
		- Allow pilots in the "Attack" command to evade if they are being fired at by another craft
		- Sliders for controlling threshold and period of collision avoidance between vessels.
		- Allow craft to evade if they are under attack while being commanded to "Attack."
	- UI improvements:
		- Improved behaviour for entering spawn coordinates and altitude.
		- Add a slider in tournament settings to control delay between heats.
	- Other improvements:
		- Further balancing of the 30mm tnt mass to 0.077 (from 0.081).
		- B9 Proc Wings HP patch

v1.3.8.2
IMPROVEMENTS
	- Rebalance 20mm and 30mm ammo tnt amount.
	- Weapons using electric charge count as always having ammo (not just those ending in 'Laser').
	- Remove surface attachment option from combat seat.
	- Add option to automatically kill off WMs after 5s when they become uncontrolled.
	- Kerbals in falling combat seats eject to safety.
	- Deploy halo chute for falling kerbals. Add AG to WM to deploy chutes on external kerbals.

v1.3.8.1
FIXES
	- Report death time to web orchestration in seconds instead of minutes
IMPROVEMENTS
	- Autonomous combat seats: when disabled (default) during competitions, combat/command seats disable the AI when the kerbal leaves the seat and vessels that are comprised of only a single combat/command seat explode.
	- Reduce max fireBurstLength to 10 and stepIncrement to 0.05 to allow more control of gun burst length.
	- Updated HP patch from CeruleanEyes

v1.3.8
FIXES
	Main fixes:
		- The remaining main memory leaks have been eliminated resulting in a noticeable performance boost. (There are still some leaks, but they amount to only a few GB if left running overnight.)
		- Explosions are no longer limited to 5 at a time.
		- Fixed decals not being returned to the object pool so that they work efficiently now.
	Other fixes:
		- Use the correct spawn distance value in the remote orchestration.
		- Unity's fake nulls strike again: properly reset explosion object pools on scene changes.
		- KSP is labelling some missiles as debris. Detect these and don't remove them.
		- Bugfixes, memory leak fixes and optimisations.
		- Don't use Parallel.ForEach to update ramming information as Unity doesn't like get_transform being called from threads.
		- Assign font attributes in Awake instead of Constructor.
		- Fix potential NRE in ApplyDamage in PooledBullet.cs
		- Fix a potential NRE in continuous spawning where a spawned vessel gets destroyed before it's activated.
		- Fix special case of vessels with combat seats getting renamed.
		- Reset spawn position and rotation after spawning as sometimes KSP packs and unpacks craft and resets things!
		- Wait an extra update during spawning to allow reference transforms to be assigned.
		- Use altitudes from FlightGlobals when raycasting fails during spawning.
IMPROVEMENTS
	Main improvements:
		- Rebalance of explosion damage from bullets to approximate the previous DPS of the browning, vulcan and gau-8.
		- AI/WM now cost 0.
	Other improvements:
		- Remove the '5' from the options for heat size in the automatic vessels per heat optimisation to ensure a minimum heat size of 5.
		- Add configurable keybindings for tournament setup and running. Improve layout of 'Edit Inputs' window.
		- Added an 'auto-enable vessel-switching' option to general settings. Added 'auto' mode for tournament generation that chooses an appropriate number of vessels per heat and distributes the deficit over multiple heats.
		- Set up paintball decal pools when the paintball toggle is toggled.
		- Extra damage sliders in-game
		- Small optimisation to avoid reallocating Ray instance in PooledBullet.cs
		- Add the explModelPath to the browninganm2.cfg
		- Use a split slider for tournament rounds setting to allow up to 100 rounds.
		- Reuse deathOrder variable instead of fetching it from BDACompetitionMode.Instance again.
		- Use minSpeed instead of idleSpeed in steer limiter. Scale possibleAccel by 1/15 as before (but without G) for now until we find a better solution.
		- Additional regular check for vessels renamed as planes due to the combat seat.
		- Automatically end a continuous spawning competition when there's nothing left to spawn and <2 active craft.
		- Add a max altitude GM killer.
		- Updated Python scripts for parsing competition results logs.
		- Also trigger competition end when there's only 1 team left.
		- Include engine acceleration but not gravity in GetSteerLimiterForSpeedAndPower as it makes gliders and RegainEnergy work better.
		- Use afterburners when regaining energy.
		- Trigger the target scan after all the teams have been assigned.
		- Enable target priority by default.
		- Stop extending when changing targets.
		- Include death time and normalised death order in web orchestration reporting with surviving player death order/time set to max

v1.3.7
FIXES
	- Fix bug in spawning due to setting a non-default control point orientation.
	- Merge two flags that represent the same status.
	- Don't reload settings when opening the main settings window as it is already loaded on start and messes with other settings windows.
	- Fixes AI not using Torpedos
IMPROVEMENTS
	- Local tournament mode (in the Vessel Spawner window).
	- Re-worked debris/bystander removal.
	- Sliders (in general settings) for many competition timers (such as the killer GM and various grace periods).
	- Cargo bays only automatically close if they've been opened to drop bombs/missiles.
	- Move vessels directly to sea-level if spawning in water.
	- Removed RWP season 2 round 3 specific code.

v1.3.6.5
FIXES
	- Fix resetting missile on miss. Add a bindable action group for resetting the missile if it has a pilot AI.
IMPROVEMENTS
	- Use aiming mode for steering when within 8s of ramming target.
	- Add in easing factors for ramming, correct missing negative term, use ramming vessel acceleration instead of relative acceleration.
	- Improved lead-time calculations for missile guidance with ease-in factors.
	- Enable target lock for missiles with weapon managers to prevent re-targeting issues.
	- Add 1f to sum of priorities to help with target bias.

v1.3.6.4
FIXES
	- Various
IMPROVEMENTS
	- In-game configuration of Round 3 targets spawn point.
	- Preserve target spawn settings when leaving/entering flight mode.
	- Save settings when closing the Vessel Spawner window.
	- Set target spawn location on using 'interesting' buttons.
	- Add a countdown slider for the Round 3 GUI and set the default target geoCoords to 1°N (equivalent to around 11 km).
	- Re-enable detonation of armed explosive parts when they are destroyed.
	- Use partHit position instead of vessel.CoM in proximity calculations. Estimate distance on next fixed update and detonate if expected to collide next fixed update.
	- Use time to closest point of approach for AAM guidance.
	- Use new Saturn texture created by Stardust

v1.3.6.3
FIXES
	- Don't autodestruct missiles if the explosive parts are using the override.
	- Show message about why the vessel spawning timed out.
	- Prevent windows from being competely off-screen (the drag region may still be off-screen though). Toggling "Strict Window Boundaries" will bring all the windows onto the screen if you can't find them.
IMPROVEMENTS
	- Absolute Distance vs Distance Factor toggle and expanded Spawn Distance slider for ranges up to 20km. (Note: for distances over 10km, it struggles due to the PRE and terrain. Using an airborne spawn first can help fix this.)
	- Add 'Detonate At Minimum Distance' to MMG. (Note: MMG doesn't have an 'ignore friendlies' yet.)
	- Add 'Detonate At Minimum Distance' for explosive parts too.
		- Note: the effect of 'Detonate At Minimum Distance' is to delay the detonation/triggering once it's within the detonation radius until the distance is minimised.

v1.3.6.2
FIXES
	- Increase the ground finding raycast distance for spawning at ground level for large radii. - Give the craft an extra 5s to land and set the spawnFailureReason if it times out.

v1.3.6.1
FIXES
	- Various
IMPROVEMENTS
	- Allow the missile to get out of NotSafe mode when it is its own parent, which enables proximity detonation on such missiles.
	- Update release command conditions
	- Reuse pilot/missile combos if miss occurs

v1.3.6
FIXES
	- Various
IMPROVEMENTS
	- Separate Vessel Spawner window.
	- Proximity fuze added to warhead, with IFF check.
	- Team spawning function.
	- Add death times to death order.
	- Better default values for dynamic damping to decent values.
	- Enable APBulletMod
	- Add death order to records.
	- Relax min < max condition for damping sliders. Relabel min/max as off-target/on-target for clarity.
	- Use a time-based check for recentlyDamaged condition in camera switch weighting.
	- Add pyramids location to default interesting spawn locations.
	- Paintball, now with 100% more paint
	- Special (temporary) button for spawning Round 3 of Season 2 of Runway Project.

v1.3.5.6
FIXES
	- Various
IMPROVEMENTS
	- Use secret token for reporting of scores in remote orchestration.

v1.3.5.5
FIXES
	- Bugfix (don't adjust gravity after the competition stops).

v1.3.5.4
FIXES
	- Bugfix for near-terrain spawning.
IMPROVEMENTS
	- Continuous single spawning mode (when enabled, the single spawn will respawn vessels 10s after the competition ends; it also automatically starts competitions).
	- Relocation of competition duration slider to general slider settings.
	- Competition duration slider now affects all competitions instead of just remotely orchestrated ones and has an 'unlimited' setting.

v1.3.5.3
IMPROVEMENTS
	- Change some variable names to reduce bandwidth due to JSON payloads.

v1.3.5.2
FIXES
	- 10s grace period instead of 60s for Gravtity Hacks (Increase Gravity on Death).
IMPROVEMENTS
	- Improvements to the remote orchestration window.
	- Ramming and parts lost and missile damage tracked for web service.

v1.3.5.1
FIXES
	- Fix the status in the Remote Orchestration Window

v1.3.5
FIXES
	- Fixed various different issues that made flares ineffective.
	- Synchronise continuous spawning to competition update ticks when competitions are active.
	- Adjust location of camera reversion for continuous spawning and make sure that the camera distance gets set.
IMPROVEMENTS
	- Change section toggles in settings window to full-width buttons to make them more obvious.
	- Added a toggle for keeping BDA windows within the screen.
	- Added a toggle for dumping continuous spawning logs every spawn toggle.
	- Improvements for the Remote Orchestration Window
	- Improvement to location switching with the 'interesting spawn locations' buttons and camera handling during spawning.
	- Latest HP part fixes from CeruleanEyes for some Mk2/H parts.
	- Included SuicidalInsanity's B9 HP patch
	Gravity hacks:
		- Gravity value displayed on vessel switcher
		- Kill time of 1s when landed with gravity hacks enabled
		- Adjustments to gravity hacks to scale with the number of craft in the competition and for continuous spawning.

v1.3.4.2
FIXES
	- Fix a bug with competitions failing to start when using the web orchestration due to the mass team switch not happening immediately.

v1.3.4.1
FIXES
	- Fix the VESSELNAMING issue that prevents some players from having their scores registered.

v1.3.4
FIXES
	- Fix craft not responding to multiple missile threats.
	- Missing condition for regular kills with missiles.
	- Clear the pilotActions dictionary to avoid ' is Dead' when starting a new competition with previously used pilots.
	- Adjust DeathOrder for continuous spawn to avoid ' killed by ' messages on spawning.
	- Fix death counts in logged scores for vessels that have run out of lives.
	- Don't clean up SpaceObjects in RemoveDebris as it is a source of null refs in the base game.
IMPROVEMENTS
	- Adjust vessel switcher window's display of dead vessels to reflect clean kills vs regular ones.
	- Only count clean kills as kill, give assists to all vessels with hits for regular kills.
	- Support scoring for hits and damage in/out.
	- Interesting Vessel Spawn locations with separate cfg file (spawn_locations.cfg).
	- Trigger result logging on scene change from BDACompetitionMode.
	- Store the competition distance.
	- Automatically dump scores when leaving flight mode.
	- Extra setting REMOTE_LOGGING_VISIBLE in the settings.cfg file only to hide the remote orchestration from the settings window. Defaults to False.
	- Start tilted 10° outwards when spawning in the air.
	- In-game messages when dumping competition logs.
	- Rolling spawning (sliders for controlling the maximum number of craft and the number of lives they have for continuous spawning).
	- Use user-set altitude and other settings for remote orchestration spawning.

v1.3.3.1
IMPROVEMENTS
	- Set default value of 'Default FFA Targeting' to false.
	- Proper targeting logic for surface vessels when target priority is enabled.

v1.3.3
FIXES
	- Several bugfixes ('packing for orbit' for continuous spawning of command seats, revert debris clean-up coroutine).
IMPROVEMENTS
	- Disable camera switch on continuous spawning.
	- Hide DEAD vessels in continuous spawning mode.
	- Allow negative weightings for target priority sliders.
	- Lower min combat speed speed to match take-off speed.
	- Damage multipler slider.

v1.3.2.2
IMPROVEMENTS
	- Updated model for the Mk1 Open Cockpit.

v1.3.2.1
FIXES
	- Don't allow minimum altitude of 0 as it breaks taking off.
IMPROVEMENTS
	- Updated collision model for Mk1 Open Cockpit.

v1.3.2
IMPROVEMENTS
	- Mk1 Open Cockpit and EAS-2 Combat Seat (with built-in AI & WM).
	- Adjustments to spawning for planets without surfaces and over oceans.
	- Extra setting for controlling ease-in speed during spawning.
	- Settings toggle for Runway Project vs official.
	- UI tidy up for AI settings.
	- Bank and pitch angle limiters.
	- Improved input for spawning coordinates (0.5s delay).
	- Spawn distance factor slider.
	- More tolerance (time) on the invalid vessel checks.

v1.3.1.1
FIXES
	- Update the ramming information datastructures for the new vessel instances during continuous spawning.

v1.3.1
IMPROVEMENTS
	- Added new M1 Abrams HE and M102 HE turrets and textures.
	- Added extra target priority controls.
	- Default target priority controls approximate "FFA Combat Targeting".

v1.3.0
FIXES
	- Major memory leak fix, giving better stability and performance for longer competitions (aubranium, DocNappers).
IMPROVEMENTS
	- Remote orchestration (aubranium).
	- HP changes for flags (Josue).
	- HP changes for parts (CeruleanEyes).
	- Improved spawning routines with ground, airborne and continuous spawning modes (DocNappers).
	- Fire ALL engines on planes that don't set AG10 (DocNappers).
	- Improved competition status messaging system (DocNappers).
	- Tag mode (Josue).
	- Out-of-ammo kill timer for continuous spawning mode to prevent craft wasting too much time trying to ram (DocNappers).
	- Vessel switcher UI improvements (DocNappers).
	- Missile scoring: parts destroyed (DocNappers).
	- Damage tracking: ballistic + explosive damage from bullet hits and explosive damage from missile strikes (DocNappers).
	- Score dumps to separate files (in GameData/BDArmory/Logs) (DocNappers).
	- Handling of badly built craft, mostly (i.e., those with AI/WM not on the cockpit or command seats) (DocNappers).
	- Partial support for command seats: they work, but frequently mess up the vessel switcher window when they spawn; this doesn't affect the scoring though (Josue, DocNappers).
	- Control of automatic camera switching frequency (Josue).
	- Target prioritisation (Josue).

v1.2.1.3
FIXES
	- Check for both vessel type not being debris and vessel name not ending in "Debris" when checking if a vessel is really alive.

v1.2.1.2
FIXES
	- Don't count missiles as debris in clean-up routine.

v1.2.1.1
FIXES
	- Fixed spacing in some displayed messages.

v1.2.1
FIXES
	- Don't overwrite settings.cfg, just generate one if it doesn't exist.
	- FFA Combat Targeting is enabled by default.

v1.2.0

v1.1.1

v1.1.0

v1.0.0

**** TAKEN OVER BY RWP DEV TEAM AND VERSION NUMBERS ADJUSTED ****

v1.3.4
* NEW FEATURES:
	* Recompiled for KSP 1.9.1
* FIXES
	* Shaders compatibility for Mac / Linux
	* Missiles problem regarding locking and losing lock affecting heat and radar missiles. (Thanks to TheKurgan to find the problematic commit)

v1.3.3
* NEW FEATURES:
	* Recompiled for KSP 1.9.0
	* Localization en-us and zh-cn (Thanks to tinygrox!)
* FIXES
	* Some NRE here and there.
	* Fixes to Laser accuracy (Thanks to Gedas!)
	* Part Categories for BDArmory is now activated by default

v1.3.2
* NEW FEATURES:
	* Recompiled for KSP 1.8.1
	* Munition count to Weapon Manager GUI.
* ENHANCEMENTS
	* Enhanced weapon selection.
	* Beam-guided munition track moving targets.
	* Improved camera tracking position.
	* RMB info in editor.
	* Ballistic guidance overhaul. Now it is possible to also select the angle of the ballistic path.
	* Turret movement improved.
* FIXES
	* Weapons respect engagement range.
	* Dozen of NRE exceptions.
	* Fix surface ai description.
	* Fix turret gimbal calculation.
	* Turrets with constrained yaw should freak out less when aiming behind them.
	* Locatization fixes.
	* Fixed torpedo produces thrust above water. #710
	* Fixed proximity fuze radius for explosive bullets.
	* Fixed heat missiles missing target just after being fired.


v1.3.1
* FIXES
	* All parts have bulkheadProfiles - should stop bulkhead filter NREs.
	* Rocket pods no longer fire StackOverflows.

v1.3.0
* NEW FEATURES:
	* Multiple teams are now supported by BDA.
		* Probably breaks ALL the existing addons.
			The new property is `Team` instead of `team`.
			Review all existing references and check whether the check is for the same/different team (`==`/`!=`) or enemy/ally (use `IsEnemy` and `IsFriendly`).
			`TargetDatabase` and `GPSTargets` have gone private and are not guaranteed to contain all the teams anyway.
			Use `TargetList` and `GPSTargetList` instead.
		* Will lose existing saved GPS targets.
		* Right-click the team button to customize the teams in-game.
	* Ammo gauges. (thanks to @SuicidalInsanity)
		* Disabled by default, enable in BDA settings.
	* Editor subcategories.
		* Disabled by default, enable in settings or by right clicking the category button.
		* Any part specifying a `bdacategory` will be accordingly categorized.
		* Other parts can be inferred from part modules.
* ENHANCEMENTS:
	* Recompiled for KSP 1.7.0
	* Wing commander formation parameters can once again be configured in editor on the weapon manager.
	* Improved gun ballistic estimation.
	* BDA will show a small version number on weapon manager.
* FIXES
	* AI pilot should now use torpedoes.
	* Weapons will revert to default weapon group on blank weapon group entry.
	* Missiles fired from turrets will obey drop time and decouple direction.
	* Guns with air detonation (flak) should work now. (thanks to @SuicidalInsanity)
	* Guard mode no longer stops firing at passed out pilots. (thanks to @SuicidalInsanity)
	* Missile turrets should properly stop tracking in various circumstances.
	* Gun safety should no longer prevent firing from aiming too close to self.
	* Drag no longer causes bullets to speed up.
	* Reloadable missile rail no longer permits reloading when out of ammo.
	* Modular missiles autodestruction if missed improved

v1.2.4
* NEW FEATURES:
	* Weapons groups - different weapons firing in parallel(thanks to @SuicidalInsanity)
* ENHANCEMENTS:
	* Recompiled for KSP 1.6.0
* FIXES
	* Fixing modular missiles roll correction.
	* Fixing modular missiles stage on proximity.
	* Fixing Hipoints for mods like AirplanePlus #598

v1.2.3
* NEW FEATURES:
	* Recompiled for KSP 1.5.1
	* EC per shot for energy weapons like Rail guns. #486
	* EMP Weapons logic.
	* Modular Missiles: Min speed before guidance trigger, time between stages.
	* New High Explosive resource for missiles.
	* New smoke model.
	* Autopilot: Orbiting direction can be set.

* ENHANCEMENTS:
	* Explosive blast forces increased.
	* Hitpoints rounding reduced to 100. #432
	* Missiles can be jettisoned using action group #539
	* Max detonation range for air explosive bullets increased from 3500m to 8000m.
	* Autopilot improvements: pitchKi has saner values, also steering added.
	* Guard mode: Better calculation of missiles away.
	* Better bullet distribution.
	* FX performance improved limiting number of parallel animations.
	* Better checks for missile detonations.

* FIXES
	* HE bullets now do less kinetic damage after substracting HE mass
	* HitPoints calculations: values remain the same between scenes
	* HitPoints calculations: bigger vessels now have more sensible HP values. #477
	* Stop explosions moving across the ground
	* Fixed detonation on collision #566
	* CSV parts export now show all parts
	* Fixed weapons category due to localization issues. #580
	* Stage icons fixed for KSP 1.5.1
	* Some exceptions controlled
	* Heat missiles will not lock friendly vessels. #586
	* Fixed issue where modular missiles were detecting themselves as enemy vessels and detonating.
	* Modular Missiles: roll correction fixed.

* BALANCE
	* Bullet mass rebalance for lower calibers #515
	* No damage reductions for lower calibers #515
	* 120mm bullet improvements.
- Thanks to SpannerMoneky, Gedas-S, DoctorDavinci, Kergan, Gomker, PapaJoesSoup, TheDogKSP, Duck1998, and Fitiales for their work on this release!

v1.2.2.2a
* FIXES
* added in missing high speed missle fix.  somehow got lost in the merge migration.

v1.2.2.2
* Recompiled for KSP 1.4.5

* FIXES
	*Error spam in Log when a radar is destroyed. An orphaned index was not properly being updated.
	 Reported in BDAc Forum post: https://forum.kerbalspaceprogram.com/index.php?/topic/155014-14x-bdarmory-continued-v1221-7102018-vessel-mover-camera-tools-bdmk22-destruction-effects-burn-together/&do=findComment&comment=3425233
	 Thanks to greydragon70 for his thoughtful evaluation of BDac and issue reporting.
	* Corrected an error where high speed missiles would sometimes not detonate in the correct location.

* ENHANCEMENTS:
  * Increased maximum allowable missles per target to 18, up from 6.
  * Added EMP Module.  Now Electromagnetic pulses exist in game that can disable electronics within the blast range.
  * Added 2 new EMP equipped missiles  HellFire EMP, and AIM-120 EMP.  Small pulse radius but demonstrates the feature.
  * Added 3 different sized EMP pulse FX, allows for additional sized pulse weapons.
  * Added Reloadable Missile Rail (ModuleMissileRearm.  Now missile launchers can be reloadable!
	This module can be added to missile launcher designs to allow reloading. (code used with permission courtesy of @flywyx).
	Requires unity based modifications,  normal rails will not function as reloadable unless additional transforms are added.
  * Added new standard resource High Explosive.  Provides better matching of tntMass for balance.
  * Added an Ammo switcher feature (no more Firespitter required)
  * Added new Universal Ammo Box part that uses the new Ammo switcher feature.  Old part remains for backawards compatability.
	Use the new part going forward.  To remove the need for FireSpitter, replace existing Ammo Box parts with the new part on existing craft.
  * Improved sub categories for BDA parts.  This helps with the clutter in the Editor under the BDA category.
  * Removed BDACategoryModule as a result of the BDA categories refactor.
	Existing craft may see a module not found warnings in the log.  This will have no ill effects and can be safely ignored.
  * Improved smoke effects for smoke canister launchers
  * Added new Jet engine based on the J-404.  Licensed from KTech. (Thanks @TheKurgan, @SpannerMonkey(SMCE) & @XOC2008!)
  * Added new BDAc Test Drone MKIII craft, utilizing the new engine.
  * Added engagement rules to all missiles


v1.2.2.1
* FIXES
  * Added bulletinfo.explosive check to GetInfo, so explosive shells now show blast radius in the part Info (RMB) section in the editor.
  * Correct text errors in bullet names on some files.  Not all platforms support UTF8 characters.
  * (Internal) Fix file copy error in build process.
  * Increase default detonation range boundaries and step increments.  Git Issue #527
  * Removed : Final from entried in MM config 000000_HitpointModule.cfg.  Causing race conditions with some BDA part mods

* ENHANCEMENTS:
  * Improved reload sound on M1Abrams Turret.
  * Removed BDA_SLW.cfg from MM configs.  Obsolete and no longer used.
  * Converted all .wav sounds to .ogg (reduce DL size and in game memory footprint)
  * Updated several Module info pages to reflect recent changes to ballistic mechanics
  * Added a part module Info Page refresh mechanism to support settings changes that affect part Module info blocks in the editor.
  * Added Jettison action to parts TweakUI in flight.  Git Issue #539
  * (Internal) Some code refactoring (basic cleanup, Module reorganization)
  * Deprecate the Cannon weaponType.   Going forward, Ballistic should be used instead.  Cannon remains (backwards compatibility), but will be eventually removed.
  * (Internal) Updated build process to improve multi developer build and deployments.  Simplified KSP version change dev environment build process.

v1.2.2
* NEW FEATURES:
  * Recompiled for KSP 1.4.4.

* ENHANCEMENTS:
  * Added AN/APG-77  Air to ground radar.

v1.2.1.4
* FIXES
  * Corrected error in Target Previous action group.  Was pointing to Target Next method instead.

* ENHANCEMENTS:
  * Added mouse slewing (pointing) in the TargetCam Window.  Now you can intuitively click and drag to position the target in the window.
  * Added mouse scrollwheel zooming in TargetCam window.  Now you can zoom in and zoom out using the mousewheel.
  * Added reactive armor part module. Modders can now take advantage of a new armor type in BDAc.
  * Added Wet Weapons Check module (ModuleWWC).  This module will pevent submerged weapons from firing (like when a ship sinks).
	The depth is user selectable.


v1.2.1.3
* FIXES
  * Removed 99_bdac_engagementenvelopes.cfg.  This legacy file was interfering with the new tuning of some of the missiles.

* ENHANCEMENTS:
  * Added Target Next / Previous hot keys and Actions.  Now you can switch targets without having to click on the Radar!
  * Numerous missile tuning tweaks to improve flight profile appearances and improve config consistency.
  * Add slider to adjust Eject Velocity of Chaff and flares in Editor.
  * Revised Jet engine sound (much better now)
  * Added configurable hot keys for VesselSwitcher Next and Previous Vessel (Defaults remain PgUp and PgDn)
  * Revised Input Settings window to use a scroller.  This reduces the size of the window by about half.


v1.2.1.2
* FIXES
  * Correct Radar display missing graphics when using low quality graphics Git Issue #516.
  * Correct tracer display missing graphics when using low quality graphics.  Git Issue #520.
  * Correct automatic resizing of WingCommander Window
  * Reintroduce BDAcUniversalAmmoBox Module Manager config file.  Somehow was dropped during a merge somewhere back.
  * Separate RWR operation from RWR display.  RWR should be enabled at all times when a Radar is installed on craft.
	- Opening and closing the RWR window now leaves RWR operation active.  Git Issues 410, #411, #461
  * removed part configs for the AGM86-cruise an the RBS-15  They have been broken, and are superceded by improved weapons.

* ENHANCEMENTS:
  * Increase the limits of the Radar and RWR window scaling to allow for larger windows.
	- Add min and max settings to the settings.cfg to allow user defined limits. Git Issue #521
  * Add mouse driven RWR and Radar windows resizing.  Now you can intuitivly resize by mouse.  Click an drag the lower right corner.
  * Redesigned Targeting Cam window to incorporate all features added to the Radar window - resizing, boundary checks, mouse resize, relocate buttons
  * Retune BDAc missiles to improve characteristics, performance, and balance.  Tuning performed by Kergan


v1.2.1.1
* NEW FEATURES:
  * Added ModuleSpaceRadar.  This limits use of space based radars supporting this module to outside the atmosphere. By DoctorDavinci and Kergan
  * Added Air to ground versions of Air to Air radars.  By SpannerMonkey(smce)
  * Added new explosion effects.  By SpanerMonkey(smce)

* ENHANCEMENTS:
  * Added boundary checking to all moveable windows.  Now windows cannot be positioned off the screen.
  * Added ability to scale Radar Warning Receiver Window.  Scale persists to config file and can be changed in Settings. Git Issue #410
  * Redesigned and added ability to scale Radar Window.  Scale persists to config file and can be changed in Settings. Git Issue #410
  * Added a toggle to collapse/expand the list of weapons on the Weapon Manager window. Git Issue #410
  * Increased the number of range steps in the Radar.  Now can display up to 1000km by default.
  * Added Dynamic range settings to Radar Display based on the max range of the radars in operation.
  * Added close buttons to the upper right of some windows. Git Issue #410
  * Added option in Settings to turn off Bullet Hole Decals (may help with performance)

* FIXES
  * Cleaned up obsolete and deprecated unity method calls.
  * Removed MM config 30_bdac_missiles_terminalmaneuvering.cfg.  No longer used.
  * Fixed radar locking in space. Git PR #517. By JRodriguez

v1.2.1
* NEW FEATURES:
  * Recompiled for KSP 1.4.3.
* FIXES:
  * Fixed model path for Flare & Chaff. Issue #512.

v1.2.0

* NEW FEATURES:
  * Support for Unity 2017. Icons textures fixed by PapaJoe. Thanks to @SpannerMonkey for chaff/smoke models.
  * Compatibility with KSP 1.4.2.
  * Surface AI: Yes, tank battles and ships battles are a reality now. Thanks to @Gedas for this major feature.
  * Damage Consequences: damaged engine has reduced thrust and greater heat production. Issue #433.

* ENHANCEMENTS:
  * Cruise Guidance overhaul.
  * Shaped explosions for AGM missiles.
  * Chaff rebalance.
  * New setting to disable terrain checks.
  * New FX for missile collisions.
  * Modular missile core - added option to control roll.
  * HE-KV1 missile is now efficient and deadly in Space :) Thanks to Kergan.
  * Weapons like cannons can fire up to their max range. (eg: a 20 km cannon can fire at 20 km)

* FIXES:
  * Drag of ammo boxes reduced. Issue #498.
  * Dozens of small fixes and rebalance!

v1.1.0

* NEW FEATURES:

  * Bullet decals.
  * Damage consequences for engine damaged. #433

* ENHANCEMENTS:

  * New damage model: the new system uses hitpoints instead of temperature.
  * Realism overhaul for ballistics, penetration and armor.
  * Realism overhaul for explosive damage and forces.
  * Improvements to Cruise Guidance.
  * Option for Modular Missiles to correct Roll.

		- For more detail you can check the issue #307 and the Wiki https://github.com/PapaJoesSoup/BDArmory/wiki/
* FIXES:
  * Kerbals can be killed again
  * Modular missiles are not usable without Guard mode #377
  * Standby Mode is being bypassed if there is an active radar on one of the teams #406
  * Bullet trajectories and Pilot AI should no longer be affected by vessel movement and vessel switching


v1.0.0

* NEW FEATURES:

  * Radar & Stealth, re-design of how the radar system works:
	- New radar reflection shader (credit: original great idea by JR!), calculating cross section in m^2:
	   + allows building for stealth using angled surfaces ("scatter those pesky radar waves away!")
	   + calculation is normalized so that a 1x1 structural plate directly frontally facing the radar yields a return of exactly 1 m^2
	- Redesign of the radar system, radars all have different ranges & detection performance:
	   + radar part configs changed, new fields (floatcurves) to define detection and lock/track performance, new field to specify ground clutter effectiveness
	- New in-editor analysis window to help evaluate a craft's cross section and performance against selectable radars
	- New options for configuration of radar guided missiles in the part config:
	   + can now explicitly specify active seeker performance (via a FloatCurve, similar to radars)
	   + can now explicitly specify the static radar cross section of a missile for detection purpose
	- Adjustment of the Chaff countermeasure system: more gradual effect of decoying missiles away (instead of previous "all-or-nothing")
	- Adjustment of IR missiles and flare countermeasures: simulating now more of a "imaging infrared" seeker than an old dumb seeker — to be successfully decoyed, flares have to more closely match the thermal spectrum of the part the seeker has locked on to

  * Massive improvements to ballistic missile guidance and modular missiles, ability to simulate ICBM flight paths:
	- Ballistic guidance has been enhanced to allow firing missiles accurately even at distances greater than 500 km
	- A new field called BallisticOverShootFactor has been added to missiles, the greater the value the further the missile will go before the terminal maneuver begins
	- By default all missiles now can steer in vacuum. New field called "vacuumSteerable" can be set to false to disable this behaviour
	- Auto SAS activation when the missile is fired. Before it was only activated if the parent vessel had it switched on.
	- Improved the Cruise and Ballistic Guidance. Ballistic Guidance will switch to AGM guidance as soon as it reached the 50% of the distance
	- Guard mode in space will consider orbiting vessels as "flying" (air targets), hence engagement of space targets is possible now

  * New dedicated sonar ping and torpedo ping sounds, courtesy of PapaJoe!

* FIXES / ENHANCEMENTS:

  * Localization updates, including chinese localization (thanks @ACEA)
  * Fixed indestructible Kerbals - weapons/explosions have effect on Kerbals again! (thanks @Designer225)
  * Fixed AIPilot problem with drag estimations (thanks @RichardDastardly)
  * Fix missile infinite fuel
  * Fix rwr window invisible in fresh installs
  * Display ranges of RWR and radar display now linked, selectable display range of radar display up to configured PRE physics max range!
  * Window position saving also for vesselswitcher
  * Prevent active radar missiles locking onto anything they see, now obey engagement settings
  * Sonar pings and torpedos only show on RWR if vessel is splashed/submerged
  * Fix guard mode "cheating" - now must have detected an enemy with radar/sonar or with visual range before it can attack it
  * If a cruise missile has terminal guidance, it can be switched off (before launch) in the part action window. The missile will then be purely gps guided without engaging its terminal targeting mode
  * If debug labels are enabled, upon entering the editor all bda parts & their properties (if relevant for balancing) are dumped into .csv files for convenient analysis in excel
  * Complete review of all event handlers, should reduce some actual or potential nullrefs upon explosive vessel disassembly
  * General performance improvements due to code refactoring



v0.3.0.0

* New DLL Changes - Full reinstall required!
* BDArmory Core : modularization of systems and features to ease integration for other mod makers
* Performance refactor and garbage collection improvements for better memory utilization

* New Features

	* Adding new weaponClass - SLW - Ship Launched Weapon - intended to target surface vessels (splashed) and submarines (splashed and underwater)

	* weaponClass.SLW is set by missileType torpedo or depthcharge

	* New "Sonar" Implementation - If RWRThreatTypes is Sonar will not detect flying vessels, only surface ships and submersibles

	* MAX_ACTIVE_RADAR_RANGE & MAX_ENGAGEMENT_RANGE added to settings.cfg for more control over ranged combat

	* Updated checks for Landed and Splashed to be more accurate and account for sumbersibles

	* Renamed "Ground" engagement option to "Surface" to better reflect behavior

	* MM Patches updated for engagement options and torpedo types

	* Issue Reference #201 for Sonar, RWR Types, engagement Types, torpedo targeting

	* Increased Radar Range #170

	* Logic for Smart Targeting should correct #216

	* fixing issue with throttle mirroring when switching vessels

	* adding gaurd mode back to editor, Solves #156
	
	* Ballistic Missile guidance improvements
	
	* Terminal Guidance will switch back to GPS target if no radar target is found
	
	
* New Parts

	* Courtesy of SpannerMonkey
		- BDA MK1 Sonar Pod
		- Sting Ray  BDA LightWeight Torpedo
		
* Notes on Naval Combat Features

	* Current implementation of "Sonar" reuses the current Radar code. Future state will have dedicated windows and naming convention
	* Activating a "Sonar" pod still says "Activate Radar"
	* A Sonar is defined by setting the rwrThreatType = 6
		- Sonar rules
			- Will only detect vessels that are underwater (> 20meters)
			- Sonar will not function if vessel is in flight
			- Sonar does not detect "Landed" vessels, only splashed
			- Normal Radar does not detect underwater vessels, still detects "Splashed" i.e. Boats
	* Engagment type "SLW" only targets underwater (submarines) and Splashed (Boats)


v0.2.1.2
= New features=
- New Armor Parts
- New Bullet Types and configurations to support Armor penetration
	- https://github.com/PapaJoesSoup/BDArmory/wiki/Bullet-Configuration
- New Universal Ammunition parts
- Start of localization

- SM changelog for Ammo overhaul and bullet sweep detail
	• Added bulletType =  to all applicable turrets Browning AN/M2 bahaOMillennium bahaM230ChainGun bahaHiddenVulcan bahaM102Howitzer bahaM1Abrams BDAcGKmk2 GoalKeeperBDAcMk1 bahaGoalKeeper bahaGau-8 bahaTurret50cal
	• Merge existing BDA ammunition resource definitions  with  UA master list
	• Merge existing BDA Bullet and shell sweep definitions  with  UA master list
	• Created large list of all current ammunition across all weapons mods
	• Defined bullet and shell sweep for most popular ammunition types  , obtained max dat for large caliber marine shells
	• Created universal ammo box, a cfg and texture only addition

Assigned values to universalAmmunition supply
	

v0.2.1.1
= Fixes =
- Recompiled and fixed for KSP 1.3.0

= New features=
- Modular Missile Guidance:
	- New option to detonate an stage on proximity.

v0.2.1.0
= Fixes =
- Problem with display of trajectories/smoke of missiles #74.
- Warhead and Procedural High Explosive cannot be detonated via Action Group #162.
- AI Pilot is unable to use Rapiers in Air Breathing mode if landed #102.
- Fixing modular missile detonation when switching.
- Fixing max static launch range for modular missiles.

v0.2.0.0
= New features=
- Modular Missile Guidance:
	A full rewrite of this part has been done. Now you can build your own missiles, define all its parameters,
	even its name. And it will be used by the AI as if it was a stock BDArmory missile!

	If you want to know more about this new feature, you can download a custom part pack for procedural missiles:
	https://github.com/jrodrigv/BDModularMissileParts
	And read this wiki
	https://github.com/jrodrigv/BDModularMissileParts/wiki/1.-Building-your-first-Modular-Missile

- Proximity Fuse for Missiles:
	A new field called "detonation distance override" has been added to missiles.
	0 by default means that it will detonate within is normal explosive radius (eg: 20 meters for AIM-120)

- Small High Explosive Warhead can now be rescaled with TweakScale. Git issue #106


= Changes =
- BDALoadedVesselSwitcher has been integrated into BDArmory, it will not be a separate mod anymore.
	Please delete it before installing this version.
- Physics range field and logic has been removed:
	BDArmory now integrates a new mod called PhysicsRangeExtender. https://github.com/jrodrigv/PhysicsRangeExtender
	Now the physics range has been extended to almost 200 km.
	However, be careful with landed vessels. Even if the vessel still loaded it could be possible that the terrain beneath it's not there anymore.
	

= Fixes =
- Game crashes when adjusting the Rotary Bomb Rack. Git Issue #76.
- Missile vs Missile Accuracy. Git Issue #82
- Bomb aiming reticle not working. Git Issue #92.
- Cluster bomb explode on load. Git Issue #151


= Known issues =
- Problem with display of trajectories/smoke of missiles. Git Issue #74

v0.11.1.6
- Fix shaders not working on Linux and Mac OS X. Git Issue #73.
- Fix bomb aimer not working. Git Issue #75.
- Fix selected weapon message missing. Git Issue #50.
- Enhancement: Allow assigning of Toggle Radar to action groups. Git Issue #58.
- Enhancement: Ground Radar use resources now.
- Enhancement: Allow the Weapon Manager to turn on the ECM when in guard mode. Git Issue #27
- Known issues: Adjustable Rotary Bomb Rack is officially broken and it has been tagged as (BROKEN)

v0.11.1.5
- Ready for KSP 1.2.1
- New feature: Bullets penetration system.
- New parts: Goalkeeper Mk1 and Mk2 - legacy textures.
- AI improvements: for air-ground missiles, prevent firing full complement at once (respect maxMissilesTarget).
- AI improvements: prevent gps guided missiles being used on air targets/incoming missiles.
- AI improvements: improve selection of AA missiles/guns against incoming missiles.
- Missile cost rebalance.

v0.11.1.4 (not released)
- Ready for KSP 1.2
- Shaders and asset bundle. Fixes Git issue #47 and partially #48
- Fix for weapons freezing when firing. Git Issue #49

v0.11.1.3beta
- Updated to be compatible with KSP 1.2. (Prerelease only)
- Add window persistence.  Remember where I put my windows, darn it! Git Issue #13 - Partial implementation.
- Fix reload sounds on M1Abrams and M102 parts.  Git Issue #39
- Fix missing weapon icon in staging part list.
- Fix missing reload bar next to icon.
- Fix missing heat guage next to icon.

v0.11.1.2
- Fix sound issue with Hydra 70.  Git Issue #1
- Fix PAC Lag issue.  Git Issue #3

v0.11.1.1
- Revert Assembly version back to 1.0.  Some mods depend on the version number of the assembly when reflecting.

v-0.11.1.0
- KSP 1.1.3 compatibility update.
- Mod authorship change.  Papa_Joe assumed coding support

v0.11.0.1
= Fixes
- Fix error spam when no weapon is selected

v0.11.0
= Compatibility =
- General compatibility for KSP 1.1
- Loading shaders with asset bundle loader

= Fixes =
- Fix incorrect tracer width in far camera with Scatterer
- Fix short bursts when firing in barrage with trigger armed
- Fix barrage on multi-barrel weapons
- Fix particle emission force being ovewritten in explosions
- Fix possible error on airborne guard with no AI pilot


v0.10.4.1
= Fixes =
- Fixed landed guards not attacking AI pilots
- Fixed competition distance being clamped while editing it

v0.10.4
= AI Improvements by ferram4 =
- AI will call for help from nearby friendlies when under fire using a new SetOverrideTarget system
- AI will try to maneuver in the vertical when turning on opponents, generally deciding whether to go up/down based on whether they are under possible threat from the current target
- AI will evade guns by trying to break in towards the threat and make themselves the most difficult target possible
- AI will try to extrapolate the motion of targets based on how long it will take them to turn around
- AI will extend somewhat further when they are set to extend, which makes it more effective in gunfights and generally results in a less steep climb when they do, so they're not as helpless.
- AI will switch to a target ahead while extending
- AI will check safety of team mates before firing
- AI more likely to take high-deflection shots
- Tweaks to g-limiting behavior

= New =
- Added Bahamuto Dynamics agency (Shuudoushi)

= Changes =
- Improved AI pilot missile avoidance
- Increased guard fire duration to 3/4 of fire interval

= Fixes =
- Removed debug entries for gun index
- Fixed radar on decoupled vessels
- Fixed TGP camera when multiple are enabled
- Fixed rate of fire for barrage firing guns faster than framerate (ferram4)
- Fixed AI pilot collision avoidance interfering with missile evasion
- Fixed GUI (reticles etc) disappearing when opening/closing map view
- Fixed GUI line displaying incorrectly when one point is behind camera

v0.10.3.3
= New =
- Salvo/Barrage toggle for guns
- New missile exhaust effects
- Missile exhaust prefabs (for modders)

= Changes =
- Improved AI pilot aiming
- Improved AI pilot roll behavior
- Improved AI pilot 'regain energy' behavior

= Fixes =
- Fixed auto cycling active radar lock when launching missile
- Fixed gun audio when fire is stopped via weapon safety check
- Fixed gun reticle when stopped via safety check
- Fixed gap in gapless particle emitter
- Fixed incorrect acceleration calculation in pilot speed controller

v0.10.3.2
= Changes =
- When multiple radars are linked and one loses lock, the one of the others will attempt to take over

= Fixes =
- Fix competition issues again
- Fixed radar animation on track-only radar
- Fixed fire animation on low RoF guns
- Hid debug listing of radar contacts

v0.10.3.1
= Changes =
- Improvements to AI Pilot handling of underpowered/slow planes
- A few behaviors added to help conserve energy

= Fixes =
- Fixed issue with competition mode sometimes causing a team's setup destination to be underground
- Fixed issue with compeition modes sometimes causing two teams to never be far enough apart to start battle
- Fixed competition mode not ending on revert/scene switch
- Fixed crosshair cursor showing when switching to vessel without weaponManager
- Fixed incorrect team being displayed on weaponManager in editor
- Fixed AI Pilot rolling into bombs after dropping
- Fixed non-stop wobble of bombs in FAR
- Fixed unable to close missile turrets in editor
- Delay turret reverse deploy animation for firePauseTime to prevent closing on last missile fired (for real this time)
- AI Pilot speed controller takes thrust limiter into account for calculations

v0.10.3
= New =
- Predictive mid-air collision avoidance for AI Pilot
- Competition mode
- Compatibility with assembly dependency
- Compatibility with BDA Vessel Switcher
- AI Pilot improvements by ferram4
- - G-limiter
- - AoA limiter
- - Dynamic minimum altitude adjustment (plane pulls out of dive earlier if needed)

= Changes =
- Guards will reset fire cycle and switch weapons if current gun has overheated
- Optional "activeMissileOnly" (bool) in MissileTurret module
- Increased radar sensitivity
- Decreased AIM-120 and AIM-9 static launch ranges
- Increased AGM min launch ranges
- Allow guard to use beam riding type missile (TOW)
- AI will do wide scan instead of focusing on target if extending to help prevent easy kill
- AI Evasive improvements
- - Fly to beam incoming missiles detected on rwr or visually
- - Fly to break away from incoming fire (instead of flying random directions)

= Fixes =
- Disabled firing with trigger when in guard mode
- Fixed AI Pilot aiming when attempting lock with heat-seeker
- Fixed Rotary Rail symmetry and rail count persistance issues (you may need to readjust the rail on your crafts)
- Fixed guard's final launch authorization to use missile DLZ instead of arbitrary values
- Fixed incorrect screen message when guard selects "none"
- Delay turret reverse deploy animation for firePauseTime to prevent closing on last missile fired

v0.10.2.1
= Fixes =
- Fixed typo in AGM-86C cruise missile description (should say GPS guided)
- Disabled 'Remote firing' option by default

v0.10.2
= New =
- Adjustable Rotary bomb/missile rail
- AI Pilot guards can select and use unguided or GPS guided bombs
- Guards will open and close cargo bays as necessary for missiles/bombs (FAR users need to manually set 'cargo bay' missiles/bombs)

= Changes =
- Selecting a missile will enable all turrets containing its type, not just current missile
- No longer render cluster bomb submunitions until they are deployed
- Guards will take longer to forget about contacts if they have not been seen
- Guards will reset memory lifetime of contact if they are seen again

= Fixes =
- Fixed targeting pod stabilizing on underwater terrain instead of surface
- Fixed Take-off not working on Command Self if AIPilot is not activated
- Fixed exceptions thrown by cluster bomb, targeting camera, and wing commander
- Reduced debug log spam

v0.10.1
= New =
- "Command self" option for wing commander

= Changes =
- Rebalanced weapon damage
- Improved AI Pilot speed management in dogfight
- Improved AI Pilot collision avoidance behavior
- Reduced bullet damage factor to 100
- Tweaked AIM-120 aero slightly
- Increased heat of explosions
- Extra explosion heat when part is destroyed is transferred to connected part
- Factor in DMG_MULTIPLIER for explosives
- optional cannonShellHeat value for ModuleWeapon - if defined, it will be used in heat damage calculation for shell explosion
- Tweaked flare effects

= Fixes =
- Fixed WeaponManager using missiles asymmetrically
- Fixed exceptions being thrown by WingCommander in editor
- Fixed exceptions thrown by ModuleTargetingCamera during loading
- Fixed RWR not functioning if it was enabled on reload
- Fixed AI using incorrect gun distance when airborne
- Fixed AI Pilot turning incorrect direction sometimes when enemy is beyond 90deg bearing


v0.10.0
= New =
- Wing Commander module
- Missile launcher turrets
- Rocket launcher turret
- TOW Missile
- Beam riding missile guidance
- Guard usage of missile launcher turrets
- Weapon targeting types are displayed in weapon list
- Weapon alignment and converge distance indicator in editor (F2)
- MinCombatSpeed variable for AI Pilot, below which the pilot will focus on regaining speed when extending or orbiting
- Idle speed for AI Pilot for when it is only orbiting
- Added steer damping value for missiles to reduce oscillations
- Ripple fire settings will be saved per-weapon
- Ripple fire action group toggle
- Tweakable gun range for guards (to decide between guns or missiles)
- Tweakable missiles per target value for guards (will wait until set amount of missiles have missed before firing again)
- Support for turret rotation sound effects
- Optional radarName field to display in modules tab instead of part title
- Support for built-in radars on turrets
- New bullet/tracer shader
- Bullet tracer intervals
- Optional ejected shell collisions
- Action groups for firing guns on weapon manager and individual guns (Currently only supports Custom1-10)
- Support for simultaneous use of multiple on-board radars
- Support for simultaneous use of multiple off-board radars via data-link
- Multi-locking TWS capability on fighter-style radome

= Changes =
- Radars can detect landed/splashed targets
- Changed Oerlikon Millennium to more realistic high rate of fire burst
- New sound effects for Millennium and M230
- Changed 30mm cannons to explosive rounds
- Tweaked AIM-9 and AIM-120 aero/steering values
- Tweaked drag and lift curves and coefficients
- Tweaked flare thermal value
- Changed PAC-3 to semi-active homing
- AI Pilot will return to and orbit the area it took off from/was activated when not in combat unless commanded to a location via wingcommander
- Improved AI Pilot throttle control and use of multi-mode engine (afterburner)
- Improved AI Pilot handling post-stall
- Improved AI Pilot evasive behavior
- Improved AI Pilot behavior for ground target gun attack
- Changed default max guard visual range to 5km
- Guard that is fixated on a target will intermittently do a wide scan to check for new threats
- Reduced weapon manager audio source ranges
- Reduced Browning AN/M2 mass to 40kg
- Missile smoke trails persist after missile is destroyed
- Improved cruise missile behavior
- Circle icon for friendly contact on B-Scope radar display

= Fixes =
- Fixed chain reactions causing rippled bombs to detonate simultaneously
- Fixed guns firing after automatically switching when emptying stores of previous missile/rocket via fire key
- Fixed empty rocket pods remaining on available weapons list
- Fixed guard mode fire intervals cycling too quickly for air-to-air missiles
- Fixed MANY guard mode issues causing it not to work properly/consistently
- Fixed incorrect selected weapon message
- Fixed targeting pod losing saved settings/target position on reload
- Fixed high relative velocity missiles stepping through objects w/o collision
- Fixed unnecessary snaking in sa or aa missile guidance
- Fixed AGM guidance on high altitude surface targets
- Fixed muzzle flashes not appearing when framerate is low
- Fixed rotary cannons not appearing to spin
- Fixed incorrect description in RBS-15 cruise missile (should say GPS guided)
- Fixed targeting pod disabling radar tracking when radar loses lock - it will wait until next lock
- Fixed turret yaw limiting behavior
- Fixed AI Pilots taking off in standby mode when peace mode is enabled
- RWR state is persistent
- Removed turret motion range tweakables from radars

= Changes by ferram4 =
- Bullet damage is now based on impact energy, not momentum
- Extra bullet damage when a part is destroyed is transferred to connected parts
- Bullet penetration is guaranteed at >~75 degrees
- Bullet ricochets are guaranteed at <~5 degrees
- Optional bullet drag (per weapon)
	+ No drag (legacy)
	+ Analytic estimate (-new default-. no affect on trajectory - only impact velocity/damage)
	+ Numerical Integration (affects trajectory - not accounted for by AI)
	
	= NOTE: aerodynamic values per weapon have not been applied yet


v0.9.9.1
= Changes =
- Removed WingCommander test (unfinished)

v0.9.9
= New =
- Browning .50cal AN/M2 Fixed Gun
- Added auto proximity gun target tracking feature (currently used on fixed vulcan and browning)
- FLIR Ball Targeting Camera
- Dynamic launch zones for missiles
- DLZ display for Radar and TGP
- Guard will choose an appropriate anti-air missile depending on target distance and missile's DLZ
- AI Pilot will go evasive if it detects someone firing guns at it

= Changes =
- AI is better at trying to stay behind target
- Guard only force-enables RWR if missiles are detected (note: guard needs RWR to detect incoming radar missiles)
- Guard FOV will narrow on engaged target
- Improved and re-implemented Pilot AI launch authorization so they won't take missile shots that will obviously miss
- Added targeting info to missiles' description where it was missing

= Fixes =
- Re-enabled guard tweakables in editor
- Fixed LoadedVessels being reset when using hyperedit to place vessel
- Fixed shells being ejected in front of gun when moving
- Fixed radar window resetting when another vessel loads
- Fixed parts disappearing from BDA category after a database reload
- Removed BDA parts from utility category
- Removed 'aam' homing type from HEKV-1 (still untested)


v0.9.8.2
= Fixes =
- Fixed bomb simpleDrag when using FAR
- No longer removes FAR module from missiles and bombs (Handled in latest FAR update)

v0.9.8.1
= Fix =
- Fixed persistence of Peace Mode option

v0.9.8
= New =
- "Peace Mode" option in settings menu - guards/AI won't attack (for setting things up)

= Changes =
- Reduced radome mass
- Adjusted global drag multiplier (affects missiles)
- Improved AI Pilot steering and aiming
- Improved AI Pilot's 'extend' behavior
- Improved AI Pilot's take-off behavior
- AI Pilot will no longer fly straight up to achieve target altitude when loitering
- Guard will no longer engage target that has lost more than 75% of its mass
- Radar lock-on-after-launch is now limited to 2 re-lock-ons before failing

= Fixes =
- Missile will now remove FAR aerodynamics when launched (use BDArmory aero instead, no more double-drag)
- Fixed particle streaks when floating origin shifts
- Fixed typo in main fire key binding
- Fixed maxDeviation for all guns
- Fixed NRE's if active targeting pod is destroyed
- Fixed NRE if attempting to send gps data without weapon manager
- Fixed default drag model on bombs
- Fixed bullet spawn position on guns
- Fixed default max bullet range
- Included bullet range config value in settings.cfg
- Configured HEKV-1 for radar guidance (untested)
- Minor optimizations

v0.9.7
= New =
- Key/button inputs for TGP and Radar
- Input binding page in settings menu
- Target selector cursor for radar when using keys/buttons
- GPS Coordinator highlights and shows name of selected target
- Off button for radar window

= Changes =
- Toolbar window face-lift and improvements
- Removed most fields/buttons from weapon manager's right-click menu
- TGP will start slewing slower then speed up - better precision
- Settings window is now draggable
- Reorganized radar buttons
- Jamming on b-scope no longer shows altitude indication (always green)
- Position of radar pings on B-scope won't update until next scan (easier to select)

= Fixes =
- Stops firing guns if clicking on RWR, data link window, or GPS window
- Fixed display of crossed-out HUD target indicator when radar-locking a friendly
- Fixed missile decouple speed not being applied to guard-fired missiles
- Fixed frame of reference for B-scope so targets in look-up or look-down situation show correct range
- Fixed position updates of attached missiles when adjusting missile rail height (caused by the extra nodes)

v0.9.6
= New =
- TGP can be slaved to the selected GPS target
- TGP can be slaved to radar locked target
- TGP NV mode illuminates vessels

= Changes =
- Changed heat-seeker growl to slide pitch from searching to locked sound instead of two separate clips
- IVA gun audio low-pass filter frequency is now configurable in settings.cfg
- Removed redundant filter effects on lower depth TGP camera
- Tracer size updates in OnWillRenderObject instead of looping through all pooled bullets for each camera
- Stopped guard debug log entries unless DEBUG_LABELS is enabled
- Updated laser damage (Yski)
- Guard will use long-range turrets for distant targets if no missiles available (Yski)

= Fixes =
- Fixed missing references in AIPilot causing loss of control when loading AI on standby
- Fixed incorrect calculation with CheckMiss() that caused weapons to detonate prematurely
- Fixed CheckMiss to only check no-target during post-thrust as a miss on AAM and not AGM or others
- Fixed miss not being counted in certain situations
- Fixed guard attempting to use an inactive TGP
- Fixed anti-radiation missile behavior when fired without lock, or lost lock
- Fixed TGP turret-slaving not working on non-active vessel
- Fixed turret slaving breaking when both TGP and Radar are enabled
- Fixed clicking on gui triggering a cannon reload
- Fixed turret jitter when slaved
- Fixed ABL reticle when slaved
- Fixed ABL's rendered line and physical hit point when slaved
- Max guard visual range value is read from config file (Yski)
- Removed 8km limit for PooledBullet (Yski)
- Max bullet range is read from config file (Yski)


v0.9.5
= New =
- GPS Coordinate lists are now persistent
- Enabled activating multiple jammers with diminishing returns for each additional jammer
- Added more stack nodes to adjustable rail
- Added configurable lock-on after launch ability for radar missiles (activation of this mode is not yet implemented though)
- Above feature also allows radar missiles which have lost surrogate radar lock to continue to predicted impact point and automatically attempt active re-lock (currently used on AMRAAM)

= Changes =
- Added variations on jamming contact's detected bearing on jammed radar
- ECM functions have been separated into configurable traits (rcs reduction, range/bearing jamming, lock-breaking)
- Made radar missile's active radar signal strength threshold configurable
- Missiles will detonate some time after they have missed
- Changed explosion damage implementation again (much better this time)
- TGP, turrets/guns, and radar will disable if vessel is not controllable

= Fixes =
- Fixed persistence of TGP locked coordinates
- Fixed jammers occasionally shutting down despite sufficient electric charge
- Vessel's jamming status is updated if parts are broken off or destroyed
- Weapon manager's module and weapon list is updated if parts are broken off or destroyed
- Fixed (harmless) debug errors when launching rockets
- Fixed rocket appearing in front of rocket launcher for one frame after launch
- Fixed possible NRE spam from ModuleWeapon after vessel loading

v0.9.4
= New =
- Stack nodes for missiles/rockets/pods
- Stack node for AdjustableRail
- Adjustable rail will update the position of attached objects when height is adjusted (no more reattaching)

= Fixes =
- Fixed guard turrets not aiming/firing when 'visually' acquiring a target
- Fixed missile not receiving target data from weapon manager if fired via right-click menu or action group
- Fixed missiles being removed from guard's target database
- Fixed guards not engaging missiles with new targeting system

v0.9.3
= New =
- With new targeting, guard range is instead visual range (acquire targets without sensors), limited to 3.5km
- Guard's visual scanning is a separate subroutine than the scan intervals defined by the slider (which is now just firing intervals)
- Guards can still discover and acquire targets beyond that distance by using radar or other sensors
- Guards can use Radar and TGP for turrets
- Guard's can use GPS, Laser, and Anti-radiation missiles
- Guards/AI now fire appropriate countermeasures and evade radar (via RWR) and heatseeking missiles (via visual detection)
- Guards fire both chaff and flare when a missile launch of unknown type is detected
- Guards will automatically enable radar or TGP if necessary

= Changes =
- Changed explosion damage to a new system of firing many rays in random directions using heat damage - more consistent on high-velocity impacts (may need balance tweaks)
- Anti-radiation missiles now only lock onto SAM or Detection type radars
- Bombs with any type of guidance now have the larger reticle (not just GPS)
- Improved JDAM steering
- Changed size of jammed radar ping
- Slightly increased TWR Radar scan sensitivity
- Increased missile detection for radars
- Tweaks to certain missiles' steering and aero (tweaks will continue in the future)
- Tweaked chaff effectiveness

= Fixes =
- Radar scan threshold now uses the proper configured value
- Radar-detected vessels are no longer reported to both team's target database
- Fixed debris showing up as enemy targets on radar
- Fixed some inconsistent use of TargetInfo
- Fixed rockets spawning in front of rocket pod instead of inside it


v0.9.2
= Changes =
- Adjusted TGP reticle sizes again
- Added reticle for where TGP is pointing when not ground stabilized

= Fixes =
- Fixed legacy targeting on GPS guided weapons
- Fixed errors in settings menu when not in-flight
- Fixed turrets not being able to fire if pitch or yaw range are locked to 0
- Fixed ABL firing through own vessel
- Returned 'toggle' action group for guns

v0.9.1
= New =
- Added ability to name and rename GPS coordinates (list is not yet persistant)

= Changes =
- Laser guided missile lock HUD icon slightly larger so it appears against the circular TGP HUD reticle

= Fixes =
- Fixed AIM-120 and PAC-3 aero and steering values
- Re-enabled legacy targeting for guards when legacy targeting is enabled in settings
- Fixed guard's use of turrets
- Fixed errors when getting pinged by Large Detection Radar on RWR


v0.9.0
= New =
- Custom BDArmory parts tab in editor
- BDArmory-specific volume sliders in options menu
- Take-off speed variable added to AI Pilot
- ModuleWeapon (replaced gun/cannon/laser functions from BahaTurret)
	- Can be used without turret to simplify unity setup/part config of fixed guns
	- Uses pooled bullets and ejected shells
	- Improved muzzle flashes
	- Center-weighted bullet spread, specified by max angle in degrees (instead of previous 'accuracy' number)
- ModuleTurret (generic turret that can be used in conjunction with other modules in the future)
	- Simplified intuitive unity setup
	- Independent yaw and pitch rotation speeds in degrees per second (instead of previous, inconsistent 'degrees per frame')
	- Precise, instantaneous aiming, or smooth aiming, or anything in between
- New tracer texture
- Optional "shortName" for weapons
